(************** Content-type: application/mathematica **************
                     CreatedBy='Mathematica 5.0'

                    Mathematica-Compatible Notebook

This notebook can be used with any Mathematica-compatible
application, such as Mathematica, MathReader or Publicon. The data
for the notebook starts with the line containing stars above.

To get the notebook into a Mathematica-compatible application, do
one of the following:

* Save the data starting with the line of stars above into a file
  with a name ending in .nb, then open the file inside the
  application;

* Copy the data starting with the line of stars above to the
  clipboard, then use the Paste menu command inside the application.

Data for notebooks contains only printable 7-bit ASCII and can be
sent directly in email or through ftp in text mode.  Newlines can be
CR, LF or CRLF (Unix, Macintosh or MS-DOS style).

NOTE: If you modify the data for this notebook not in a Mathematica-
compatible application, you must delete the line below containing
the word CacheID, otherwise Mathematica-compatible applications may
try to use invalid cache data.

For more information on notebooks and Mathematica-compatible 
applications, contact Wolfram Research:
  web: http://www.wolfram.com
  email: info@wolfram.com
  phone: +1-217-398-0700 (U.S.)

Notebook reader applications are available free of charge from 
Wolfram Research.
*******************************************************************)

(*CacheID: 232*)


(*NotebookFileLineBreakTest
NotebookFileLineBreakTest*)
(*NotebookOptionsPosition[     94072,       1921]*)
(*NotebookOutlinePosition[     96559,       1986]*)
(*  CellTagsIndexPosition[     96448,       1979]*)
(*WindowFrame->Normal*)



Notebook[{

Cell[CellGroupData[{
Cell["DeleteEdges", "ObjectName",
  CellTags->{"b:3", "LocalInteractions:10"}],

Cell[TextData[{
  "\[FilledSmallSquare] DeleteEdges[ ",
  StyleBox["model, ",
    FontSlant->"Italic"],
  "All ",
  "] removes all edges from ",
  StyleBox["model",
    FontSlant->"Italic"],
  "."
}], "Usage",
  CellTags->{"b:3", "LocalInteractions:10"}],

Cell[CellGroupData[{

Cell["Example", "ExampleSection",
  CellTags->{"b:3", "LocalInteractions:10"}],

Cell[CellGroupData[{

Cell[BoxData[{
    \(\(m = LocalInteractionModel[];\)\), "\[IndentingNewLine]", 
    \(\(ShowGraph[m];\)\)}], "Input",
  CellLabel->"In[7]:=",
  CellTags->{"b:3", "LocalInteractions:10"}],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: 1 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.0454545 0.909091 0.0454545 0.909091 [
[ 0 0 0 0 ]
[ 1 1 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 0 m
1 0 L
1 1 L
0 1 L
closepath
clip
newpath
0 0 0 r
.005 w
[ ] 0 setdash
.04545 .04545 m
.14646 .04545 L
s
.04545 .04545 m
.04545 .14646 L
s
.14646 .04545 m
.24747 .04545 L
s
.14646 .04545 m
.14646 .14646 L
s
.24747 .04545 m
.34848 .04545 L
s
.24747 .04545 m
.24747 .14646 L
s
.34848 .04545 m
.44949 .04545 L
s
.34848 .04545 m
.34848 .14646 L
s
.44949 .04545 m
.55051 .04545 L
s
.44949 .04545 m
.44949 .14646 L
s
.55051 .04545 m
.65152 .04545 L
s
.55051 .04545 m
.55051 .14646 L
s
.65152 .04545 m
.75253 .04545 L
s
.65152 .04545 m
.65152 .14646 L
s
.75253 .04545 m
.85354 .04545 L
s
.75253 .04545 m
.75253 .14646 L
s
.85354 .04545 m
.95455 .04545 L
s
.85354 .04545 m
.85354 .14646 L
s
.95455 .04545 m
.95455 .14646 L
s
.04545 .14646 m
.14646 .14646 L
s
.04545 .14646 m
.04545 .24747 L
s
.14646 .14646 m
.24747 .14646 L
s
.14646 .14646 m
.14646 .24747 L
s
.24747 .14646 m
.34848 .14646 L
s
.24747 .14646 m
.24747 .24747 L
s
.34848 .14646 m
.44949 .14646 L
s
.34848 .14646 m
.34848 .24747 L
s
.44949 .14646 m
.55051 .14646 L
s
.44949 .14646 m
.44949 .24747 L
s
.55051 .14646 m
.65152 .14646 L
s
.55051 .14646 m
.55051 .24747 L
s
.65152 .14646 m
.75253 .14646 L
s
.65152 .14646 m
.65152 .24747 L
s
.75253 .14646 m
.85354 .14646 L
s
.75253 .14646 m
.75253 .24747 L
s
.85354 .14646 m
.95455 .14646 L
s
.85354 .14646 m
.85354 .24747 L
s
.95455 .14646 m
.95455 .24747 L
s
.04545 .24747 m
.14646 .24747 L
s
.04545 .24747 m
.04545 .34848 L
s
.14646 .24747 m
.24747 .24747 L
s
.14646 .24747 m
.14646 .34848 L
s
.24747 .24747 m
.34848 .24747 L
s
.24747 .24747 m
.24747 .34848 L
s
.34848 .24747 m
.44949 .24747 L
s
.34848 .24747 m
.34848 .34848 L
s
.44949 .24747 m
.55051 .24747 L
s
.44949 .24747 m
.44949 .34848 L
s
.55051 .24747 m
.65152 .24747 L
s
.55051 .24747 m
.55051 .34848 L
s
.65152 .24747 m
.75253 .24747 L
s
.65152 .24747 m
.65152 .34848 L
s
.75253 .24747 m
.85354 .24747 L
s
.75253 .24747 m
.75253 .34848 L
s
.85354 .24747 m
.95455 .24747 L
s
.85354 .24747 m
.85354 .34848 L
s
.95455 .24747 m
.95455 .34848 L
s
.04545 .34848 m
.14646 .34848 L
s
.04545 .34848 m
.04545 .44949 L
s
.14646 .34848 m
.24747 .34848 L
s
.14646 .34848 m
.14646 .44949 L
s
.24747 .34848 m
.34848 .34848 L
s
.24747 .34848 m
.24747 .44949 L
s
.34848 .34848 m
.44949 .34848 L
s
.34848 .34848 m
.34848 .44949 L
s
.44949 .34848 m
.55051 .34848 L
s
.44949 .34848 m
.44949 .44949 L
s
.55051 .34848 m
.65152 .34848 L
s
.55051 .34848 m
.55051 .44949 L
s
.65152 .34848 m
.75253 .34848 L
s
.65152 .34848 m
.65152 .44949 L
s
.75253 .34848 m
.85354 .34848 L
s
.75253 .34848 m
.75253 .44949 L
s
.85354 .34848 m
.95455 .34848 L
s
.85354 .34848 m
.85354 .44949 L
s
.95455 .34848 m
.95455 .44949 L
s
.04545 .44949 m
.14646 .44949 L
s
.04545 .44949 m
.04545 .55051 L
s
.14646 .44949 m
.24747 .44949 L
s
.14646 .44949 m
.14646 .55051 L
s
.24747 .44949 m
.34848 .44949 L
s
.24747 .44949 m
.24747 .55051 L
s
.34848 .44949 m
.44949 .44949 L
s
.34848 .44949 m
.34848 .55051 L
s
.44949 .44949 m
.55051 .44949 L
s
.44949 .44949 m
.44949 .55051 L
s
.55051 .44949 m
.65152 .44949 L
s
.55051 .44949 m
.55051 .55051 L
s
.65152 .44949 m
.75253 .44949 L
s
.65152 .44949 m
.65152 .55051 L
s
.75253 .44949 m
.85354 .44949 L
s
.75253 .44949 m
.75253 .55051 L
s
.85354 .44949 m
.95455 .44949 L
s
.85354 .44949 m
.85354 .55051 L
s
.95455 .44949 m
.95455 .55051 L
s
.04545 .55051 m
.14646 .55051 L
s
.04545 .55051 m
.04545 .65152 L
s
.14646 .55051 m
.24747 .55051 L
s
.14646 .55051 m
.14646 .65152 L
s
.24747 .55051 m
.34848 .55051 L
s
.24747 .55051 m
.24747 .65152 L
s
.34848 .55051 m
.44949 .55051 L
s
.34848 .55051 m
.34848 .65152 L
s
.44949 .55051 m
.55051 .55051 L
s
.44949 .55051 m
.44949 .65152 L
s
.55051 .55051 m
.65152 .55051 L
s
.55051 .55051 m
.55051 .65152 L
s
.65152 .55051 m
.75253 .55051 L
s
.65152 .55051 m
.65152 .65152 L
s
.75253 .55051 m
.85354 .55051 L
s
.75253 .55051 m
.75253 .65152 L
s
.85354 .55051 m
.95455 .55051 L
s
.85354 .55051 m
.85354 .65152 L
s
.95455 .55051 m
.95455 .65152 L
s
.04545 .65152 m
.14646 .65152 L
s
.04545 .65152 m
.04545 .75253 L
s
.14646 .65152 m
.24747 .65152 L
s
.14646 .65152 m
.14646 .75253 L
s
.24747 .65152 m
.34848 .65152 L
s
.24747 .65152 m
.24747 .75253 L
s
.34848 .65152 m
.44949 .65152 L
s
.34848 .65152 m
.34848 .75253 L
s
.44949 .65152 m
.55051 .65152 L
s
.44949 .65152 m
.44949 .75253 L
s
.55051 .65152 m
.65152 .65152 L
s
.55051 .65152 m
.55051 .75253 L
s
.65152 .65152 m
.75253 .65152 L
s
.65152 .65152 m
.65152 .75253 L
s
.75253 .65152 m
.85354 .65152 L
s
.75253 .65152 m
.75253 .75253 L
s
.85354 .65152 m
.95455 .65152 L
s
.85354 .65152 m
.85354 .75253 L
s
.95455 .65152 m
.95455 .75253 L
s
.04545 .75253 m
.14646 .75253 L
s
.04545 .75253 m
.04545 .85354 L
s
.14646 .75253 m
.24747 .75253 L
s
.14646 .75253 m
.14646 .85354 L
s
.24747 .75253 m
.34848 .75253 L
s
.24747 .75253 m
.24747 .85354 L
s
.34848 .75253 m
.44949 .75253 L
s
.34848 .75253 m
.34848 .85354 L
s
.44949 .75253 m
.55051 .75253 L
s
.44949 .75253 m
.44949 .85354 L
s
.55051 .75253 m
.65152 .75253 L
s
.55051 .75253 m
.55051 .85354 L
s
.65152 .75253 m
.75253 .75253 L
s
.65152 .75253 m
.65152 .85354 L
s
.75253 .75253 m
.85354 .75253 L
s
.75253 .75253 m
.75253 .85354 L
s
.85354 .75253 m
.95455 .75253 L
s
.85354 .75253 m
.85354 .85354 L
s
.95455 .75253 m
.95455 .85354 L
s
.04545 .85354 m
.14646 .85354 L
s
.04545 .85354 m
.04545 .95455 L
s
.14646 .85354 m
.24747 .85354 L
s
.14646 .85354 m
.14646 .95455 L
s
.24747 .85354 m
.34848 .85354 L
s
.24747 .85354 m
.24747 .95455 L
s
.34848 .85354 m
.44949 .85354 L
s
.34848 .85354 m
.34848 .95455 L
s
.44949 .85354 m
.55051 .85354 L
s
.44949 .85354 m
.44949 .95455 L
s
.55051 .85354 m
.65152 .85354 L
s
.55051 .85354 m
.55051 .95455 L
s
.65152 .85354 m
.75253 .85354 L
s
.65152 .85354 m
.65152 .95455 L
s
.75253 .85354 m
.85354 .85354 L
s
.75253 .85354 m
.75253 .95455 L
s
.85354 .85354 m
.95455 .85354 L
s
.85354 .85354 m
.85354 .95455 L
s
.95455 .85354 m
.95455 .95455 L
s
.04545 .95455 m
.14646 .95455 L
s
.14646 .95455 m
.24747 .95455 L
s
.24747 .95455 m
.34848 .95455 L
s
.34848 .95455 m
.44949 .95455 L
s
.44949 .95455 m
.55051 .95455 L
s
.55051 .95455 m
.65152 .95455 L
s
.65152 .95455 m
.75253 .95455 L
s
.75253 .95455 m
.85354 .95455 L
s
.85354 .95455 m
.95455 .95455 L
s
1 0 0 r
.025 w
.04545 .04545 Mdot
.14646 .04545 Mdot
.24747 .04545 Mdot
.34848 .04545 Mdot
.44949 .04545 Mdot
.55051 .04545 Mdot
.65152 .04545 Mdot
.75253 .04545 Mdot
.85354 .04545 Mdot
.95455 .04545 Mdot
.04545 .14646 Mdot
.14646 .14646 Mdot
.24747 .14646 Mdot
.34848 .14646 Mdot
.44949 .14646 Mdot
.55051 .14646 Mdot
.65152 .14646 Mdot
.75253 .14646 Mdot
.85354 .14646 Mdot
.95455 .14646 Mdot
.04545 .24747 Mdot
.14646 .24747 Mdot
.24747 .24747 Mdot
.34848 .24747 Mdot
.44949 .24747 Mdot
.55051 .24747 Mdot
.65152 .24747 Mdot
.75253 .24747 Mdot
.85354 .24747 Mdot
.95455 .24747 Mdot
.04545 .34848 Mdot
.14646 .34848 Mdot
.24747 .34848 Mdot
.34848 .34848 Mdot
.44949 .34848 Mdot
.55051 .34848 Mdot
.65152 .34848 Mdot
.75253 .34848 Mdot
.85354 .34848 Mdot
.95455 .34848 Mdot
.04545 .44949 Mdot
.14646 .44949 Mdot
.24747 .44949 Mdot
.34848 .44949 Mdot
.44949 .44949 Mdot
.55051 .44949 Mdot
.65152 .44949 Mdot
.75253 .44949 Mdot
.85354 .44949 Mdot
.95455 .44949 Mdot
.04545 .55051 Mdot
.14646 .55051 Mdot
.24747 .55051 Mdot
.34848 .55051 Mdot
.44949 .55051 Mdot
.55051 .55051 Mdot
.65152 .55051 Mdot
.75253 .55051 Mdot
.85354 .55051 Mdot
.95455 .55051 Mdot
.04545 .65152 Mdot
.14646 .65152 Mdot
.24747 .65152 Mdot
.34848 .65152 Mdot
.44949 .65152 Mdot
.55051 .65152 Mdot
.65152 .65152 Mdot
.75253 .65152 Mdot
.85354 .65152 Mdot
.95455 .65152 Mdot
.04545 .75253 Mdot
.14646 .75253 Mdot
.24747 .75253 Mdot
.34848 .75253 Mdot
.44949 .75253 Mdot
.55051 .75253 Mdot
.65152 .75253 Mdot
.75253 .75253 Mdot
.85354 .75253 Mdot
.95455 .75253 Mdot
.04545 .85354 Mdot
.14646 .85354 Mdot
.24747 .85354 Mdot
.34848 .85354 Mdot
.44949 .85354 Mdot
.55051 .85354 Mdot
.65152 .85354 Mdot
.75253 .85354 Mdot
.85354 .85354 Mdot
.95455 .85354 Mdot
.04545 .95455 Mdot
.14646 .95455 Mdot
.24747 .95455 Mdot
.34848 .95455 Mdot
.44949 .95455 Mdot
.55051 .95455 Mdot
.65152 .95455 Mdot
.75253 .95455 Mdot
.85354 .95455 Mdot
.95455 .95455 Mdot
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  CellLabel->"From In[7]:=",
  ImageSize->{288, 288},
  ImageMargins->{{0, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40004P000182000`400?l00000o`00003ooooooolQ
ooooo`00oooooolQooooo`00oooooolQooooo`00oooooolQooooo`00oooooolQooooo`00oooooolQ
ooooo`00oooooolQooooo`00oooooolQooooo`00oooooolQooooo`00oooooolQooooo`00oooooolQ
ooooo`002oooool3ool001[ooooo0ooo000Jooooo`?oo`006_ooool3ool001[ooooo0ooo000Joooo
o`?oo`006_ooool3ool001[ooooo0ooo000Jooooo`?oo`006_ooool3ool000gooooo000:ooooo`Go
o`006?ooool5ool001Sooooo1Ooo000Hooooo`Goo`006?ooool5ool001Sooooo1Ooo000Hooooo`Go
o`006?ooool5ool001Sooooo1Ooo000Hooooo`Goo`003?ooool000Wooooo1ooo000Fooooo`Ooo`00
5_ooool7ool001Kooooo1ooo000Fooooo`Ooo`005_ooool7ool001Kooooo1ooo000Fooooo`Ooo`00
5_ooool7ool001Kooooo1ooo000;ooooo`002Oooool7ool001Ko00001ooo000Fo`0000Ooo`005_l0
0007ool001Ko00001ooo000Fo`0000Ooo`005_l00007ool001Ko00001ooo000Fo`0000Ooo`005_l0
0007ool000_ooooo0009ooooo`Ooo`005_ooool7ool001Kooooo1ooo000Fooooo`Ooo`005_ooool7
ool001Kooooo1ooo000Fooooo`Ooo`005_ooool7ool001Kooooo1ooo000Fooooo`Ooo`002oooool0
00[ooooo1Ooo000Hooooo`Goo`006?ooool5ool001Sooooo1Ooo000Hooooo`Goo`006?ooool5ool0
01Sooooo1Ooo000Hooooo`Goo`006?ooool5ool001Sooooo1Ooo000<ooooo`002oooool3ool001[o
oooo0ooo000Jooooo`?oo`006_ooool3ool001[ooooo0ooo000Jooooo`?oo`006_ooool3ool001[o
oooo0ooo000Jooooo`?oo`006_ooool3ool000gooooo000=ooooo`03o`000?oooooooooo01[ooooo
00?o0000ooooooooool06_ooool00ol0003oooooooooo`0Jooooo`03o`000?oooooooooo01[ooooo
00?o0000ooooooooool06Oooool00ol0003oooooooooo`0Jooooo`03o`000?oooooooooo01[ooooo
00?o0000ooooooooool06_ooool00ol0003oooooooooo`0Jooooo`03o`000?oooooooooo00cooooo
000=ooooo`03o`000?oooooooooo01[ooooo00?o0000ooooooooool06_ooool00ol0003ooooooooo
o`0Jooooo`03o`000?oooooooooo01[ooooo00?o0000ooooooooool06Oooool00ol0003ooooooooo
o`0Jooooo`03o`000?oooooooooo01[ooooo00?o0000ooooooooool06_ooool00ol0003ooooooooo
o`0Jooooo`03o`000?oooooooooo00cooooo000=ooooo`03o`000?oooooooooo01[ooooo00?o0000
ooooooooool06_ooool00ol0003oooooooooo`0Jooooo`03o`000?oooooooooo01[ooooo00?o0000
ooooooooool06Oooool00ol0003oooooooooo`0Jooooo`03o`000?oooooooooo01[ooooo00?o0000
ooooooooool06_ooool00ol0003oooooooooo`0Jooooo`03o`000?oooooooooo00cooooo000=oooo
o`03o`000?oooooooooo01[ooooo00?o0000ooooooooool06_ooool00ol0003oooooooooo`0Joooo
o`03o`000?oooooooooo01[ooooo00?o0000ooooooooool06Oooool00ol0003oooooooooo`0Joooo
o`03o`000?oooooooooo01[ooooo00?o0000ooooooooool06_ooool00ol0003oooooooooo`0Joooo
o`03o`000?oooooooooo00cooooo000=ooooo`03o`000?oooooooooo01[ooooo00?o0000oooooooo
ool06_ooool00ol0003oooooooooo`0Jooooo`03o`000?oooooooooo01[ooooo00?o0000oooooooo
ool06Oooool00ol0003oooooooooo`0Jooooo`03o`000?oooooooooo01[ooooo00?o0000oooooooo
ool06_ooool00ol0003oooooooooo`0Jooooo`03o`000?oooooooooo00cooooo000=ooooo`03o`00
0?oooooooooo01[ooooo00?o0000ooooooooool06_ooool00ol0003oooooooooo`0Jooooo`03o`00
0?oooooooooo01[ooooo00?o0000ooooooooool06Oooool00ol0003oooooooooo`0Jooooo`03o`00
0?oooooooooo01[ooooo00?o0000ooooooooool06_ooool00ol0003oooooooooo`0Jooooo`03o`00
0?oooooooooo00cooooo000=ooooo`03o`000?oooooooooo01[ooooo00?o0000ooooooooool06_oo
ool00ol0003oooooooooo`0Jooooo`03o`000?oooooooooo01[ooooo00?o0000ooooooooool06Ooo
ool00ol0003oooooooooo`0Jooooo`03o`000?oooooooooo01[ooooo00?o0000ooooooooool06_oo
ool00ol0003oooooooooo`0Jooooo`03o`000?oooooooooo00cooooo000=ooooo`03o`000?oooooo
oooo01[ooooo00?o0000ooooooooool06_ooool00ol0003oooooooooo`0Jooooo`03o`000?oooooo
oooo01[ooooo00?o0000ooooooooool06Oooool00ol0003oooooooooo`0Jooooo`03o`000?oooooo
oooo01[ooooo00?o0000ooooooooool06_ooool00ol0003oooooooooo`0Jooooo`03o`000?oooooo
oooo00cooooo000=ooooo`03o`000?oooooooooo01[ooooo00?o0000ooooooooool06_ooool00ol0
003oooooooooo`0Jooooo`03o`000?oooooooooo01[ooooo00?o0000ooooooooool06Oooool00ol0
003oooooooooo`0Jooooo`03o`000?oooooooooo01[ooooo00?o0000ooooooooool06_ooool00ol0
003oooooooooo`0Jooooo`03o`000?oooooooooo00cooooo000=ooooo`03o`000?oooooooooo01[o
oooo00?o0000ooooooooool06_ooool00ol0003oooooooooo`0Jooooo`03o`000?oooooooooo01[o
oooo00?o0000ooooooooool06Oooool00ol0003oooooooooo`0Jooooo`03o`000?oooooooooo01[o
oooo00?o0000ooooooooool06_ooool00ol0003oooooooooo`0Jooooo`03o`000?oooooooooo00co
oooo000=ooooo`03o`000?oooooooooo01[ooooo00?o0000ooooooooool06_ooool00ol0003ooooo
ooooo`0Jooooo`03o`000?oooooooooo01[ooooo00?o0000ooooooooool06Oooool00ol0003ooooo
ooooo`0Jooooo`03o`000?oooooooooo01[ooooo00?o0000ooooooooool06_ooool00ol0003ooooo
ooooo`0Jooooo`03o`000?oooooooooo00cooooo000=ooooo`03o`000?oooooooooo01[ooooo00?o
0000ooooooooool06_ooool00ol0003oooooooooo`0Jooooo`03o`000?oooooooooo01[ooooo00?o
0000ooooooooool06Oooool00ol0003oooooooooo`0Jooooo`03o`000?oooooooooo01[ooooo00?o
0000ooooooooool06_ooool00ol0003oooooooooo`0Jooooo`03o`000?oooooooooo00cooooo000=
ooooo`03o`000?oooooooooo01[ooooo00?o0000ooooooooool06_ooool00ol0003oooooooooo`0J
ooooo`03o`000?oooooooooo01[ooooo00?o0000ooooooooool06Oooool00ol0003oooooooooo`0J
ooooo`03o`000?oooooooooo01[ooooo00?o0000ooooooooool06_ooool00ol0003oooooooooo`0J
ooooo`03o`000?oooooooooo00cooooo000=ooooo`03o`000?oooooooooo01[ooooo00?o0000oooo
ooooool06_ooool00ol0003oooooooooo`0Jooooo`03o`000?oooooooooo01[ooooo00?o0000oooo
ooooool06Oooool00ol0003oooooooooo`0Jooooo`03o`000?oooooooooo01[ooooo00?o0000oooo
ooooool06_ooool00ol0003oooooooooo`0Jooooo`03o`000?oooooooooo00cooooo000=ooooo`03
o`000?oooooooooo01[ooooo00?o0000ooooooooool06_ooool00ol0003oooooooooo`0Jooooo`03
o`000?oooooooooo01[ooooo00?o0000ooooooooool06Oooool00ol0003oooooooooo`0Jooooo`03
o`000?oooooooooo01[ooooo00?o0000ooooooooool06_ooool00ol0003oooooooooo`0Jooooo`03
o`000?oooooooooo00cooooo000=ooooo`03o`000?oooooooooo01[ooooo00?o0000ooooooooool0
6_ooool00ol0003oooooooooo`0Jooooo`03o`000?oooooooooo01[ooooo00?o0000ooooooooool0
6Oooool00ol0003oooooooooo`0Jooooo`03o`000?oooooooooo01[ooooo00?o0000ooooooooool0
6_ooool00ol0003oooooooooo`0Jooooo`03o`000?oooooooooo00cooooo000=ooooo`03o`000?oo
oooooooo01[ooooo00?o0000ooooooooool06_ooool00ol0003oooooooooo`0Jooooo`03o`000?oo
oooooooo01[ooooo00?o0000ooooooooool06Oooool00ol0003oooooooooo`0Jooooo`03o`000?oo
oooooooo01[ooooo00?o0000ooooooooool06_ooool00ol0003oooooooooo`0Jooooo`03o`000?oo
oooooooo00cooooo000=ooooo`03o`000?oooooooooo01[ooooo00?o0000ooooooooool06_ooool0
0ol0003oooooooooo`0Jooooo`03o`000?oooooooooo01[ooooo00?o0000ooooooooool06Oooool0
0ol0003oooooooooo`0Jooooo`03o`000?oooooooooo01[ooooo00?o0000ooooooooool06_ooool0
0ol0003oooooooooo`0Jooooo`03o`000?oooooooooo00cooooo000=ooooo`03o`000?oooooooooo
01[ooooo00?o0000ooooooooool06_ooool00ol0003oooooooooo`0Jooooo`03o`000?oooooooooo
01[ooooo00?o0000ooooooooool06Oooool00ol0003oooooooooo`0Jooooo`03o`000?oooooooooo
01[ooooo00?o0000ooooooooool06_ooool00ol0003oooooooooo`0Jooooo`03o`000?oooooooooo
00cooooo000=ooooo`03o`000?oooooooooo01[ooooo00?o0000ooooooooool06_ooool00ol0003o
ooooooooo`0Jooooo`03o`000?oooooooooo01[ooooo00?o0000ooooooooool06Oooool00ol0003o
ooooooooo`0Jooooo`03o`000?oooooooooo01[ooooo00?o0000ooooooooool06_ooool00ol0003o
ooooooooo`0Jooooo`03o`000?oooooooooo00cooooo000=ooooo`03o`000?oooooooooo01[ooooo
00?o0000ooooooooool06_ooool00ol0003oooooooooo`0Jooooo`03o`000?oooooooooo01[ooooo
00?o0000ooooooooool06Oooool00ol0003oooooooooo`0Jooooo`03o`000?oooooooooo01[ooooo
00?o0000ooooooooool06_ooool00ol0003oooooooooo`0Jooooo`03o`000?oooooooooo00cooooo
000=ooooo`03o`000?oooooooooo01[ooooo00?o0000ooooooooool06_ooool00ol0003ooooooooo
o`0Jooooo`03o`000?oooooooooo01[ooooo00?o0000ooooooooool06Oooool00ol0003ooooooooo
o`0Jooooo`03o`000?oooooooooo01[ooooo00?o0000ooooooooool06_ooool00ol0003ooooooooo
o`0Jooooo`03o`000?oooooooooo00cooooo000;ooooo`?oo`006_ooool3ool001[ooooo0ooo000J
ooooo`?oo`006_ooool3ool001[ooooo0ooo000Jooooo`?oo`006_ooool3ool001[ooooo0ooo000J
ooooo`?oo`003Oooool000[ooooo1Ooo000Hooooo`Goo`006?ooool5ool001Sooooo1Ooo000Hoooo
o`Goo`006?ooool5ool001Sooooo1Ooo000Hooooo`Goo`006?ooool5ool001Sooooo1Ooo000<oooo
o`002Oooool7ool001Kooooo1ooo000Fooooo`Ooo`005_ooool7ool001Kooooo1ooo000Fooooo`Oo
o`005_ooool7ool001Kooooo1ooo000Fooooo`Ooo`005_ooool7ool000_ooooo0009ooooo`Ooo`00
5_l00007ool001Ko00001ooo000Fo`0000Ooo`005_l00007ool001Ko00001ooo000Fo`0000Ooo`00
5_l00007ool001Ko00001ooo000Fo`0000Ooo`002oooool000Wooooo1ooo000Fooooo`Ooo`005_oo
ool7ool001Kooooo1ooo000Fooooo`Ooo`005_ooool7ool001Kooooo1ooo000Fooooo`Ooo`005_oo
ool7ool001Kooooo1ooo000;ooooo`002_ooool5ool001Sooooo1Ooo000Hooooo`Goo`006?ooool5
ool001Sooooo1Ooo000Hooooo`Goo`006?ooool5ool001Sooooo1Ooo000Hooooo`Goo`006?ooool5
ool000cooooo000;ooooo`?oo`006_ooool3ool001[ooooo0ooo000Jooooo`?oo`006_ooool3ool0
01[ooooo0ooo000Jooooo`?oo`006_ooool3ool001[ooooo0ooo000Jooooo`?oo`003Oooool000go
oooo00?o0000ooooooooool06_ooool00ol0003oooooooooo`0Jooooo`03o`000?oooooooooo01[o
oooo00?o0000ooooooooool06_ooool00ol0003oooooooooo`0Iooooo`03o`000?oooooooooo01[o
oooo00?o0000ooooooooool06_ooool00ol0003oooooooooo`0Jooooo`03o`000?oooooooooo01[o
oooo00?o0000ooooooooool03?ooool000gooooo00?o0000ooooooooool06_ooool00ol0003ooooo
ooooo`0Jooooo`03o`000?oooooooooo01[ooooo00?o0000ooooooooool06_ooool00ol0003ooooo
ooooo`0Iooooo`03o`000?oooooooooo01[ooooo00?o0000ooooooooool06_ooool00ol0003ooooo
ooooo`0Jooooo`03o`000?oooooooooo01[ooooo00?o0000ooooooooool03?ooool000gooooo00?o
0000ooooooooool06_ooool00ol0003oooooooooo`0Jooooo`03o`000?oooooooooo01[ooooo00?o
0000ooooooooool06_ooool00ol0003oooooooooo`0Iooooo`03o`000?oooooooooo01[ooooo00?o
0000ooooooooool06_ooool00ol0003oooooooooo`0Jooooo`03o`000?oooooooooo01[ooooo00?o
0000ooooooooool03?ooool000gooooo00?o0000ooooooooool06_ooool00ol0003oooooooooo`0J
ooooo`03o`000?oooooooooo01[ooooo00?o0000ooooooooool06_ooool00ol0003oooooooooo`0I
ooooo`03o`000?oooooooooo01[ooooo00?o0000ooooooooool06_ooool00ol0003oooooooooo`0J
ooooo`03o`000?oooooooooo01[ooooo00?o0000ooooooooool03?ooool000gooooo00?o0000oooo
ooooool06_ooool00ol0003oooooooooo`0Jooooo`03o`000?oooooooooo01[ooooo00?o0000oooo
ooooool06_ooool00ol0003oooooooooo`0Iooooo`03o`000?oooooooooo01[ooooo00?o0000oooo
ooooool06_ooool00ol0003oooooooooo`0Jooooo`03o`000?oooooooooo01[ooooo00?o0000oooo
ooooool03?ooool000gooooo00?o0000ooooooooool06_ooool00ol0003oooooooooo`0Jooooo`03
o`000?oooooooooo01[ooooo00?o0000ooooooooool06_ooool00ol0003oooooooooo`0Iooooo`03
o`000?oooooooooo01[ooooo00?o0000ooooooooool06_ooool00ol0003oooooooooo`0Jooooo`03
o`000?oooooooooo01[ooooo00?o0000ooooooooool03?ooool000gooooo00?o0000ooooooooool0
6_ooool00ol0003oooooooooo`0Jooooo`03o`000?oooooooooo01[ooooo00?o0000ooooooooool0
6_ooool00ol0003oooooooooo`0Iooooo`03o`000?oooooooooo01[ooooo00?o0000ooooooooool0
6_ooool00ol0003oooooooooo`0Jooooo`03o`000?oooooooooo01[ooooo00?o0000ooooooooool0
3?ooool000gooooo00?o0000ooooooooool06_ooool00ol0003oooooooooo`0Jooooo`03o`000?oo
oooooooo01[ooooo00?o0000ooooooooool06_ooool00ol0003oooooooooo`0Iooooo`03o`000?oo
oooooooo01[ooooo00?o0000ooooooooool06_ooool00ol0003oooooooooo`0Jooooo`03o`000?oo
oooooooo01[ooooo00?o0000ooooooooool03?ooool000gooooo00?o0000ooooooooool06_ooool0
0ol0003oooooooooo`0Jooooo`03o`000?oooooooooo01[ooooo00?o0000ooooooooool06_ooool0
0ol0003oooooooooo`0Iooooo`03o`000?oooooooooo01[ooooo00?o0000ooooooooool06_ooool0
0ol0003oooooooooo`0Jooooo`03o`000?oooooooooo01[ooooo00?o0000ooooooooool03?ooool0
00gooooo00?o0000ooooooooool06_ooool00ol0003oooooooooo`0Jooooo`03o`000?oooooooooo
01[ooooo00?o0000ooooooooool06_ooool00ol0003oooooooooo`0Iooooo`03o`000?oooooooooo
01[ooooo00?o0000ooooooooool06_ooool00ol0003oooooooooo`0Jooooo`03o`000?oooooooooo
01[ooooo00?o0000ooooooooool03?ooool000gooooo00?o0000ooooooooool06_ooool00ol0003o
ooooooooo`0Jooooo`03o`000?oooooooooo01[ooooo00?o0000ooooooooool06_ooool00ol0003o
ooooooooo`0Iooooo`03o`000?oooooooooo01[ooooo00?o0000ooooooooool06_ooool00ol0003o
ooooooooo`0Jooooo`03o`000?oooooooooo01[ooooo00?o0000ooooooooool03?ooool000gooooo
00?o0000ooooooooool06_ooool00ol0003oooooooooo`0Jooooo`03o`000?oooooooooo01[ooooo
00?o0000ooooooooool06_ooool00ol0003oooooooooo`0Iooooo`03o`000?oooooooooo01[ooooo
00?o0000ooooooooool06_ooool00ol0003oooooooooo`0Jooooo`03o`000?oooooooooo01[ooooo
00?o0000ooooooooool03?ooool000gooooo00?o0000ooooooooool06_ooool00ol0003ooooooooo
o`0Jooooo`03o`000?oooooooooo01[ooooo00?o0000ooooooooool06_ooool00ol0003ooooooooo
o`0Iooooo`03o`000?oooooooooo01[ooooo00?o0000ooooooooool06_ooool00ol0003ooooooooo
o`0Jooooo`03o`000?oooooooooo01[ooooo00?o0000ooooooooool03?ooool000gooooo00?o0000
ooooooooool06_ooool00ol0003oooooooooo`0Jooooo`03o`000?oooooooooo01[ooooo00?o0000
ooooooooool06_ooool00ol0003oooooooooo`0Iooooo`03o`000?oooooooooo01[ooooo00?o0000
ooooooooool06_ooool00ol0003oooooooooo`0Jooooo`03o`000?oooooooooo01[ooooo00?o0000
ooooooooool03?ooool000gooooo00?o0000ooooooooool06_ooool00ol0003oooooooooo`0Joooo
o`03o`000?oooooooooo01[ooooo00?o0000ooooooooool06_ooool00ol0003oooooooooo`0Ioooo
o`03o`000?oooooooooo01[ooooo00?o0000ooooooooool06_ooool00ol0003oooooooooo`0Joooo
o`03o`000?oooooooooo01[ooooo00?o0000ooooooooool03?ooool000gooooo00?o0000oooooooo
ool06_ooool00ol0003oooooooooo`0Jooooo`03o`000?oooooooooo01[ooooo00?o0000oooooooo
ool06_ooool00ol0003oooooooooo`0Iooooo`03o`000?oooooooooo01[ooooo00?o0000oooooooo
ool06_ooool00ol0003oooooooooo`0Jooooo`03o`000?oooooooooo01[ooooo00?o0000oooooooo
ool03?ooool000gooooo00?o0000ooooooooool06_ooool00ol0003oooooooooo`0Jooooo`03o`00
0?oooooooooo01[ooooo00?o0000ooooooooool06_ooool00ol0003oooooooooo`0Iooooo`03o`00
0?oooooooooo01[ooooo00?o0000ooooooooool06_ooool00ol0003oooooooooo`0Jooooo`03o`00
0?oooooooooo01[ooooo00?o0000ooooooooool03?ooool000gooooo00?o0000ooooooooool06_oo
ool00ol0003oooooooooo`0Jooooo`03o`000?oooooooooo01[ooooo00?o0000ooooooooool06_oo
ool00ol0003oooooooooo`0Iooooo`03o`000?oooooooooo01[ooooo00?o0000ooooooooool06_oo
ool00ol0003oooooooooo`0Jooooo`03o`000?oooooooooo01[ooooo00?o0000ooooooooool03?oo
ool000gooooo00?o0000ooooooooool06_ooool00ol0003oooooooooo`0Jooooo`03o`000?oooooo
oooo01[ooooo00?o0000ooooooooool06_ooool00ol0003oooooooooo`0Iooooo`03o`000?oooooo
oooo01[ooooo00?o0000ooooooooool06_ooool00ol0003oooooooooo`0Jooooo`03o`000?oooooo
oooo01[ooooo00?o0000ooooooooool03?ooool000gooooo00?o0000ooooooooool06_ooool00ol0
003oooooooooo`0Jooooo`03o`000?oooooooooo01[ooooo00?o0000ooooooooool06_ooool00ol0
003oooooooooo`0Iooooo`03o`000?oooooooooo01[ooooo00?o0000ooooooooool06_ooool00ol0
003oooooooooo`0Jooooo`03o`000?oooooooooo01[ooooo00?o0000ooooooooool03?ooool000go
oooo00?o0000ooooooooool06_ooool00ol0003oooooooooo`0Jooooo`03o`000?oooooooooo01[o
oooo00?o0000ooooooooool06_ooool00ol0003oooooooooo`0Iooooo`03o`000?oooooooooo01[o
oooo00?o0000ooooooooool06_ooool00ol0003oooooooooo`0Jooooo`03o`000?oooooooooo01[o
oooo00?o0000ooooooooool03?ooool000gooooo00?o0000ooooooooool06_ooool00ol0003ooooo
ooooo`0Jooooo`03o`000?oooooooooo01[ooooo00?o0000ooooooooool06_ooool00ol0003ooooo
ooooo`0Iooooo`03o`000?oooooooooo01[ooooo00?o0000ooooooooool06_ooool00ol0003ooooo
ooooo`0Jooooo`03o`000?oooooooooo01[ooooo00?o0000ooooooooool03?ooool000_ooooo0ooo
000Jooooo`?oo`006_ooool3ool001[ooooo0ooo000Jooooo`?oo`006_ooool3ool001[ooooo0ooo
000Jooooo`?oo`006_ooool3ool001[ooooo0ooo000=ooooo`002_ooool5ool001Sooooo1Ooo000H
ooooo`Goo`006?ooool5ool001Sooooo1Ooo000Hooooo`Goo`006?ooool5ool001Sooooo1Ooo000H
ooooo`Goo`006?ooool5ool000cooooo0009ooooo`Ooo`005_ooool7ool001Kooooo1ooo000Foooo
o`Ooo`005_ooool7ool001Kooooo1ooo000Fooooo`Ooo`005_ooool7ool001Kooooo1ooo000Foooo
o`Ooo`002oooool000Wooooo1ooo000Fo`0000Ooo`005_l00007ool001Ko00001ooo000Fo`0000Oo
o`005_l00007ool001Ko00001ooo000Fo`0000Ooo`005_l00007ool001Ko00001ooo000;ooooo`00
2Oooool7ool001Kooooo1ooo000Fooooo`Ooo`005_ooool7ool001Kooooo1ooo000Fooooo`Ooo`00
5_ooool7ool001Kooooo1ooo000Fooooo`Ooo`005_ooool7ool000_ooooo000:ooooo`Goo`006?oo
ool5ool001Sooooo1Ooo000Hooooo`Goo`006?ooool5ool001Sooooo1Ooo000Hooooo`Goo`006?oo
ool5ool001Sooooo1Ooo000Hooooo`Goo`003?ooool000_ooooo0ooo000Jooooo`?oo`006_ooool3
ool001[ooooo0ooo000Jooooo`?oo`006_ooool3ool001[ooooo0ooo000Jooooo`?oo`006_ooool3
ool001[ooooo0ooo000=ooooo`003Oooool00ol0003oooooooooo`0Jooooo`03o`000?oooooooooo
01[ooooo00?o0000ooooooooool06_ooool00ol0003oooooooooo`0Jooooo`03o`000?oooooooooo
01Wooooo00?o0000ooooooooool06_ooool00ol0003oooooooooo`0Jooooo`03o`000?oooooooooo
01[ooooo00?o0000ooooooooool06_ooool00ol0003oooooooooo`0<ooooo`003Oooool00ol0003o
ooooooooo`0Jooooo`03o`000?oooooooooo01[ooooo00?o0000ooooooooool06_ooool00ol0003o
ooooooooo`0Jooooo`03o`000?oooooooooo01Wooooo00?o0000ooooooooool06_ooool00ol0003o
ooooooooo`0Jooooo`03o`000?oooooooooo01[ooooo00?o0000ooooooooool06_ooool00ol0003o
ooooooooo`0<ooooo`003Oooool00ol0003oooooooooo`0Jooooo`03o`000?oooooooooo01[ooooo
00?o0000ooooooooool06_ooool00ol0003oooooooooo`0Jooooo`03o`000?oooooooooo01Wooooo
00?o0000ooooooooool06_ooool00ol0003oooooooooo`0Jooooo`03o`000?oooooooooo01[ooooo
00?o0000ooooooooool06_ooool00ol0003oooooooooo`0<ooooo`003Oooool00ol0003ooooooooo
o`0Jooooo`03o`000?oooooooooo01[ooooo00?o0000ooooooooool06_ooool00ol0003ooooooooo
o`0Jooooo`03o`000?oooooooooo01Wooooo00?o0000ooooooooool06_ooool00ol0003ooooooooo
o`0Jooooo`03o`000?oooooooooo01[ooooo00?o0000ooooooooool06_ooool00ol0003ooooooooo
o`0<ooooo`003Oooool00ol0003oooooooooo`0Jooooo`03o`000?oooooooooo01[ooooo00?o0000
ooooooooool06_ooool00ol0003oooooooooo`0Jooooo`03o`000?oooooooooo01Wooooo00?o0000
ooooooooool06_ooool00ol0003oooooooooo`0Jooooo`03o`000?oooooooooo01[ooooo00?o0000
ooooooooool06_ooool00ol0003oooooooooo`0<ooooo`003Oooool00ol0003oooooooooo`0Joooo
o`03o`000?oooooooooo01[ooooo00?o0000ooooooooool06_ooool00ol0003oooooooooo`0Joooo
o`03o`000?oooooooooo01Wooooo00?o0000ooooooooool06_ooool00ol0003oooooooooo`0Joooo
o`03o`000?oooooooooo01[ooooo00?o0000ooooooooool06_ooool00ol0003oooooooooo`0<oooo
o`003Oooool00ol0003oooooooooo`0Jooooo`03o`000?oooooooooo01[ooooo00?o0000oooooooo
ool06_ooool00ol0003oooooooooo`0Jooooo`03o`000?oooooooooo01Wooooo00?o0000oooooooo
ool06_ooool00ol0003oooooooooo`0Jooooo`03o`000?oooooooooo01[ooooo00?o0000oooooooo
ool06_ooool00ol0003oooooooooo`0<ooooo`003Oooool00ol0003oooooooooo`0Jooooo`03o`00
0?oooooooooo01[ooooo00?o0000ooooooooool06_ooool00ol0003oooooooooo`0Jooooo`03o`00
0?oooooooooo01Wooooo00?o0000ooooooooool06_ooool00ol0003oooooooooo`0Jooooo`03o`00
0?oooooooooo01[ooooo00?o0000ooooooooool06_ooool00ol0003oooooooooo`0<ooooo`003Ooo
ool00ol0003oooooooooo`0Jooooo`03o`000?oooooooooo01[ooooo00?o0000ooooooooool06_oo
ool00ol0003oooooooooo`0Jooooo`03o`000?oooooooooo01Wooooo00?o0000ooooooooool06_oo
ool00ol0003oooooooooo`0Jooooo`03o`000?oooooooooo01[ooooo00?o0000ooooooooool06_oo
ool00ol0003oooooooooo`0<ooooo`003Oooool00ol0003oooooooooo`0Jooooo`03o`000?oooooo
oooo01[ooooo00?o0000ooooooooool06_ooool00ol0003oooooooooo`0Jooooo`03o`000?oooooo
oooo01Wooooo00?o0000ooooooooool06_ooool00ol0003oooooooooo`0Jooooo`03o`000?oooooo
oooo01[ooooo00?o0000ooooooooool06_ooool00ol0003oooooooooo`0<ooooo`003Oooool00ol0
003oooooooooo`0Jooooo`03o`000?oooooooooo01[ooooo00?o0000ooooooooool06_ooool00ol0
003oooooooooo`0Jooooo`03o`000?oooooooooo01Wooooo00?o0000ooooooooool06_ooool00ol0
003oooooooooo`0Jooooo`03o`000?oooooooooo01[ooooo00?o0000ooooooooool06_ooool00ol0
003oooooooooo`0<ooooo`003Oooool00ol0003oooooooooo`0Jooooo`03o`000?oooooooooo01[o
oooo00?o0000ooooooooool06_ooool00ol0003oooooooooo`0Jooooo`03o`000?oooooooooo01Wo
oooo00?o0000ooooooooool06_ooool00ol0003oooooooooo`0Jooooo`03o`000?oooooooooo01[o
oooo00?o0000ooooooooool06_ooool00ol0003oooooooooo`0<ooooo`003Oooool00ol0003ooooo
ooooo`0Jooooo`03o`000?oooooooooo01[ooooo00?o0000ooooooooool06_ooool00ol0003ooooo
ooooo`0Jooooo`03o`000?oooooooooo01Wooooo00?o0000ooooooooool06_ooool00ol0003ooooo
ooooo`0Jooooo`03o`000?oooooooooo01[ooooo00?o0000ooooooooool06_ooool00ol0003ooooo
ooooo`0<ooooo`003Oooool00ol0003oooooooooo`0Jooooo`03o`000?oooooooooo01[ooooo00?o
0000ooooooooool06_ooool00ol0003oooooooooo`0Jooooo`03o`000?oooooooooo01Wooooo00?o
0000ooooooooool06_ooool00ol0003oooooooooo`0Jooooo`03o`000?oooooooooo01[ooooo00?o
0000ooooooooool06_ooool00ol0003oooooooooo`0<ooooo`003Oooool00ol0003oooooooooo`0J
ooooo`03o`000?oooooooooo01[ooooo00?o0000ooooooooool06_ooool00ol0003oooooooooo`0J
ooooo`03o`000?oooooooooo01Wooooo00?o0000ooooooooool06_ooool00ol0003oooooooooo`0J
ooooo`03o`000?oooooooooo01[ooooo00?o0000ooooooooool06_ooool00ol0003oooooooooo`0<
ooooo`003Oooool00ol0003oooooooooo`0Jooooo`03o`000?oooooooooo01[ooooo00?o0000oooo
ooooool06_ooool00ol0003oooooooooo`0Jooooo`03o`000?oooooooooo01Wooooo00?o0000oooo
ooooool06_ooool00ol0003oooooooooo`0Jooooo`03o`000?oooooooooo01[ooooo00?o0000oooo
ooooool06_ooool00ol0003oooooooooo`0<ooooo`003Oooool00ol0003oooooooooo`0Jooooo`03
o`000?oooooooooo01[ooooo00?o0000ooooooooool06_ooool00ol0003oooooooooo`0Jooooo`03
o`000?oooooooooo01Wooooo00?o0000ooooooooool06_ooool00ol0003oooooooooo`0Jooooo`03
o`000?oooooooooo01[ooooo00?o0000ooooooooool06_ooool00ol0003oooooooooo`0<ooooo`00
3Oooool00ol0003oooooooooo`0Jooooo`03o`000?oooooooooo01[ooooo00?o0000ooooooooool0
6_ooool00ol0003oooooooooo`0Jooooo`03o`000?oooooooooo01Wooooo00?o0000ooooooooool0
6_ooool00ol0003oooooooooo`0Jooooo`03o`000?oooooooooo01[ooooo00?o0000ooooooooool0
6_ooool00ol0003oooooooooo`0<ooooo`003Oooool00ol0003oooooooooo`0Jooooo`03o`000?oo
oooooooo01[ooooo00?o0000ooooooooool06_ooool00ol0003oooooooooo`0Jooooo`03o`000?oo
oooooooo01Wooooo00?o0000ooooooooool06_ooool00ol0003oooooooooo`0Jooooo`03o`000?oo
oooooooo01[ooooo00?o0000ooooooooool06_ooool00ol0003oooooooooo`0<ooooo`003Oooool0
0ol0003oooooooooo`0Jooooo`03o`000?oooooooooo01[ooooo00?o0000ooooooooool06_ooool0
0ol0003oooooooooo`0Jooooo`03o`000?oooooooooo01Wooooo00?o0000ooooooooool06_ooool0
0ol0003oooooooooo`0Jooooo`03o`000?oooooooooo01[ooooo00?o0000ooooooooool06_ooool0
0ol0003oooooooooo`0<ooooo`003Oooool00ol0003oooooooooo`0Jooooo`03o`000?oooooooooo
01[ooooo00?o0000ooooooooool06_ooool00ol0003oooooooooo`0Jooooo`03o`000?oooooooooo
01Wooooo00?o0000ooooooooool06_ooool00ol0003oooooooooo`0Jooooo`03o`000?oooooooooo
01[ooooo00?o0000ooooooooool06_ooool00ol0003oooooooooo`0<ooooo`003Oooool00ol0003o
ooooooooo`0Jooooo`03o`000?oooooooooo01[ooooo00?o0000ooooooooool06_ooool00ol0003o
ooooooooo`0Jooooo`03o`000?oooooooooo01Wooooo00?o0000ooooooooool06_ooool00ol0003o
ooooooooo`0Jooooo`03o`000?oooooooooo01[ooooo00?o0000ooooooooool06_ooool00ol0003o
ooooooooo`0<ooooo`002oooool3ool001[ooooo0ooo000Jooooo`?oo`006_ooool3ool001[ooooo
0ooo000Jooooo`?oo`006_ooool3ool001[ooooo0ooo000Jooooo`?oo`006_ooool3ool000gooooo
000:ooooo`Goo`006?ooool5ool001Sooooo1Ooo000Hooooo`Goo`006?ooool5ool001Sooooo1Ooo
000Hooooo`Goo`006?ooool5ool001Sooooo1Ooo000Hooooo`Goo`003?ooool000Wooooo1ooo000F
ooooo`Ooo`005_ooool7ool001Kooooo1ooo000Fooooo`Ooo`005_ooool7ool001Kooooo1ooo000F
ooooo`Ooo`005_ooool7ool001Kooooo1ooo000;ooooo`002Oooool7ool001Ko00001ooo000Fo`00
00Ooo`005_l00007ool001Ko00001ooo000Fo`0000Ooo`005_l00007ool001Ko00001ooo000Fo`00
00Ooo`005_l00007ool000_ooooo0009ooooo`Ooo`005_ooool7ool001Kooooo1ooo000Fooooo`Oo
o`005_ooool7ool001Kooooo1ooo000Fooooo`Ooo`005_ooool7ool001Kooooo1ooo000Fooooo`Oo
o`002oooool000[ooooo1Ooo000Hooooo`Goo`006?ooool5ool001Sooooo1Ooo000Hooooo`Goo`00
6?ooool5ool001Sooooo1Ooo000Hooooo`Goo`006?ooool5ool001Sooooo1Ooo000<ooooo`002ooo
ool3ool001[ooooo0ooo000Jooooo`?oo`006_ooool3ool001[ooooo0ooo000Jooooo`?oo`006_oo
ool3ool001[ooooo0ooo000Jooooo`?oo`006_ooool3ool000gooooo000=ooooo`03o`000?oooooo
oooo01[ooooo00?o0000ooooooooool06_ooool00ol0003oooooooooo`0Jooooo`03o`000?oooooo
oooo01[ooooo00?o0000ooooooooool06Oooool00ol0003oooooooooo`0Jooooo`03o`000?oooooo
oooo01[ooooo00?o0000ooooooooool06_ooool00ol0003oooooooooo`0Jooooo`03o`000?oooooo
oooo00cooooo000=ooooo`03o`000?oooooooooo01[ooooo00?o0000ooooooooool06_ooool00ol0
003oooooooooo`0Jooooo`03o`000?oooooooooo01[ooooo00?o0000ooooooooool06Oooool00ol0
003oooooooooo`0Jooooo`03o`000?oooooooooo01[ooooo00?o0000ooooooooool06_ooool00ol0
003oooooooooo`0Jooooo`03o`000?oooooooooo00cooooo000=ooooo`03o`000?oooooooooo01[o
oooo00?o0000ooooooooool06_ooool00ol0003oooooooooo`0Jooooo`03o`000?oooooooooo01[o
oooo00?o0000ooooooooool06Oooool00ol0003oooooooooo`0Jooooo`03o`000?oooooooooo01[o
oooo00?o0000ooooooooool06_ooool00ol0003oooooooooo`0Jooooo`03o`000?oooooooooo00co
oooo000=ooooo`03o`000?oooooooooo01[ooooo00?o0000ooooooooool06_ooool00ol0003ooooo
ooooo`0Jooooo`03o`000?oooooooooo01[ooooo00?o0000ooooooooool06Oooool00ol0003ooooo
ooooo`0Jooooo`03o`000?oooooooooo01[ooooo00?o0000ooooooooool06_ooool00ol0003ooooo
ooooo`0Jooooo`03o`000?oooooooooo00cooooo000=ooooo`03o`000?oooooooooo01[ooooo00?o
0000ooooooooool06_ooool00ol0003oooooooooo`0Jooooo`03o`000?oooooooooo01[ooooo00?o
0000ooooooooool06Oooool00ol0003oooooooooo`0Jooooo`03o`000?oooooooooo01[ooooo00?o
0000ooooooooool06_ooool00ol0003oooooooooo`0Jooooo`03o`000?oooooooooo00cooooo000=
ooooo`03o`000?oooooooooo01[ooooo00?o0000ooooooooool06_ooool00ol0003oooooooooo`0J
ooooo`03o`000?oooooooooo01[ooooo00?o0000ooooooooool06Oooool00ol0003oooooooooo`0J
ooooo`03o`000?oooooooooo01[ooooo00?o0000ooooooooool06_ooool00ol0003oooooooooo`0J
ooooo`03o`000?oooooooooo00cooooo000=ooooo`03o`000?oooooooooo01[ooooo00?o0000oooo
ooooool06_ooool00ol0003oooooooooo`0Jooooo`03o`000?oooooooooo01[ooooo00?o0000oooo
ooooool06Oooool00ol0003oooooooooo`0Jooooo`03o`000?oooooooooo01[ooooo00?o0000oooo
ooooool06_ooool00ol0003oooooooooo`0Jooooo`03o`000?oooooooooo00cooooo000=ooooo`03
o`000?oooooooooo01[ooooo00?o0000ooooooooool06_ooool00ol0003oooooooooo`0Jooooo`03
o`000?oooooooooo01[ooooo00?o0000ooooooooool06Oooool00ol0003oooooooooo`0Jooooo`03
o`000?oooooooooo01[ooooo00?o0000ooooooooool06_ooool00ol0003oooooooooo`0Jooooo`03
o`000?oooooooooo00cooooo000=ooooo`03o`000?oooooooooo01[ooooo00?o0000ooooooooool0
6_ooool00ol0003oooooooooo`0Jooooo`03o`000?oooooooooo01[ooooo00?o0000ooooooooool0
6Oooool00ol0003oooooooooo`0Jooooo`03o`000?oooooooooo01[ooooo00?o0000ooooooooool0
6_ooool00ol0003oooooooooo`0Jooooo`03o`000?oooooooooo00cooooo000=ooooo`03o`000?oo
oooooooo01[ooooo00?o0000ooooooooool06_ooool00ol0003oooooooooo`0Jooooo`03o`000?oo
oooooooo01[ooooo00?o0000ooooooooool06Oooool00ol0003oooooooooo`0Jooooo`03o`000?oo
oooooooo01[ooooo00?o0000ooooooooool06_ooool00ol0003oooooooooo`0Jooooo`03o`000?oo
oooooooo00cooooo000=ooooo`03o`000?oooooooooo01[ooooo00?o0000ooooooooool06_ooool0
0ol0003oooooooooo`0Jooooo`03o`000?oooooooooo01[ooooo00?o0000ooooooooool06Oooool0
0ol0003oooooooooo`0Jooooo`03o`000?oooooooooo01[ooooo00?o0000ooooooooool06_ooool0
0ol0003oooooooooo`0Jooooo`03o`000?oooooooooo00cooooo000=ooooo`03o`000?oooooooooo
01[ooooo00?o0000ooooooooool06_ooool00ol0003oooooooooo`0Jooooo`03o`000?oooooooooo
01[ooooo00?o0000ooooooooool06Oooool00ol0003oooooooooo`0Jooooo`03o`000?oooooooooo
01[ooooo00?o0000ooooooooool06_ooool00ol0003oooooooooo`0Jooooo`03o`000?oooooooooo
00cooooo000=ooooo`03o`000?oooooooooo01[ooooo00?o0000ooooooooool06_ooool00ol0003o
ooooooooo`0Jooooo`03o`000?oooooooooo01[ooooo00?o0000ooooooooool06Oooool00ol0003o
ooooooooo`0Jooooo`03o`000?oooooooooo01[ooooo00?o0000ooooooooool06_ooool00ol0003o
ooooooooo`0Jooooo`03o`000?oooooooooo00cooooo000=ooooo`03o`000?oooooooooo01[ooooo
00?o0000ooooooooool06_ooool00ol0003oooooooooo`0Jooooo`03o`000?oooooooooo01[ooooo
00?o0000ooooooooool06Oooool00ol0003oooooooooo`0Jooooo`03o`000?oooooooooo01[ooooo
00?o0000ooooooooool06_ooool00ol0003oooooooooo`0Jooooo`03o`000?oooooooooo00cooooo
000=ooooo`03o`000?oooooooooo01[ooooo00?o0000ooooooooool06_ooool00ol0003ooooooooo
o`0Jooooo`03o`000?oooooooooo01[ooooo00?o0000ooooooooool06Oooool00ol0003ooooooooo
o`0Jooooo`03o`000?oooooooooo01[ooooo00?o0000ooooooooool06_ooool00ol0003ooooooooo
o`0Jooooo`03o`000?oooooooooo00cooooo000=ooooo`03o`000?oooooooooo01[ooooo00?o0000
ooooooooool06_ooool00ol0003oooooooooo`0Jooooo`03o`000?oooooooooo01[ooooo00?o0000
ooooooooool06Oooool00ol0003oooooooooo`0Jooooo`03o`000?oooooooooo01[ooooo00?o0000
ooooooooool06_ooool00ol0003oooooooooo`0Jooooo`03o`000?oooooooooo00cooooo000=oooo
o`03o`000?oooooooooo01[ooooo00?o0000ooooooooool06_ooool00ol0003oooooooooo`0Joooo
o`03o`000?oooooooooo01[ooooo00?o0000ooooooooool06Oooool00ol0003oooooooooo`0Joooo
o`03o`000?oooooooooo01[ooooo00?o0000ooooooooool06_ooool00ol0003oooooooooo`0Joooo
o`03o`000?oooooooooo00cooooo000=ooooo`03o`000?oooooooooo01[ooooo00?o0000oooooooo
ool06_ooool00ol0003oooooooooo`0Jooooo`03o`000?oooooooooo01[ooooo00?o0000oooooooo
ool06Oooool00ol0003oooooooooo`0Jooooo`03o`000?oooooooooo01[ooooo00?o0000oooooooo
ool06_ooool00ol0003oooooooooo`0Jooooo`03o`000?oooooooooo00cooooo000=ooooo`03o`00
0?oooooooooo01[ooooo00?o0000ooooooooool06_ooool00ol0003oooooooooo`0Jooooo`03o`00
0?oooooooooo01[ooooo00?o0000ooooooooool06Oooool00ol0003oooooooooo`0Jooooo`03o`00
0?oooooooooo01[ooooo00?o0000ooooooooool06_ooool00ol0003oooooooooo`0Jooooo`03o`00
0?oooooooooo00cooooo000=ooooo`03o`000?oooooooooo01[ooooo00?o0000ooooooooool06_oo
ool00ol0003oooooooooo`0Jooooo`03o`000?oooooooooo01[ooooo00?o0000ooooooooool06Ooo
ool00ol0003oooooooooo`0Jooooo`03o`000?oooooooooo01[ooooo00?o0000ooooooooool06_oo
ool00ol0003oooooooooo`0Jooooo`03o`000?oooooooooo00cooooo000=ooooo`03o`000?oooooo
oooo01[ooooo00?o0000ooooooooool06_ooool00ol0003oooooooooo`0Jooooo`03o`000?oooooo
oooo01[ooooo00?o0000ooooooooool06Oooool00ol0003oooooooooo`0Jooooo`03o`000?oooooo
oooo01[ooooo00?o0000ooooooooool06_ooool00ol0003oooooooooo`0Jooooo`03o`000?oooooo
oooo00cooooo000=ooooo`03o`000?oooooooooo01[ooooo00?o0000ooooooooool06_ooool00ol0
003oooooooooo`0Jooooo`03o`000?oooooooooo01[ooooo00?o0000ooooooooool06Oooool00ol0
003oooooooooo`0Jooooo`03o`000?oooooooooo01[ooooo00?o0000ooooooooool06_ooool00ol0
003oooooooooo`0Jooooo`03o`000?oooooooooo00cooooo000;ooooo`?oo`006_ooool3ool001[o
oooo0ooo000Jooooo`?oo`006_ooool3ool001[ooooo0ooo000Jooooo`?oo`006_ooool3ool001[o
oooo0ooo000Jooooo`?oo`003Oooool000[ooooo1Ooo000Hooooo`Goo`006?ooool5ool001Sooooo
1Ooo000Hooooo`Goo`006?ooool5ool001Sooooo1Ooo000Hooooo`Goo`006?ooool5ool001Sooooo
1Ooo000<ooooo`002Oooool7ool001Kooooo1ooo000Fooooo`Ooo`005_ooool7ool001Kooooo1ooo
000Fooooo`Ooo`005_ooool7ool001Kooooo1ooo000Fooooo`Ooo`005_ooool7ool000_ooooo0009
ooooo`Ooo`005_l00007ool001Ko00001ooo000Fo`0000Ooo`005_l00007ool001Ko00001ooo000F
o`0000Ooo`005_l00007ool001Ko00001ooo000Fo`0000Ooo`002oooool000Wooooo1ooo000Foooo
o`Ooo`005_ooool7ool001Kooooo1ooo000Fooooo`Ooo`005_ooool7ool001Kooooo1ooo000Foooo
o`Ooo`005_ooool7ool001Kooooo1ooo000;ooooo`002_ooool5ool001Sooooo1Ooo000Hooooo`Go
o`006?ooool5ool001Sooooo1Ooo000Hooooo`Goo`006?ooool5ool001Sooooo1Ooo000Hooooo`Go
o`006?ooool5ool000cooooo000;ooooo`?oo`006_ooool3ool001[ooooo0ooo000Jooooo`?oo`00
6_ooool3ool001[ooooo0ooo000Jooooo`?oo`006_ooool3ool001[ooooo0ooo000Jooooo`?oo`00
3Oooool000gooooo00?o0000ooooooooool06_ooool00ol0003oooooooooo`0Jooooo`03o`000?oo
oooooooo01[ooooo00?o0000ooooooooool06_ooool00ol0003oooooooooo`0Iooooo`03o`000?oo
oooooooo01[ooooo00?o0000ooooooooool06_ooool00ol0003oooooooooo`0Jooooo`03o`000?oo
oooooooo01[ooooo00?o0000ooooooooool03?ooool000gooooo00?o0000ooooooooool06_ooool0
0ol0003oooooooooo`0Jooooo`03o`000?oooooooooo01[ooooo00?o0000ooooooooool06_ooool0
0ol0003oooooooooo`0Iooooo`03o`000?oooooooooo01[ooooo00?o0000ooooooooool06_ooool0
0ol0003oooooooooo`0Jooooo`03o`000?oooooooooo01[ooooo00?o0000ooooooooool03?ooool0
00gooooo00?o0000ooooooooool06_ooool00ol0003oooooooooo`0Jooooo`03o`000?oooooooooo
01[ooooo00?o0000ooooooooool06_ooool00ol0003oooooooooo`0Iooooo`03o`000?oooooooooo
01[ooooo00?o0000ooooooooool06_ooool00ol0003oooooooooo`0Jooooo`03o`000?oooooooooo
01[ooooo00?o0000ooooooooool03?ooool000gooooo00?o0000ooooooooool06_ooool00ol0003o
ooooooooo`0Jooooo`03o`000?oooooooooo01[ooooo00?o0000ooooooooool06_ooool00ol0003o
ooooooooo`0Iooooo`03o`000?oooooooooo01[ooooo00?o0000ooooooooool06_ooool00ol0003o
ooooooooo`0Jooooo`03o`000?oooooooooo01[ooooo00?o0000ooooooooool03?ooool000gooooo
00?o0000ooooooooool06_ooool00ol0003oooooooooo`0Jooooo`03o`000?oooooooooo01[ooooo
00?o0000ooooooooool06_ooool00ol0003oooooooooo`0Iooooo`03o`000?oooooooooo01[ooooo
00?o0000ooooooooool06_ooool00ol0003oooooooooo`0Jooooo`03o`000?oooooooooo01[ooooo
00?o0000ooooooooool03?ooool000gooooo00?o0000ooooooooool06_ooool00ol0003ooooooooo
o`0Jooooo`03o`000?oooooooooo01[ooooo00?o0000ooooooooool06_ooool00ol0003ooooooooo
o`0Iooooo`03o`000?oooooooooo01[ooooo00?o0000ooooooooool06_ooool00ol0003ooooooooo
o`0Jooooo`03o`000?oooooooooo01[ooooo00?o0000ooooooooool03?ooool000gooooo00?o0000
ooooooooool06_ooool00ol0003oooooooooo`0Jooooo`03o`000?oooooooooo01[ooooo00?o0000
ooooooooool06_ooool00ol0003oooooooooo`0Iooooo`03o`000?oooooooooo01[ooooo00?o0000
ooooooooool06_ooool00ol0003oooooooooo`0Jooooo`03o`000?oooooooooo01[ooooo00?o0000
ooooooooool03?ooool000gooooo00?o0000ooooooooool06_ooool00ol0003oooooooooo`0Joooo
o`03o`000?oooooooooo01[ooooo00?o0000ooooooooool06_ooool00ol0003oooooooooo`0Ioooo
o`03o`000?oooooooooo01[ooooo00?o0000ooooooooool06_ooool00ol0003oooooooooo`0Joooo
o`03o`000?oooooooooo01[ooooo00?o0000ooooooooool03?ooool000gooooo00?o0000oooooooo
ool06_ooool00ol0003oooooooooo`0Jooooo`03o`000?oooooooooo01[ooooo00?o0000oooooooo
ool06_ooool00ol0003oooooooooo`0Iooooo`03o`000?oooooooooo01[ooooo00?o0000oooooooo
ool06_ooool00ol0003oooooooooo`0Jooooo`03o`000?oooooooooo01[ooooo00?o0000oooooooo
ool03?ooool000gooooo00?o0000ooooooooool06_ooool00ol0003oooooooooo`0Jooooo`03o`00
0?oooooooooo01[ooooo00?o0000ooooooooool06_ooool00ol0003oooooooooo`0Iooooo`03o`00
0?oooooooooo01[ooooo00?o0000ooooooooool06_ooool00ol0003oooooooooo`0Jooooo`03o`00
0?oooooooooo01[ooooo00?o0000ooooooooool03?ooool000gooooo00?o0000ooooooooool06_oo
ool00ol0003oooooooooo`0Jooooo`03o`000?oooooooooo01[ooooo00?o0000ooooooooool06_oo
ool00ol0003oooooooooo`0Iooooo`03o`000?oooooooooo01[ooooo00?o0000ooooooooool06_oo
ool00ol0003oooooooooo`0Jooooo`03o`000?oooooooooo01[ooooo00?o0000ooooooooool03?oo
ool000gooooo00?o0000ooooooooool06_ooool00ol0003oooooooooo`0Jooooo`03o`000?oooooo
oooo01[ooooo00?o0000ooooooooool06_ooool00ol0003oooooooooo`0Iooooo`03o`000?oooooo
oooo01[ooooo00?o0000ooooooooool06_ooool00ol0003oooooooooo`0Jooooo`03o`000?oooooo
oooo01[ooooo00?o0000ooooooooool03?ooool000gooooo00?o0000ooooooooool06_ooool00ol0
003oooooooooo`0Jooooo`03o`000?oooooooooo01[ooooo00?o0000ooooooooool06_ooool00ol0
003oooooooooo`0Iooooo`03o`000?oooooooooo01[ooooo00?o0000ooooooooool06_ooool00ol0
003oooooooooo`0Jooooo`03o`000?oooooooooo01[ooooo00?o0000ooooooooool03?ooool000go
oooo00?o0000ooooooooool06_ooool00ol0003oooooooooo`0Jooooo`03o`000?oooooooooo01[o
oooo00?o0000ooooooooool06_ooool00ol0003oooooooooo`0Iooooo`03o`000?oooooooooo01[o
oooo00?o0000ooooooooool06_ooool00ol0003oooooooooo`0Jooooo`03o`000?oooooooooo01[o
oooo00?o0000ooooooooool03?ooool000gooooo00?o0000ooooooooool06_ooool00ol0003ooooo
ooooo`0Jooooo`03o`000?oooooooooo01[ooooo00?o0000ooooooooool06_ooool00ol0003ooooo
ooooo`0Iooooo`03o`000?oooooooooo01[ooooo00?o0000ooooooooool06_ooool00ol0003ooooo
ooooo`0Jooooo`03o`000?oooooooooo01[ooooo00?o0000ooooooooool03?ooool000gooooo00?o
0000ooooooooool06_ooool00ol0003oooooooooo`0Jooooo`03o`000?oooooooooo01[ooooo00?o
0000ooooooooool06_ooool00ol0003oooooooooo`0Iooooo`03o`000?oooooooooo01[ooooo00?o
0000ooooooooool06_ooool00ol0003oooooooooo`0Jooooo`03o`000?oooooooooo01[ooooo00?o
0000ooooooooool03?ooool000gooooo00?o0000ooooooooool06_ooool00ol0003oooooooooo`0J
ooooo`03o`000?oooooooooo01[ooooo00?o0000ooooooooool06_ooool00ol0003oooooooooo`0I
ooooo`03o`000?oooooooooo01[ooooo00?o0000ooooooooool06_ooool00ol0003oooooooooo`0J
ooooo`03o`000?oooooooooo01[ooooo00?o0000ooooooooool03?ooool000gooooo00?o0000oooo
ooooool06_ooool00ol0003oooooooooo`0Jooooo`03o`000?oooooooooo01[ooooo00?o0000oooo
ooooool06_ooool00ol0003oooooooooo`0Iooooo`03o`000?oooooooooo01[ooooo00?o0000oooo
ooooool06_ooool00ol0003oooooooooo`0Jooooo`03o`000?oooooooooo01[ooooo00?o0000oooo
ooooool03?ooool000gooooo00?o0000ooooooooool06_ooool00ol0003oooooooooo`0Jooooo`03
o`000?oooooooooo01[ooooo00?o0000ooooooooool06_ooool00ol0003oooooooooo`0Iooooo`03
o`000?oooooooooo01[ooooo00?o0000ooooooooool06_ooool00ol0003oooooooooo`0Jooooo`03
o`000?oooooooooo01[ooooo00?o0000ooooooooool03?ooool000gooooo00?o0000ooooooooool0
6_ooool00ol0003oooooooooo`0Jooooo`03o`000?oooooooooo01[ooooo00?o0000ooooooooool0
6_ooool00ol0003oooooooooo`0Iooooo`03o`000?oooooooooo01[ooooo00?o0000ooooooooool0
6_ooool00ol0003oooooooooo`0Jooooo`03o`000?oooooooooo01[ooooo00?o0000ooooooooool0
3?ooool000gooooo00?o0000ooooooooool06_ooool00ol0003oooooooooo`0Jooooo`03o`000?oo
oooooooo01[ooooo00?o0000ooooooooool06_ooool00ol0003oooooooooo`0Iooooo`03o`000?oo
oooooooo01[ooooo00?o0000ooooooooool06_ooool00ol0003oooooooooo`0Jooooo`03o`000?oo
oooooooo01[ooooo00?o0000ooooooooool03?ooool000gooooo00?o0000ooooooooool06_ooool0
0ol0003oooooooooo`0Jooooo`03o`000?oooooooooo01[ooooo00?o0000ooooooooool06_ooool0
0ol0003oooooooooo`0Iooooo`03o`000?oooooooooo01[ooooo00?o0000ooooooooool06_ooool0
0ol0003oooooooooo`0Jooooo`03o`000?oooooooooo01[ooooo00?o0000ooooooooool03?ooool0
00_ooooo0ooo000Jooooo`?oo`006_ooool3ool001[ooooo0ooo000Jooooo`?oo`006_ooool3ool0
01[ooooo0ooo000Jooooo`?oo`006_ooool3ool001[ooooo0ooo000=ooooo`002_ooool5ool001So
oooo1Ooo000Hooooo`Goo`006?ooool5ool001Sooooo1Ooo000Hooooo`Goo`006?ooool5ool001So
oooo1Ooo000Hooooo`Goo`006?ooool5ool000cooooo0009ooooo`Ooo`005_l00007ool001Ko0000
1ooo000Fo`0000Ooo`005_l00007ool001Ko00001ooo000Fo`0000Ooo`005_l00007ool001Ko0000
1ooo000Fo`0000Ooo`002oooool000Wooooo1ooo000Fooooo`Ooo`005_ooool7ool001Kooooo1ooo
000Fooooo`Ooo`005_ooool7ool001Kooooo1ooo000Fooooo`Ooo`005_ooool7ool001Kooooo1ooo
000;ooooo`002Oooool7ool001Kooooo1ooo000Fooooo`Ooo`005_ooool7ool001Kooooo1ooo000F
ooooo`Ooo`005_ooool7ool001Kooooo1ooo000Fooooo`Ooo`005_ooool7ool000_ooooo000:oooo
o`Goo`006?ooool5ool001Sooooo1Ooo000Hooooo`Goo`006?ooool5ool001Sooooo1Ooo000Hoooo
o`Goo`006?ooool5ool001Sooooo1Ooo000Hooooo`Goo`003?ooool000_ooooo0ooo000Jooooo`?o
o`006_ooool3ool001[ooooo0ooo000Jooooo`?oo`006_ooool3ool001[ooooo0ooo000Jooooo`?o
o`006_ooool3ool001[ooooo0ooo000=ooooo`003Oooool00ol0003oooooooooo`0Jooooo`03o`00
0?oooooooooo01[ooooo00?o0000ooooooooool06_ooool00ol0003oooooooooo`0Jooooo`03o`00
0?oooooooooo01Wooooo00?o0000ooooooooool06_ooool00ol0003oooooooooo`0Jooooo`03o`00
0?oooooooooo01[ooooo00?o0000ooooooooool06_ooool00ol0003oooooooooo`0<ooooo`003Ooo
ool00ol0003oooooooooo`0Jooooo`03o`000?oooooooooo01[ooooo00?o0000ooooooooool06_oo
ool00ol0003oooooooooo`0Jooooo`03o`000?oooooooooo01Wooooo00?o0000ooooooooool06_oo
ool00ol0003oooooooooo`0Jooooo`03o`000?oooooooooo01[ooooo00?o0000ooooooooool06_oo
ool00ol0003oooooooooo`0<ooooo`003Oooool00ol0003oooooooooo`0Jooooo`03o`000?oooooo
oooo01[ooooo00?o0000ooooooooool06_ooool00ol0003oooooooooo`0Jooooo`03o`000?oooooo
oooo01Wooooo00?o0000ooooooooool06_ooool00ol0003oooooooooo`0Jooooo`03o`000?oooooo
oooo01[ooooo00?o0000ooooooooool06_ooool00ol0003oooooooooo`0<ooooo`003Oooool00ol0
003oooooooooo`0Jooooo`03o`000?oooooooooo01[ooooo00?o0000ooooooooool06_ooool00ol0
003oooooooooo`0Jooooo`03o`000?oooooooooo01Wooooo00?o0000ooooooooool06_ooool00ol0
003oooooooooo`0Jooooo`03o`000?oooooooooo01[ooooo00?o0000ooooooooool06_ooool00ol0
003oooooooooo`0<ooooo`003Oooool00ol0003oooooooooo`0Jooooo`03o`000?oooooooooo01[o
oooo00?o0000ooooooooool06_ooool00ol0003oooooooooo`0Jooooo`03o`000?oooooooooo01Wo
oooo00?o0000ooooooooool06_ooool00ol0003oooooooooo`0Jooooo`03o`000?oooooooooo01[o
oooo00?o0000ooooooooool06_ooool00ol0003oooooooooo`0<ooooo`003Oooool00ol0003ooooo
ooooo`0Jooooo`03o`000?oooooooooo01[ooooo00?o0000ooooooooool06_ooool00ol0003ooooo
ooooo`0Jooooo`03o`000?oooooooooo01Wooooo00?o0000ooooooooool06_ooool00ol0003ooooo
ooooo`0Jooooo`03o`000?oooooooooo01[ooooo00?o0000ooooooooool06_ooool00ol0003ooooo
ooooo`0<ooooo`003Oooool00ol0003oooooooooo`0Jooooo`03o`000?oooooooooo01[ooooo00?o
0000ooooooooool06_ooool00ol0003oooooooooo`0Jooooo`03o`000?oooooooooo01Wooooo00?o
0000ooooooooool06_ooool00ol0003oooooooooo`0Jooooo`03o`000?oooooooooo01[ooooo00?o
0000ooooooooool06_ooool00ol0003oooooooooo`0<ooooo`003Oooool00ol0003oooooooooo`0J
ooooo`03o`000?oooooooooo01[ooooo00?o0000ooooooooool06_ooool00ol0003oooooooooo`0J
ooooo`03o`000?oooooooooo01Wooooo00?o0000ooooooooool06_ooool00ol0003oooooooooo`0J
ooooo`03o`000?oooooooooo01[ooooo00?o0000ooooooooool06_ooool00ol0003oooooooooo`0<
ooooo`003Oooool00ol0003oooooooooo`0Jooooo`03o`000?oooooooooo01[ooooo00?o0000oooo
ooooool06_ooool00ol0003oooooooooo`0Jooooo`03o`000?oooooooooo01Wooooo00?o0000oooo
ooooool06_ooool00ol0003oooooooooo`0Jooooo`03o`000?oooooooooo01[ooooo00?o0000oooo
ooooool06_ooool00ol0003oooooooooo`0<ooooo`003Oooool00ol0003oooooooooo`0Jooooo`03
o`000?oooooooooo01[ooooo00?o0000ooooooooool06_ooool00ol0003oooooooooo`0Jooooo`03
o`000?oooooooooo01Wooooo00?o0000ooooooooool06_ooool00ol0003oooooooooo`0Jooooo`03
o`000?oooooooooo01[ooooo00?o0000ooooooooool06_ooool00ol0003oooooooooo`0<ooooo`00
3Oooool00ol0003oooooooooo`0Jooooo`03o`000?oooooooooo01[ooooo00?o0000ooooooooool0
6_ooool00ol0003oooooooooo`0Jooooo`03o`000?oooooooooo01Wooooo00?o0000ooooooooool0
6_ooool00ol0003oooooooooo`0Jooooo`03o`000?oooooooooo01[ooooo00?o0000ooooooooool0
6_ooool00ol0003oooooooooo`0<ooooo`003Oooool00ol0003oooooooooo`0Jooooo`03o`000?oo
oooooooo01[ooooo00?o0000ooooooooool06_ooool00ol0003oooooooooo`0Jooooo`03o`000?oo
oooooooo01Wooooo00?o0000ooooooooool06_ooool00ol0003oooooooooo`0Jooooo`03o`000?oo
oooooooo01[ooooo00?o0000ooooooooool06_ooool00ol0003oooooooooo`0<ooooo`003Oooool0
0ol0003oooooooooo`0Jooooo`03o`000?oooooooooo01[ooooo00?o0000ooooooooool06_ooool0
0ol0003oooooooooo`0Jooooo`03o`000?oooooooooo01Wooooo00?o0000ooooooooool06_ooool0
0ol0003oooooooooo`0Jooooo`03o`000?oooooooooo01[ooooo00?o0000ooooooooool06_ooool0
0ol0003oooooooooo`0<ooooo`003Oooool00ol0003oooooooooo`0Jooooo`03o`000?oooooooooo
01[ooooo00?o0000ooooooooool06_ooool00ol0003oooooooooo`0Jooooo`03o`000?oooooooooo
01Wooooo00?o0000ooooooooool06_ooool00ol0003oooooooooo`0Jooooo`03o`000?oooooooooo
01[ooooo00?o0000ooooooooool06_ooool00ol0003oooooooooo`0<ooooo`003Oooool00ol0003o
ooooooooo`0Jooooo`03o`000?oooooooooo01[ooooo00?o0000ooooooooool06_ooool00ol0003o
ooooooooo`0Jooooo`03o`000?oooooooooo01Wooooo00?o0000ooooooooool06_ooool00ol0003o
ooooooooo`0Jooooo`03o`000?oooooooooo01[ooooo00?o0000ooooooooool06_ooool00ol0003o
ooooooooo`0<ooooo`003Oooool00ol0003oooooooooo`0Jooooo`03o`000?oooooooooo01[ooooo
00?o0000ooooooooool06_ooool00ol0003oooooooooo`0Jooooo`03o`000?oooooooooo01Wooooo
00?o0000ooooooooool06_ooool00ol0003oooooooooo`0Jooooo`03o`000?oooooooooo01[ooooo
00?o0000ooooooooool06_ooool00ol0003oooooooooo`0<ooooo`003Oooool00ol0003ooooooooo
o`0Jooooo`03o`000?oooooooooo01[ooooo00?o0000ooooooooool06_ooool00ol0003ooooooooo
o`0Jooooo`03o`000?oooooooooo01Wooooo00?o0000ooooooooool06_ooool00ol0003ooooooooo
o`0Jooooo`03o`000?oooooooooo01[ooooo00?o0000ooooooooool06_ooool00ol0003ooooooooo
o`0<ooooo`003Oooool00ol0003oooooooooo`0Jooooo`03o`000?oooooooooo01[ooooo00?o0000
ooooooooool06_ooool00ol0003oooooooooo`0Jooooo`03o`000?oooooooooo01Wooooo00?o0000
ooooooooool06_ooool00ol0003oooooooooo`0Jooooo`03o`000?oooooooooo01[ooooo00?o0000
ooooooooool06_ooool00ol0003oooooooooo`0<ooooo`003Oooool00ol0003oooooooooo`0Joooo
o`03o`000?oooooooooo01[ooooo00?o0000ooooooooool06_ooool00ol0003oooooooooo`0Joooo
o`03o`000?oooooooooo01Wooooo00?o0000ooooooooool06_ooool00ol0003oooooooooo`0Joooo
o`03o`000?oooooooooo01[ooooo00?o0000ooooooooool06_ooool00ol0003oooooooooo`0<oooo
o`003Oooool00ol0003oooooooooo`0Jooooo`03o`000?oooooooooo01[ooooo00?o0000oooooooo
ool06_ooool00ol0003oooooooooo`0Jooooo`03o`000?oooooooooo01Wooooo00?o0000oooooooo
ool06_ooool00ol0003oooooooooo`0Jooooo`03o`000?oooooooooo01[ooooo00?o0000oooooooo
ool06_ooool00ol0003oooooooooo`0<ooooo`003Oooool00ol0003oooooooooo`0Jooooo`03o`00
0?oooooooooo01[ooooo00?o0000ooooooooool06_ooool00ol0003oooooooooo`0Jooooo`03o`00
0?oooooooooo01Wooooo00?o0000ooooooooool06_ooool00ol0003oooooooooo`0Jooooo`03o`00
0?oooooooooo01[ooooo00?o0000ooooooooool06_ooool00ol0003oooooooooo`0<ooooo`003Ooo
ool00ol0003oooooooooo`0Jooooo`03o`000?oooooooooo01[ooooo00?o0000ooooooooool06_oo
ool00ol0003oooooooooo`0Jooooo`03o`000?oooooooooo01Wooooo00?o0000ooooooooool06_oo
ool00ol0003oooooooooo`0Jooooo`03o`000?oooooooooo01[ooooo00?o0000ooooooooool06_oo
ool00ol0003oooooooooo`0<ooooo`002oooool3ool001[ooooo0ooo000Jooooo`?oo`006_ooool3
ool001[ooooo0ooo000Jooooo`?oo`006_ooool3ool001[ooooo0ooo000Jooooo`?oo`006_ooool3
ool000gooooo000:ooooo`Goo`006?ooool5ool001Sooooo1Ooo000Hooooo`Goo`006?ooool5ool0
01Sooooo1Ooo000Hooooo`Goo`006?ooool5ool001Sooooo1Ooo000Hooooo`Goo`003?ooool000Wo
oooo1ooo000Fo`0000Ooo`005_l00007ool001Ko00001ooo000Fo`0000Ooo`005_l00007ool001Ko
00001ooo000Fo`0000Ooo`005_l00007ool001Ko00001ooo000;ooooo`002Oooool7ool001Kooooo
1ooo000Fooooo`Ooo`005_ooool7ool001Kooooo1ooo000Fooooo`Ooo`005_ooool7ool001Kooooo
1ooo000Fooooo`Ooo`005_ooool7ool000_ooooo0009ooooo`Ooo`005_ooool7ool001Kooooo1ooo
000Fooooo`Ooo`005_ooool7ool001Kooooo1ooo000Fooooo`Ooo`005_ooool7ool001Kooooo1ooo
000Fooooo`Ooo`002oooool000[ooooo1Ooo000Hooooo`Goo`006?ooool5ool001Sooooo1Ooo000H
ooooo`Goo`006?ooool5ool001Sooooo1Ooo000Hooooo`Goo`006?ooool5ool001Sooooo1Ooo000<
ooooo`002oooool3ool001[ooooo0ooo000Jooooo`?oo`006_ooool3ool001[ooooo0ooo000Joooo
o`?oo`006_ooool3ool001[ooooo0ooo000Jooooo`?oo`006_ooool3ool000gooooo000=ooooo`03
o`000?oooooooooo01[ooooo00?o0000ooooooooool06_ooool00ol0003oooooooooo`0Jooooo`03
o`000?oooooooooo01[ooooo00?o0000ooooooooool06Oooool00ol0003oooooooooo`0Jooooo`03
o`000?oooooooooo01[ooooo00?o0000ooooooooool06_ooool00ol0003oooooooooo`0Jooooo`03
o`000?oooooooooo00cooooo000=ooooo`03o`000?oooooooooo01[ooooo00?o0000ooooooooool0
6_ooool00ol0003oooooooooo`0Jooooo`03o`000?oooooooooo01[ooooo00?o0000ooooooooool0
6Oooool00ol0003oooooooooo`0Jooooo`03o`000?oooooooooo01[ooooo00?o0000ooooooooool0
6_ooool00ol0003oooooooooo`0Jooooo`03o`000?oooooooooo00cooooo000=ooooo`03o`000?oo
oooooooo01[ooooo00?o0000ooooooooool06_ooool00ol0003oooooooooo`0Jooooo`03o`000?oo
oooooooo01[ooooo00?o0000ooooooooool06Oooool00ol0003oooooooooo`0Jooooo`03o`000?oo
oooooooo01[ooooo00?o0000ooooooooool06_ooool00ol0003oooooooooo`0Jooooo`03o`000?oo
oooooooo00cooooo000=ooooo`03o`000?oooooooooo01[ooooo00?o0000ooooooooool06_ooool0
0ol0003oooooooooo`0Jooooo`03o`000?oooooooooo01[ooooo00?o0000ooooooooool06Oooool0
0ol0003oooooooooo`0Jooooo`03o`000?oooooooooo01[ooooo00?o0000ooooooooool06_ooool0
0ol0003oooooooooo`0Jooooo`03o`000?oooooooooo00cooooo000=ooooo`03o`000?oooooooooo
01[ooooo00?o0000ooooooooool06_ooool00ol0003oooooooooo`0Jooooo`03o`000?oooooooooo
01[ooooo00?o0000ooooooooool06Oooool00ol0003oooooooooo`0Jooooo`03o`000?oooooooooo
01[ooooo00?o0000ooooooooool06_ooool00ol0003oooooooooo`0Jooooo`03o`000?oooooooooo
00cooooo000=ooooo`03o`000?oooooooooo01[ooooo00?o0000ooooooooool06_ooool00ol0003o
ooooooooo`0Jooooo`03o`000?oooooooooo01[ooooo00?o0000ooooooooool06Oooool00ol0003o
ooooooooo`0Jooooo`03o`000?oooooooooo01[ooooo00?o0000ooooooooool06_ooool00ol0003o
ooooooooo`0Jooooo`03o`000?oooooooooo00cooooo000=ooooo`03o`000?oooooooooo01[ooooo
00?o0000ooooooooool06_ooool00ol0003oooooooooo`0Jooooo`03o`000?oooooooooo01[ooooo
00?o0000ooooooooool06Oooool00ol0003oooooooooo`0Jooooo`03o`000?oooooooooo01[ooooo
00?o0000ooooooooool06_ooool00ol0003oooooooooo`0Jooooo`03o`000?oooooooooo00cooooo
000=ooooo`03o`000?oooooooooo01[ooooo00?o0000ooooooooool06_ooool00ol0003ooooooooo
o`0Jooooo`03o`000?oooooooooo01[ooooo00?o0000ooooooooool06Oooool00ol0003ooooooooo
o`0Jooooo`03o`000?oooooooooo01[ooooo00?o0000ooooooooool06_ooool00ol0003ooooooooo
o`0Jooooo`03o`000?oooooooooo00cooooo000=ooooo`03o`000?oooooooooo01[ooooo00?o0000
ooooooooool06_ooool00ol0003oooooooooo`0Jooooo`03o`000?oooooooooo01[ooooo00?o0000
ooooooooool06Oooool00ol0003oooooooooo`0Jooooo`03o`000?oooooooooo01[ooooo00?o0000
ooooooooool06_ooool00ol0003oooooooooo`0Jooooo`03o`000?oooooooooo00cooooo000=oooo
o`03o`000?oooooooooo01[ooooo00?o0000ooooooooool06_ooool00ol0003oooooooooo`0Joooo
o`03o`000?oooooooooo01[ooooo00?o0000ooooooooool06Oooool00ol0003oooooooooo`0Joooo
o`03o`000?oooooooooo01[ooooo00?o0000ooooooooool06_ooool00ol0003oooooooooo`0Joooo
o`03o`000?oooooooooo00cooooo000=ooooo`03o`000?oooooooooo01[ooooo00?o0000oooooooo
ool06_ooool00ol0003oooooooooo`0Jooooo`03o`000?oooooooooo01[ooooo00?o0000oooooooo
ool06Oooool00ol0003oooooooooo`0Jooooo`03o`000?oooooooooo01[ooooo00?o0000oooooooo
ool06_ooool00ol0003oooooooooo`0Jooooo`03o`000?oooooooooo00cooooo000=ooooo`03o`00
0?oooooooooo01[ooooo00?o0000ooooooooool06_ooool00ol0003oooooooooo`0Jooooo`03o`00
0?oooooooooo01[ooooo00?o0000ooooooooool06Oooool00ol0003oooooooooo`0Jooooo`03o`00
0?oooooooooo01[ooooo00?o0000ooooooooool06_ooool00ol0003oooooooooo`0Jooooo`03o`00
0?oooooooooo00cooooo000=ooooo`03o`000?oooooooooo01[ooooo00?o0000ooooooooool06_oo
ool00ol0003oooooooooo`0Jooooo`03o`000?oooooooooo01[ooooo00?o0000ooooooooool06Ooo
ool00ol0003oooooooooo`0Jooooo`03o`000?oooooooooo01[ooooo00?o0000ooooooooool06_oo
ool00ol0003oooooooooo`0Jooooo`03o`000?oooooooooo00cooooo000=ooooo`03o`000?oooooo
oooo01[ooooo00?o0000ooooooooool06_ooool00ol0003oooooooooo`0Jooooo`03o`000?oooooo
oooo01[ooooo00?o0000ooooooooool06Oooool00ol0003oooooooooo`0Jooooo`03o`000?oooooo
oooo01[ooooo00?o0000ooooooooool06_ooool00ol0003oooooooooo`0Jooooo`03o`000?oooooo
oooo00cooooo000=ooooo`03o`000?oooooooooo01[ooooo00?o0000ooooooooool06_ooool00ol0
003oooooooooo`0Jooooo`03o`000?oooooooooo01[ooooo00?o0000ooooooooool06Oooool00ol0
003oooooooooo`0Jooooo`03o`000?oooooooooo01[ooooo00?o0000ooooooooool06_ooool00ol0
003oooooooooo`0Jooooo`03o`000?oooooooooo00cooooo000=ooooo`03o`000?oooooooooo01[o
oooo00?o0000ooooooooool06_ooool00ol0003oooooooooo`0Jooooo`03o`000?oooooooooo01[o
oooo00?o0000ooooooooool06Oooool00ol0003oooooooooo`0Jooooo`03o`000?oooooooooo01[o
oooo00?o0000ooooooooool06_ooool00ol0003oooooooooo`0Jooooo`03o`000?oooooooooo00co
oooo000=ooooo`03o`000?oooooooooo01[ooooo00?o0000ooooooooool06_ooool00ol0003ooooo
ooooo`0Jooooo`03o`000?oooooooooo01[ooooo00?o0000ooooooooool06Oooool00ol0003ooooo
ooooo`0Jooooo`03o`000?oooooooooo01[ooooo00?o0000ooooooooool06_ooool00ol0003ooooo
ooooo`0Jooooo`03o`000?oooooooooo00cooooo000=ooooo`03o`000?oooooooooo01[ooooo00?o
0000ooooooooool06_ooool00ol0003oooooooooo`0Jooooo`03o`000?oooooooooo01[ooooo00?o
0000ooooooooool06Oooool00ol0003oooooooooo`0Jooooo`03o`000?oooooooooo01[ooooo00?o
0000ooooooooool06_ooool00ol0003oooooooooo`0Jooooo`03o`000?oooooooooo00cooooo000=
ooooo`03o`000?oooooooooo01[ooooo00?o0000ooooooooool06_ooool00ol0003oooooooooo`0J
ooooo`03o`000?oooooooooo01[ooooo00?o0000ooooooooool06Oooool00ol0003oooooooooo`0J
ooooo`03o`000?oooooooooo01[ooooo00?o0000ooooooooool06_ooool00ol0003oooooooooo`0J
ooooo`03o`000?oooooooooo00cooooo000=ooooo`03o`000?oooooooooo01[ooooo00?o0000oooo
ooooool06_ooool00ol0003oooooooooo`0Jooooo`03o`000?oooooooooo01[ooooo00?o0000oooo
ooooool06Oooool00ol0003oooooooooo`0Jooooo`03o`000?oooooooooo01[ooooo00?o0000oooo
ooooool06_ooool00ol0003oooooooooo`0Jooooo`03o`000?oooooooooo00cooooo000=ooooo`03
o`000?oooooooooo01[ooooo00?o0000ooooooooool06_ooool00ol0003oooooooooo`0Jooooo`03
o`000?oooooooooo01[ooooo00?o0000ooooooooool06Oooool00ol0003oooooooooo`0Jooooo`03
o`000?oooooooooo01[ooooo00?o0000ooooooooool06_ooool00ol0003oooooooooo`0Jooooo`03
o`000?oooooooooo00cooooo000=ooooo`03o`000?oooooooooo01[ooooo00?o0000ooooooooool0
6_ooool00ol0003oooooooooo`0Jooooo`03o`000?oooooooooo01[ooooo00?o0000ooooooooool0
6Oooool00ol0003oooooooooo`0Jooooo`03o`000?oooooooooo01[ooooo00?o0000ooooooooool0
6_ooool00ol0003oooooooooo`0Jooooo`03o`000?oooooooooo00cooooo000;ooooo`?oo`006_oo
ool3ool001[ooooo0ooo000Jooooo`?oo`006_ooool3ool001[ooooo0ooo000Jooooo`?oo`006_oo
ool3ool001[ooooo0ooo000Jooooo`?oo`003Oooool000[ooooo1Ooo000Hooooo`Goo`006?ooool5
ool001Sooooo1Ooo000Hooooo`Goo`006?ooool5ool001Sooooo1Ooo000Hooooo`Goo`006?ooool5
ool001Sooooo1Ooo000<ooooo`002Oooool7ool001Ko00001ooo000Fo`0000Ooo`005_l00007ool0
01Ko00001ooo000Fo`0000Ooo`005_l00007ool001Ko00001ooo000Fo`0000Ooo`005_l00007ool0
00_ooooo0009ooooo`Ooo`005_ooool7ool001Kooooo1ooo000Fooooo`Ooo`005_ooool7ool001Ko
oooo1ooo000Fooooo`Ooo`005_ooool7ool001Kooooo1ooo000Fooooo`Ooo`002oooool000Wooooo
1ooo000Fooooo`Ooo`005_ooool7ool001Kooooo1ooo000Fooooo`Ooo`005_ooool7ool001Kooooo
1ooo000Fooooo`Ooo`005_ooool7ool001Kooooo1ooo000;ooooo`002_ooool5ool001Sooooo1Ooo
000Hooooo`Goo`006?ooool5ool001Sooooo1Ooo000Hooooo`Goo`006?ooool5ool001Sooooo1Ooo
000Hooooo`Goo`006?ooool5ool000cooooo000;ooooo`?oo`006_ooool3ool001[ooooo0ooo000J
ooooo`?oo`006_ooool3ool001[ooooo0ooo000Jooooo`?oo`006_ooool3ool001[ooooo0ooo000J
ooooo`?oo`003Oooool000gooooo00?o0000ooooooooool06_ooool00ol0003oooooooooo`0Joooo
o`03o`000?oooooooooo01[ooooo00?o0000ooooooooool06_ooool00ol0003oooooooooo`0Ioooo
o`03o`000?oooooooooo01[ooooo00?o0000ooooooooool06_ooool00ol0003oooooooooo`0Joooo
o`03o`000?oooooooooo01[ooooo00?o0000ooooooooool03?ooool000gooooo00?o0000oooooooo
ool06_ooool00ol0003oooooooooo`0Jooooo`03o`000?oooooooooo01[ooooo00?o0000oooooooo
ool06_ooool00ol0003oooooooooo`0Iooooo`03o`000?oooooooooo01[ooooo00?o0000oooooooo
ool06_ooool00ol0003oooooooooo`0Jooooo`03o`000?oooooooooo01[ooooo00?o0000oooooooo
ool03?ooool000gooooo00?o0000ooooooooool06_ooool00ol0003oooooooooo`0Jooooo`03o`00
0?oooooooooo01[ooooo00?o0000ooooooooool06_ooool00ol0003oooooooooo`0Iooooo`03o`00
0?oooooooooo01[ooooo00?o0000ooooooooool06_ooool00ol0003oooooooooo`0Jooooo`03o`00
0?oooooooooo01[ooooo00?o0000ooooooooool03?ooool000gooooo00?o0000ooooooooool06_oo
ool00ol0003oooooooooo`0Jooooo`03o`000?oooooooooo01[ooooo00?o0000ooooooooool06_oo
ool00ol0003oooooooooo`0Iooooo`03o`000?oooooooooo01[ooooo00?o0000ooooooooool06_oo
ool00ol0003oooooooooo`0Jooooo`03o`000?oooooooooo01[ooooo00?o0000ooooooooool03?oo
ool000gooooo00?o0000ooooooooool06_ooool00ol0003oooooooooo`0Jooooo`03o`000?oooooo
oooo01[ooooo00?o0000ooooooooool06_ooool00ol0003oooooooooo`0Iooooo`03o`000?oooooo
oooo01[ooooo00?o0000ooooooooool06_ooool00ol0003oooooooooo`0Jooooo`03o`000?oooooo
oooo01[ooooo00?o0000ooooooooool03?ooool000gooooo00?o0000ooooooooool06_ooool00ol0
003oooooooooo`0Jooooo`03o`000?oooooooooo01[ooooo00?o0000ooooooooool06_ooool00ol0
003oooooooooo`0Iooooo`03o`000?oooooooooo01[ooooo00?o0000ooooooooool06_ooool00ol0
003oooooooooo`0Jooooo`03o`000?oooooooooo01[ooooo00?o0000ooooooooool03?ooool000go
oooo00?o0000ooooooooool06_ooool00ol0003oooooooooo`0Jooooo`03o`000?oooooooooo01[o
oooo00?o0000ooooooooool06_ooool00ol0003oooooooooo`0Iooooo`03o`000?oooooooooo01[o
oooo00?o0000ooooooooool06_ooool00ol0003oooooooooo`0Jooooo`03o`000?oooooooooo01[o
oooo00?o0000ooooooooool03?ooool000gooooo00?o0000ooooooooool06_ooool00ol0003ooooo
ooooo`0Jooooo`03o`000?oooooooooo01[ooooo00?o0000ooooooooool06_ooool00ol0003ooooo
ooooo`0Iooooo`03o`000?oooooooooo01[ooooo00?o0000ooooooooool06_ooool00ol0003ooooo
ooooo`0Jooooo`03o`000?oooooooooo01[ooooo00?o0000ooooooooool03?ooool000gooooo00?o
0000ooooooooool06_ooool00ol0003oooooooooo`0Jooooo`03o`000?oooooooooo01[ooooo00?o
0000ooooooooool06_ooool00ol0003oooooooooo`0Iooooo`03o`000?oooooooooo01[ooooo00?o
0000ooooooooool06_ooool00ol0003oooooooooo`0Jooooo`03o`000?oooooooooo01[ooooo00?o
0000ooooooooool03?ooool000gooooo00?o0000ooooooooool06_ooool00ol0003oooooooooo`0J
ooooo`03o`000?oooooooooo01[ooooo00?o0000ooooooooool06_ooool00ol0003oooooooooo`0I
ooooo`03o`000?oooooooooo01[ooooo00?o0000ooooooooool06_ooool00ol0003oooooooooo`0J
ooooo`03o`000?oooooooooo01[ooooo00?o0000ooooooooool03?ooool000gooooo00?o0000oooo
ooooool06_ooool00ol0003oooooooooo`0Jooooo`03o`000?oooooooooo01[ooooo00?o0000oooo
ooooool06_ooool00ol0003oooooooooo`0Iooooo`03o`000?oooooooooo01[ooooo00?o0000oooo
ooooool06_ooool00ol0003oooooooooo`0Jooooo`03o`000?oooooooooo01[ooooo00?o0000oooo
ooooool03?ooool000gooooo00?o0000ooooooooool06_ooool00ol0003oooooooooo`0Jooooo`03
o`000?oooooooooo01[ooooo00?o0000ooooooooool06_ooool00ol0003oooooooooo`0Iooooo`03
o`000?oooooooooo01[ooooo00?o0000ooooooooool06_ooool00ol0003oooooooooo`0Jooooo`03
o`000?oooooooooo01[ooooo00?o0000ooooooooool03?ooool000gooooo00?o0000ooooooooool0
6_ooool00ol0003oooooooooo`0Jooooo`03o`000?oooooooooo01[ooooo00?o0000ooooooooool0
6_ooool00ol0003oooooooooo`0Iooooo`03o`000?oooooooooo01[ooooo00?o0000ooooooooool0
6_ooool00ol0003oooooooooo`0Jooooo`03o`000?oooooooooo01[ooooo00?o0000ooooooooool0
3?ooool000gooooo00?o0000ooooooooool06_ooool00ol0003oooooooooo`0Jooooo`03o`000?oo
oooooooo01[ooooo00?o0000ooooooooool06_ooool00ol0003oooooooooo`0Iooooo`03o`000?oo
oooooooo01[ooooo00?o0000ooooooooool06_ooool00ol0003oooooooooo`0Jooooo`03o`000?oo
oooooooo01[ooooo00?o0000ooooooooool03?ooool000gooooo00?o0000ooooooooool06_ooool0
0ol0003oooooooooo`0Jooooo`03o`000?oooooooooo01[ooooo00?o0000ooooooooool06_ooool0
0ol0003oooooooooo`0Iooooo`03o`000?oooooooooo01[ooooo00?o0000ooooooooool06_ooool0
0ol0003oooooooooo`0Jooooo`03o`000?oooooooooo01[ooooo00?o0000ooooooooool03?ooool0
00gooooo00?o0000ooooooooool06_ooool00ol0003oooooooooo`0Jooooo`03o`000?oooooooooo
01[ooooo00?o0000ooooooooool06_ooool00ol0003oooooooooo`0Iooooo`03o`000?oooooooooo
01[ooooo00?o0000ooooooooool06_ooool00ol0003oooooooooo`0Jooooo`03o`000?oooooooooo
01[ooooo00?o0000ooooooooool03?ooool000gooooo00?o0000ooooooooool06_ooool00ol0003o
ooooooooo`0Jooooo`03o`000?oooooooooo01[ooooo00?o0000ooooooooool06_ooool00ol0003o
ooooooooo`0Iooooo`03o`000?oooooooooo01[ooooo00?o0000ooooooooool06_ooool00ol0003o
ooooooooo`0Jooooo`03o`000?oooooooooo01[ooooo00?o0000ooooooooool03?ooool000gooooo
00?o0000ooooooooool06_ooool00ol0003oooooooooo`0Jooooo`03o`000?oooooooooo01[ooooo
00?o0000ooooooooool06_ooool00ol0003oooooooooo`0Iooooo`03o`000?oooooooooo01[ooooo
00?o0000ooooooooool06_ooool00ol0003oooooooooo`0Jooooo`03o`000?oooooooooo01[ooooo
00?o0000ooooooooool03?ooool000gooooo00?o0000ooooooooool06_ooool00ol0003ooooooooo
o`0Jooooo`03o`000?oooooooooo01[ooooo00?o0000ooooooooool06_ooool00ol0003ooooooooo
o`0Iooooo`03o`000?oooooooooo01[ooooo00?o0000ooooooooool06_ooool00ol0003ooooooooo
o`0Jooooo`03o`000?oooooooooo01[ooooo00?o0000ooooooooool03?ooool000gooooo00?o0000
ooooooooool06_ooool00ol0003oooooooooo`0Jooooo`03o`000?oooooooooo01[ooooo00?o0000
ooooooooool06_ooool00ol0003oooooooooo`0Iooooo`03o`000?oooooooooo01[ooooo00?o0000
ooooooooool06_ooool00ol0003oooooooooo`0Jooooo`03o`000?oooooooooo01[ooooo00?o0000
ooooooooool03?ooool000gooooo00?o0000ooooooooool06_ooool00ol0003oooooooooo`0Joooo
o`03o`000?oooooooooo01[ooooo00?o0000ooooooooool06_ooool00ol0003oooooooooo`0Ioooo
o`03o`000?oooooooooo01[ooooo00?o0000ooooooooool06_ooool00ol0003oooooooooo`0Joooo
o`03o`000?oooooooooo01[ooooo00?o0000ooooooooool03?ooool000gooooo00?o0000oooooooo
ool06_ooool00ol0003oooooooooo`0Jooooo`03o`000?oooooooooo01[ooooo00?o0000oooooooo
ool06_ooool00ol0003oooooooooo`0Iooooo`03o`000?oooooooooo01[ooooo00?o0000oooooooo
ool06_ooool00ol0003oooooooooo`0Jooooo`03o`000?oooooooooo01[ooooo00?o0000oooooooo
ool03?ooool000_ooooo0ooo000Jooooo`?oo`006_ooool3ool001[ooooo0ooo000Jooooo`?oo`00
6_ooool3ool001[ooooo0ooo000Jooooo`?oo`006_ooool3ool001[ooooo0ooo000=ooooo`002_oo
ool5ool001Sooooo1Ooo000Hooooo`Goo`006?ooool5ool001Sooooo1Ooo000Hooooo`Goo`006?oo
ool5ool001Sooooo1Ooo000Hooooo`Goo`006?ooool5ool000cooooo0009ooooo`Ooo`005_l00007
ool001Ko00001ooo000Fo`0000Ooo`005_l00007ool001Ko00001ooo000Fo`0000Ooo`005_l00007
ool001Ko00001ooo000Fo`0000Ooo`002oooool000Wooooo1ooo000Fooooo`Ooo`005_ooool7ool0
01Kooooo1ooo000Fooooo`Ooo`005_ooool7ool001Kooooo1ooo000Fooooo`Ooo`005_ooool7ool0
01Kooooo1ooo000;ooooo`002Oooool7ool001Kooooo1ooo000Fooooo`Ooo`005_ooool7ool001Ko
oooo1ooo000Fooooo`Ooo`005_ooool7ool001Kooooo1ooo000Fooooo`Ooo`005_ooool7ool000_o
oooo000:ooooo`Goo`006?ooool5ool001Sooooo1Ooo000Hooooo`Goo`006?ooool5ool001Sooooo
1Ooo000Hooooo`Goo`006?ooool5ool001Sooooo1Ooo000Hooooo`Goo`003?ooool000_ooooo0ooo
000Jooooo`?oo`006_ooool3ool001[ooooo0ooo000Jooooo`?oo`006_ooool3ool001[ooooo0ooo
000Jooooo`?oo`006_ooool3ool001[ooooo0ooo000=ooooo`003Oooool00ol0003oooooooooo`0J
ooooo`03o`000?oooooooooo01[ooooo00?o0000ooooooooool06_ooool00ol0003oooooooooo`0J
ooooo`03o`000?oooooooooo01Wooooo00?o0000ooooooooool06_ooool00ol0003oooooooooo`0J
ooooo`03o`000?oooooooooo01[ooooo00?o0000ooooooooool06_ooool00ol0003oooooooooo`0<
ooooo`003Oooool00ol0003oooooooooo`0Jooooo`03o`000?oooooooooo01[ooooo00?o0000oooo
ooooool06_ooool00ol0003oooooooooo`0Jooooo`03o`000?oooooooooo01Wooooo00?o0000oooo
ooooool06_ooool00ol0003oooooooooo`0Jooooo`03o`000?oooooooooo01[ooooo00?o0000oooo
ooooool06_ooool00ol0003oooooooooo`0<ooooo`003Oooool00ol0003oooooooooo`0Jooooo`03
o`000?oooooooooo01[ooooo00?o0000ooooooooool06_ooool00ol0003oooooooooo`0Jooooo`03
o`000?oooooooooo01Wooooo00?o0000ooooooooool06_ooool00ol0003oooooooooo`0Jooooo`03
o`000?oooooooooo01[ooooo00?o0000ooooooooool06_ooool00ol0003oooooooooo`0<ooooo`00
3Oooool00ol0003oooooooooo`0Jooooo`03o`000?oooooooooo01[ooooo00?o0000ooooooooool0
6_ooool00ol0003oooooooooo`0Jooooo`03o`000?oooooooooo01Wooooo00?o0000ooooooooool0
6_ooool00ol0003oooooooooo`0Jooooo`03o`000?oooooooooo01[ooooo00?o0000ooooooooool0
6_ooool00ol0003oooooooooo`0<ooooo`003Oooool00ol0003oooooooooo`0Jooooo`03o`000?oo
oooooooo01[ooooo00?o0000ooooooooool06_ooool00ol0003oooooooooo`0Jooooo`03o`000?oo
oooooooo01Wooooo00?o0000ooooooooool06_ooool00ol0003oooooooooo`0Jooooo`03o`000?oo
oooooooo01[ooooo00?o0000ooooooooool06_ooool00ol0003oooooooooo`0<ooooo`003Oooool0
0ol0003oooooooooo`0Jooooo`03o`000?oooooooooo01[ooooo00?o0000ooooooooool06_ooool0
0ol0003oooooooooo`0Jooooo`03o`000?oooooooooo01Wooooo00?o0000ooooooooool06_ooool0
0ol0003oooooooooo`0Jooooo`03o`000?oooooooooo01[ooooo00?o0000ooooooooool06_ooool0
0ol0003oooooooooo`0<ooooo`003Oooool00ol0003oooooooooo`0Jooooo`03o`000?oooooooooo
01[ooooo00?o0000ooooooooool06_ooool00ol0003oooooooooo`0Jooooo`03o`000?oooooooooo
01Wooooo00?o0000ooooooooool06_ooool00ol0003oooooooooo`0Jooooo`03o`000?oooooooooo
01[ooooo00?o0000ooooooooool06_ooool00ol0003oooooooooo`0<ooooo`003Oooool00ol0003o
ooooooooo`0Jooooo`03o`000?oooooooooo01[ooooo00?o0000ooooooooool06_ooool00ol0003o
ooooooooo`0Jooooo`03o`000?oooooooooo01Wooooo00?o0000ooooooooool06_ooool00ol0003o
ooooooooo`0Jooooo`03o`000?oooooooooo01[ooooo00?o0000ooooooooool06_ooool00ol0003o
ooooooooo`0<ooooo`003Oooool00ol0003oooooooooo`0Jooooo`03o`000?oooooooooo01[ooooo
00?o0000ooooooooool06_ooool00ol0003oooooooooo`0Jooooo`03o`000?oooooooooo01Wooooo
00?o0000ooooooooool06_ooool00ol0003oooooooooo`0Jooooo`03o`000?oooooooooo01[ooooo
00?o0000ooooooooool06_ooool00ol0003oooooooooo`0<ooooo`003Oooool00ol0003ooooooooo
o`0Jooooo`03o`000?oooooooooo01[ooooo00?o0000ooooooooool06_ooool00ol0003ooooooooo
o`0Jooooo`03o`000?oooooooooo01Wooooo00?o0000ooooooooool06_ooool00ol0003ooooooooo
o`0Jooooo`03o`000?oooooooooo01[ooooo00?o0000ooooooooool06_ooool00ol0003ooooooooo
o`0<ooooo`003Oooool00ol0003oooooooooo`0Jooooo`03o`000?oooooooooo01[ooooo00?o0000
ooooooooool06_ooool00ol0003oooooooooo`0Jooooo`03o`000?oooooooooo01Wooooo00?o0000
ooooooooool06_ooool00ol0003oooooooooo`0Jooooo`03o`000?oooooooooo01[ooooo00?o0000
ooooooooool06_ooool00ol0003oooooooooo`0<ooooo`003Oooool00ol0003oooooooooo`0Joooo
o`03o`000?oooooooooo01[ooooo00?o0000ooooooooool06_ooool00ol0003oooooooooo`0Joooo
o`03o`000?oooooooooo01Wooooo00?o0000ooooooooool06_ooool00ol0003oooooooooo`0Joooo
o`03o`000?oooooooooo01[ooooo00?o0000ooooooooool06_ooool00ol0003oooooooooo`0<oooo
o`003Oooool00ol0003oooooooooo`0Jooooo`03o`000?oooooooooo01[ooooo00?o0000oooooooo
ool06_ooool00ol0003oooooooooo`0Jooooo`03o`000?oooooooooo01Wooooo00?o0000oooooooo
ool06_ooool00ol0003oooooooooo`0Jooooo`03o`000?oooooooooo01[ooooo00?o0000oooooooo
ool06_ooool00ol0003oooooooooo`0<ooooo`003Oooool00ol0003oooooooooo`0Jooooo`03o`00
0?oooooooooo01[ooooo00?o0000ooooooooool06_ooool00ol0003oooooooooo`0Jooooo`03o`00
0?oooooooooo01Wooooo00?o0000ooooooooool06_ooool00ol0003oooooooooo`0Jooooo`03o`00
0?oooooooooo01[ooooo00?o0000ooooooooool06_ooool00ol0003oooooooooo`0<ooooo`003Ooo
ool00ol0003oooooooooo`0Jooooo`03o`000?oooooooooo01[ooooo00?o0000ooooooooool06_oo
ool00ol0003oooooooooo`0Jooooo`03o`000?oooooooooo01Wooooo00?o0000ooooooooool06_oo
ool00ol0003oooooooooo`0Jooooo`03o`000?oooooooooo01[ooooo00?o0000ooooooooool06_oo
ool00ol0003oooooooooo`0<ooooo`003Oooool00ol0003oooooooooo`0Jooooo`03o`000?oooooo
oooo01[ooooo00?o0000ooooooooool06_ooool00ol0003oooooooooo`0Jooooo`03o`000?oooooo
oooo01Wooooo00?o0000ooooooooool06_ooool00ol0003oooooooooo`0Jooooo`03o`000?oooooo
oooo01[ooooo00?o0000ooooooooool06_ooool00ol0003oooooooooo`0<ooooo`003Oooool00ol0
003oooooooooo`0Jooooo`03o`000?oooooooooo01[ooooo00?o0000ooooooooool06_ooool00ol0
003oooooooooo`0Jooooo`03o`000?oooooooooo01Wooooo00?o0000ooooooooool06_ooool00ol0
003oooooooooo`0Jooooo`03o`000?oooooooooo01[ooooo00?o0000ooooooooool06_ooool00ol0
003oooooooooo`0<ooooo`003Oooool00ol0003oooooooooo`0Jooooo`03o`000?oooooooooo01[o
oooo00?o0000ooooooooool06_ooool00ol0003oooooooooo`0Jooooo`03o`000?oooooooooo01Wo
oooo00?o0000ooooooooool06_ooool00ol0003oooooooooo`0Jooooo`03o`000?oooooooooo01[o
oooo00?o0000ooooooooool06_ooool00ol0003oooooooooo`0<ooooo`003Oooool00ol0003ooooo
ooooo`0Jooooo`03o`000?oooooooooo01[ooooo00?o0000ooooooooool06_ooool00ol0003ooooo
ooooo`0Jooooo`03o`000?oooooooooo01Wooooo00?o0000ooooooooool06_ooool00ol0003ooooo
ooooo`0Jooooo`03o`000?oooooooooo01[ooooo00?o0000ooooooooool06_ooool00ol0003ooooo
ooooo`0<ooooo`003Oooool00ol0003oooooooooo`0Jooooo`03o`000?oooooooooo01[ooooo00?o
0000ooooooooool06_ooool00ol0003oooooooooo`0Jooooo`03o`000?oooooooooo01Wooooo00?o
0000ooooooooool06_ooool00ol0003oooooooooo`0Jooooo`03o`000?oooooooooo01[ooooo00?o
0000ooooooooool06_ooool00ol0003oooooooooo`0<ooooo`003Oooool00ol0003oooooooooo`0J
ooooo`03o`000?oooooooooo01[ooooo00?o0000ooooooooool06_ooool00ol0003oooooooooo`0J
ooooo`03o`000?oooooooooo01Wooooo00?o0000ooooooooool06_ooool00ol0003oooooooooo`0J
ooooo`03o`000?oooooooooo01[ooooo00?o0000ooooooooool06_ooool00ol0003oooooooooo`0<
ooooo`003Oooool00ol0003oooooooooo`0Jooooo`03o`000?oooooooooo01[ooooo00?o0000oooo
ooooool06_ooool00ol0003oooooooooo`0Jooooo`03o`000?oooooooooo01Wooooo00?o0000oooo
ooooool06_ooool00ol0003oooooooooo`0Jooooo`03o`000?oooooooooo01[ooooo00?o0000oooo
ooooool06_ooool00ol0003oooooooooo`0<ooooo`002oooool3ool001[ooooo0ooo000Jooooo`?o
o`006_ooool3ool001[ooooo0ooo000Jooooo`?oo`006_ooool3ool001[ooooo0ooo000Jooooo`?o
o`006_ooool3ool000gooooo000:ooooo`Goo`006?ooool5ool001Sooooo1Ooo000Hooooo`Goo`00
6?ooool5ool001Sooooo1Ooo000Hooooo`Goo`006?ooool5ool001Sooooo1Ooo000Hooooo`Goo`00
3?ooool000Wooooo1ooo000Fo`0000Ooo`005_l00007ool001Ko00001ooo000Fo`0000Ooo`005_l0
0007ool001Ko00001ooo000Fo`0000Ooo`005_l00007ool001Ko00001ooo000;ooooo`002Oooool7
ool001Kooooo1ooo000Fooooo`Ooo`005_ooool7ool001Kooooo1ooo000Fooooo`Ooo`005_ooool7
ool001Kooooo1ooo000Fooooo`Ooo`005_ooool7ool000_ooooo0009ooooo`Ooo`005_ooool7ool0
01Kooooo1ooo000Fooooo`Ooo`005_ooool7ool001Kooooo1ooo000Fooooo`Ooo`005_ooool7ool0
01Kooooo1ooo000Fooooo`Ooo`002oooool000[ooooo1Ooo000Hooooo`Goo`006?ooool5ool001So
oooo1Ooo000Hooooo`Goo`006?ooool5ool001Sooooo1Ooo000Hooooo`Goo`006?ooool5ool001So
oooo1Ooo000<ooooo`002oooool3ool001[ooooo0ooo000Jooooo`?oo`006_ooool3ool001[ooooo
0ooo000Jooooo`?oo`006_ooool3ool001[ooooo0ooo000Jooooo`?oo`006_ooool3ool000gooooo
003oooooob7ooooo003oooooob7ooooo003oooooob7ooooo003oooooob7ooooo003oooooob7ooooo
003oooooob7ooooo003oooooob7ooooo003oooooob7ooooo003oooooob7ooooo0000\
\>"],
  ImageRangeCache->{{{0, 287}, {287, 0}} -> {-0.0500054, -0.0500054, \
0.00383279, 0.00383279}},
  CellTags->{"b:3", "LocalInteractions:10"}]
}, Open  ]],

Cell[BoxData[
    \(DeleteEdges[m, All]\)], "Input",
  CellLabel->"In[9]:=",
  CellTags->{"b:3", "LocalInteractions:10"}],

Cell[CellGroupData[{

Cell[BoxData[
    \(\(ShowGraph[m];\)\)], "Input",
  CellLabel->"In[10]:=",
  CellTags->{"b:3", "LocalInteractions:10"}],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: 1 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.0454545 0.909091 0.0454545 0.909091 [
[ 0 0 0 0 ]
[ 1 1 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 0 m
1 0 L
1 1 L
0 1 L
closepath
clip
newpath
1 0 0 r
.025 w
.04545 .04545 Mdot
.14646 .04545 Mdot
.24747 .04545 Mdot
.34848 .04545 Mdot
.44949 .04545 Mdot
.55051 .04545 Mdot
.65152 .04545 Mdot
.75253 .04545 Mdot
.85354 .04545 Mdot
.95455 .04545 Mdot
.04545 .14646 Mdot
.14646 .14646 Mdot
.24747 .14646 Mdot
.34848 .14646 Mdot
.44949 .14646 Mdot
.55051 .14646 Mdot
.65152 .14646 Mdot
.75253 .14646 Mdot
.85354 .14646 Mdot
.95455 .14646 Mdot
.04545 .24747 Mdot
.14646 .24747 Mdot
.24747 .24747 Mdot
.34848 .24747 Mdot
.44949 .24747 Mdot
.55051 .24747 Mdot
.65152 .24747 Mdot
.75253 .24747 Mdot
.85354 .24747 Mdot
.95455 .24747 Mdot
.04545 .34848 Mdot
.14646 .34848 Mdot
.24747 .34848 Mdot
.34848 .34848 Mdot
.44949 .34848 Mdot
.55051 .34848 Mdot
.65152 .34848 Mdot
.75253 .34848 Mdot
.85354 .34848 Mdot
.95455 .34848 Mdot
.04545 .44949 Mdot
.14646 .44949 Mdot
.24747 .44949 Mdot
.34848 .44949 Mdot
.44949 .44949 Mdot
.55051 .44949 Mdot
.65152 .44949 Mdot
.75253 .44949 Mdot
.85354 .44949 Mdot
.95455 .44949 Mdot
.04545 .55051 Mdot
.14646 .55051 Mdot
.24747 .55051 Mdot
.34848 .55051 Mdot
.44949 .55051 Mdot
.55051 .55051 Mdot
.65152 .55051 Mdot
.75253 .55051 Mdot
.85354 .55051 Mdot
.95455 .55051 Mdot
.04545 .65152 Mdot
.14646 .65152 Mdot
.24747 .65152 Mdot
.34848 .65152 Mdot
.44949 .65152 Mdot
.55051 .65152 Mdot
.65152 .65152 Mdot
.75253 .65152 Mdot
.85354 .65152 Mdot
.95455 .65152 Mdot
.04545 .75253 Mdot
.14646 .75253 Mdot
.24747 .75253 Mdot
.34848 .75253 Mdot
.44949 .75253 Mdot
.55051 .75253 Mdot
.65152 .75253 Mdot
.75253 .75253 Mdot
.85354 .75253 Mdot
.95455 .75253 Mdot
.04545 .85354 Mdot
.14646 .85354 Mdot
.24747 .85354 Mdot
.34848 .85354 Mdot
.44949 .85354 Mdot
.55051 .85354 Mdot
.65152 .85354 Mdot
.75253 .85354 Mdot
.85354 .85354 Mdot
.95455 .85354 Mdot
.04545 .95455 Mdot
.14646 .95455 Mdot
.24747 .95455 Mdot
.34848 .95455 Mdot
.44949 .95455 Mdot
.55051 .95455 Mdot
.65152 .95455 Mdot
.75253 .95455 Mdot
.85354 .95455 Mdot
.95455 .95455 Mdot
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  CellLabel->"From In[10]:=",
  ImageSize->{288, 288},
  ImageMargins->{{0, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40004P000182000`400?l00000o`00003ooooooolQ
ooooo`00oooooolQooooo`00oooooolQooooo`00oooooolQooooo`00oooooolQooooo`00oooooolQ
ooooo`00oooooolQooooo`00oooooolQooooo`00oooooolQooooo`00oooooolQooooo`00oooooolQ
ooooo`002oooool3ool001[ooooo0ooo000Jooooo`?oo`006_ooool3ool001[ooooo0ooo000Joooo
o`?oo`006_ooool3ool001[ooooo0ooo000Jooooo`?oo`006_ooool3ool000gooooo000:ooooo`Go
o`006?ooool5ool001Sooooo1Ooo000Hooooo`Goo`006?ooool5ool001Sooooo1Ooo000Hooooo`Go
o`006?ooool5ool001Sooooo1Ooo000Hooooo`Goo`003?ooool000Wooooo1ooo000Fooooo`Ooo`00
5_ooool7ool001Kooooo1ooo000Fooooo`Ooo`005_ooool7ool001Kooooo1ooo000Fooooo`Ooo`00
5_ooool7ool001Kooooo1ooo000;ooooo`002Oooool7ool001Kooooo1ooo000Fooooo`Ooo`005_oo
ool7ool001Kooooo1ooo000Fooooo`Ooo`005_ooool7ool001Kooooo1ooo000Fooooo`Ooo`005_oo
ool7ool000_ooooo0009ooooo`Ooo`005_ooool7ool001Kooooo1ooo000Fooooo`Ooo`005_ooool7
ool001Kooooo1ooo000Fooooo`Ooo`005_ooool7ool001Kooooo1ooo000Fooooo`Ooo`002oooool0
00[ooooo1Ooo000Hooooo`Goo`006?ooool5ool001Sooooo1Ooo000Hooooo`Goo`006?ooool5ool0
01Sooooo1Ooo000Hooooo`Goo`006?ooool5ool001Sooooo1Ooo000<ooooo`002oooool3ool001[o
oooo0ooo000Jooooo`?oo`006_ooool3ool001[ooooo0ooo000Jooooo`?oo`006_ooool3ool001[o
oooo0ooo000Jooooo`?oo`006_ooool3ool000gooooo003oooooob7ooooo003oooooob7ooooo003o
ooooob7ooooo003oooooob7ooooo003oooooob7ooooo003oooooob7ooooo003oooooob7ooooo003o
ooooob7ooooo003oooooob7ooooo003oooooob7ooooo003oooooob7ooooo003oooooob7ooooo003o
ooooob7ooooo003oooooob7ooooo003oooooob7ooooo003oooooob7ooooo003oooooob7ooooo003o
ooooob7ooooo003oooooob7ooooo003oooooob7ooooo003oooooob7ooooo003oooooob7ooooo000;
ooooo`?oo`006_ooool3ool001[ooooo0ooo000Jooooo`?oo`006_ooool3ool001[ooooo0ooo000J
ooooo`?oo`006_ooool3ool001[ooooo0ooo000Jooooo`?oo`003Oooool000[ooooo1Ooo000Hoooo
o`Goo`006?ooool5ool001Sooooo1Ooo000Hooooo`Goo`006?ooool5ool001Sooooo1Ooo000Hoooo
o`Goo`006?ooool5ool001Sooooo1Ooo000<ooooo`002Oooool7ool001Kooooo1ooo000Fooooo`Oo
o`005_ooool7ool001Kooooo1ooo000Fooooo`Ooo`005_ooool7ool001Kooooo1ooo000Fooooo`Oo
o`005_ooool7ool000_ooooo0009ooooo`Ooo`005_ooool7ool001Kooooo1ooo000Fooooo`Ooo`00
5_ooool7ool001Kooooo1ooo000Fooooo`Ooo`005_ooool7ool001Kooooo1ooo000Fooooo`Ooo`00
2oooool000Wooooo1ooo000Fooooo`Ooo`005_ooool7ool001Kooooo1ooo000Fooooo`Ooo`005_oo
ool7ool001Kooooo1ooo000Fooooo`Ooo`005_ooool7ool001Kooooo1ooo000;ooooo`002_ooool5
ool001Sooooo1Ooo000Hooooo`Goo`006?ooool5ool001Sooooo1Ooo000Hooooo`Goo`006?ooool5
ool001Sooooo1Ooo000Hooooo`Goo`006?ooool5ool000cooooo000;ooooo`?oo`006_ooool3ool0
01[ooooo0ooo000Jooooo`?oo`006_ooool3ool001[ooooo0ooo000Jooooo`?oo`006_ooool3ool0
01[ooooo0ooo000Jooooo`?oo`003Oooool00?oooooo8Oooool00?oooooo8Oooool00?oooooo8Ooo
ool00?oooooo8Oooool00?oooooo8Oooool00?oooooo8Oooool00?oooooo8Oooool00?oooooo8Ooo
ool00?oooooo8Oooool00?oooooo8Oooool00?oooooo8Oooool00?oooooo8Oooool00?oooooo8Ooo
ool00?oooooo8Oooool00?oooooo8Oooool00?oooooo8Oooool00?oooooo8Oooool00?oooooo8Ooo
ool00?oooooo8Oooool00?oooooo8Oooool00?oooooo8Oooool00?oooooo8Oooool000_ooooo0ooo
000Jooooo`?oo`006_ooool3ool001[ooooo0ooo000Jooooo`?oo`006_ooool3ool001[ooooo0ooo
000Jooooo`?oo`006_ooool3ool001[ooooo0ooo000=ooooo`002_ooool5ool001Sooooo1Ooo000H
ooooo`Goo`006?ooool5ool001Sooooo1Ooo000Hooooo`Goo`006?ooool5ool001Sooooo1Ooo000H
ooooo`Goo`006?ooool5ool000cooooo0009ooooo`Ooo`005_ooool7ool001Kooooo1ooo000Foooo
o`Ooo`005_ooool7ool001Kooooo1ooo000Fooooo`Ooo`005_ooool7ool001Kooooo1ooo000Foooo
o`Ooo`002oooool000Wooooo1ooo000Fooooo`Ooo`005_ooool7ool001Kooooo1ooo000Fooooo`Oo
o`005_ooool7ool001Kooooo1ooo000Fooooo`Ooo`005_ooool7ool001Kooooo1ooo000;ooooo`00
2Oooool7ool001Kooooo1ooo000Fooooo`Ooo`005_ooool7ool001Kooooo1ooo000Fooooo`Ooo`00
5_ooool7ool001Kooooo1ooo000Fooooo`Ooo`005_ooool7ool000_ooooo000:ooooo`Goo`006?oo
ool5ool001Sooooo1Ooo000Hooooo`Goo`006?ooool5ool001Sooooo1Ooo000Hooooo`Goo`006?oo
ool5ool001Sooooo1Ooo000Hooooo`Goo`003?ooool000_ooooo0ooo000Jooooo`?oo`006_ooool3
ool001[ooooo0ooo000Jooooo`?oo`006_ooool3ool001[ooooo0ooo000Jooooo`?oo`006_ooool3
ool001[ooooo0ooo000=ooooo`00oooooolQooooo`00oooooolQooooo`00oooooolQooooo`00oooo
oolQooooo`00oooooolQooooo`00oooooolQooooo`00oooooolQooooo`00oooooolQooooo`00oooo
oolQooooo`00oooooolQooooo`00oooooolQooooo`00oooooolQooooo`00oooooolQooooo`00oooo
oolQooooo`00oooooolQooooo`00oooooolQooooo`00oooooolQooooo`00oooooolQooooo`00oooo
oolQooooo`00oooooolQooooo`00oooooolQooooo`00oooooolQooooo`002oooool3ool001[ooooo
0ooo000Jooooo`?oo`006_ooool3ool001[ooooo0ooo000Jooooo`?oo`006_ooool3ool001[ooooo
0ooo000Jooooo`?oo`006_ooool3ool000gooooo000:ooooo`Goo`006?ooool5ool001Sooooo1Ooo
000Hooooo`Goo`006?ooool5ool001Sooooo1Ooo000Hooooo`Goo`006?ooool5ool001Sooooo1Ooo
000Hooooo`Goo`003?ooool000Wooooo1ooo000Fooooo`Ooo`005_ooool7ool001Kooooo1ooo000F
ooooo`Ooo`005_ooool7ool001Kooooo1ooo000Fooooo`Ooo`005_ooool7ool001Kooooo1ooo000;
ooooo`002Oooool7ool001Kooooo1ooo000Fooooo`Ooo`005_ooool7ool001Kooooo1ooo000Foooo
o`Ooo`005_ooool7ool001Kooooo1ooo000Fooooo`Ooo`005_ooool7ool000_ooooo0009ooooo`Oo
o`005_ooool7ool001Kooooo1ooo000Fooooo`Ooo`005_ooool7ool001Kooooo1ooo000Fooooo`Oo
o`005_ooool7ool001Kooooo1ooo000Fooooo`Ooo`002oooool000[ooooo1Ooo000Hooooo`Goo`00
6?ooool5ool001Sooooo1Ooo000Hooooo`Goo`006?ooool5ool001Sooooo1Ooo000Hooooo`Goo`00
6?ooool5ool001Sooooo1Ooo000<ooooo`002oooool3ool001[ooooo0ooo000Jooooo`?oo`006_oo
ool3ool001[ooooo0ooo000Jooooo`?oo`006_ooool3ool001[ooooo0ooo000Jooooo`?oo`006_oo
ool3ool000gooooo003oooooob7ooooo003oooooob7ooooo003oooooob7ooooo003oooooob7ooooo
003oooooob7ooooo003oooooob7ooooo003oooooob7ooooo003oooooob7ooooo003oooooob7ooooo
003oooooob7ooooo003oooooob7ooooo003oooooob7ooooo003oooooob7ooooo003oooooob7ooooo
003oooooob7ooooo003oooooob7ooooo003oooooob7ooooo003oooooob7ooooo003oooooob7ooooo
003oooooob7ooooo003oooooob7ooooo003oooooob7ooooo000;ooooo`?oo`006_ooool3ool001[o
oooo0ooo000Jooooo`?oo`006_ooool3ool001[ooooo0ooo000Jooooo`?oo`006_ooool3ool001[o
oooo0ooo000Jooooo`?oo`003Oooool000[ooooo1Ooo000Hooooo`Goo`006?ooool5ool001Sooooo
1Ooo000Hooooo`Goo`006?ooool5ool001Sooooo1Ooo000Hooooo`Goo`006?ooool5ool001Sooooo
1Ooo000<ooooo`002Oooool7ool001Kooooo1ooo000Fooooo`Ooo`005_ooool7ool001Kooooo1ooo
000Fooooo`Ooo`005_ooool7ool001Kooooo1ooo000Fooooo`Ooo`005_ooool7ool000_ooooo0009
ooooo`Ooo`005_ooool7ool001Kooooo1ooo000Fooooo`Ooo`005_ooool7ool001Kooooo1ooo000F
ooooo`Ooo`005_ooool7ool001Kooooo1ooo000Fooooo`Ooo`002oooool000Wooooo1ooo000Foooo
o`Ooo`005_ooool7ool001Kooooo1ooo000Fooooo`Ooo`005_ooool7ool001Kooooo1ooo000Foooo
o`Ooo`005_ooool7ool001Kooooo1ooo000;ooooo`002_ooool5ool001Sooooo1Ooo000Hooooo`Go
o`006?ooool5ool001Sooooo1Ooo000Hooooo`Goo`006?ooool5ool001Sooooo1Ooo000Hooooo`Go
o`006?ooool5ool000cooooo000;ooooo`?oo`006_ooool3ool001[ooooo0ooo000Jooooo`?oo`00
6_ooool3ool001[ooooo0ooo000Jooooo`?oo`006_ooool3ool001[ooooo0ooo000Jooooo`?oo`00
3Oooool00?oooooo8Oooool00?oooooo8Oooool00?oooooo8Oooool00?oooooo8Oooool00?oooooo
8Oooool00?oooooo8Oooool00?oooooo8Oooool00?oooooo8Oooool00?oooooo8Oooool00?oooooo
8Oooool00?oooooo8Oooool00?oooooo8Oooool00?oooooo8Oooool00?oooooo8Oooool00?oooooo
8Oooool00?oooooo8Oooool00?oooooo8Oooool00?oooooo8Oooool00?oooooo8Oooool00?oooooo
8Oooool00?oooooo8Oooool00?oooooo8Oooool000_ooooo0ooo000Jooooo`?oo`006_ooool3ool0
01[ooooo0ooo000Jooooo`?oo`006_ooool3ool001[ooooo0ooo000Jooooo`?oo`006_ooool3ool0
01[ooooo0ooo000=ooooo`002_ooool5ool001Sooooo1Ooo000Hooooo`Goo`006?ooool5ool001So
oooo1Ooo000Hooooo`Goo`006?ooool5ool001Sooooo1Ooo000Hooooo`Goo`006?ooool5ool000co
oooo0009ooooo`Ooo`005_ooool7ool001Kooooo1ooo000Fooooo`Ooo`005_ooool7ool001Kooooo
1ooo000Fooooo`Ooo`005_ooool7ool001Kooooo1ooo000Fooooo`Ooo`002oooool000Wooooo1ooo
000Fooooo`Ooo`005_ooool7ool001Kooooo1ooo000Fooooo`Ooo`005_ooool7ool001Kooooo1ooo
000Fooooo`Ooo`005_ooool7ool001Kooooo1ooo000;ooooo`002Oooool7ool001Kooooo1ooo000F
ooooo`Ooo`005_ooool7ool001Kooooo1ooo000Fooooo`Ooo`005_ooool7ool001Kooooo1ooo000F
ooooo`Ooo`005_ooool7ool000_ooooo000:ooooo`Goo`006?ooool5ool001Sooooo1Ooo000Hoooo
o`Goo`006?ooool5ool001Sooooo1Ooo000Hooooo`Goo`006?ooool5ool001Sooooo1Ooo000Hoooo
o`Goo`003?ooool000_ooooo0ooo000Jooooo`?oo`006_ooool3ool001[ooooo0ooo000Jooooo`?o
o`006_ooool3ool001[ooooo0ooo000Jooooo`?oo`006_ooool3ool001[ooooo0ooo000=ooooo`00
oooooolQooooo`00oooooolQooooo`00oooooolQooooo`00oooooolQooooo`00oooooolQooooo`00
oooooolQooooo`00oooooolQooooo`00oooooolQooooo`00oooooolQooooo`00oooooolQooooo`00
oooooolQooooo`00oooooolQooooo`00oooooolQooooo`00oooooolQooooo`00oooooolQooooo`00
oooooolQooooo`00oooooolQooooo`00oooooolQooooo`00oooooolQooooo`00oooooolQooooo`00
oooooolQooooo`00oooooolQooooo`002oooool3ool001[ooooo0ooo000Jooooo`?oo`006_ooool3
ool001[ooooo0ooo000Jooooo`?oo`006_ooool3ool001[ooooo0ooo000Jooooo`?oo`006_ooool3
ool000gooooo000:ooooo`Goo`006?ooool5ool001Sooooo1Ooo000Hooooo`Goo`006?ooool5ool0
01Sooooo1Ooo000Hooooo`Goo`006?ooool5ool001Sooooo1Ooo000Hooooo`Goo`003?ooool000Wo
oooo1ooo000Fooooo`Ooo`005_ooool7ool001Kooooo1ooo000Fooooo`Ooo`005_ooool7ool001Ko
oooo1ooo000Fooooo`Ooo`005_ooool7ool001Kooooo1ooo000;ooooo`002Oooool7ool001Kooooo
1ooo000Fooooo`Ooo`005_ooool7ool001Kooooo1ooo000Fooooo`Ooo`005_ooool7ool001Kooooo
1ooo000Fooooo`Ooo`005_ooool7ool000_ooooo0009ooooo`Ooo`005_ooool7ool001Kooooo1ooo
000Fooooo`Ooo`005_ooool7ool001Kooooo1ooo000Fooooo`Ooo`005_ooool7ool001Kooooo1ooo
000Fooooo`Ooo`002oooool000[ooooo1Ooo000Hooooo`Goo`006?ooool5ool001Sooooo1Ooo000H
ooooo`Goo`006?ooool5ool001Sooooo1Ooo000Hooooo`Goo`006?ooool5ool001Sooooo1Ooo000<
ooooo`002oooool3ool001[ooooo0ooo000Jooooo`?oo`006_ooool3ool001[ooooo0ooo000Joooo
o`?oo`006_ooool3ool001[ooooo0ooo000Jooooo`?oo`006_ooool3ool000gooooo003oooooob7o
oooo003oooooob7ooooo003oooooob7ooooo003oooooob7ooooo003oooooob7ooooo003oooooob7o
oooo003oooooob7ooooo003oooooob7ooooo003oooooob7ooooo003oooooob7ooooo003oooooob7o
oooo003oooooob7ooooo003oooooob7ooooo003oooooob7ooooo003oooooob7ooooo003oooooob7o
oooo003oooooob7ooooo003oooooob7ooooo003oooooob7ooooo003oooooob7ooooo003oooooob7o
oooo003oooooob7ooooo000;ooooo`?oo`006_ooool3ool001[ooooo0ooo000Jooooo`?oo`006_oo
ool3ool001[ooooo0ooo000Jooooo`?oo`006_ooool3ool001[ooooo0ooo000Jooooo`?oo`003Ooo
ool000[ooooo1Ooo000Hooooo`Goo`006?ooool5ool001Sooooo1Ooo000Hooooo`Goo`006?ooool5
ool001Sooooo1Ooo000Hooooo`Goo`006?ooool5ool001Sooooo1Ooo000<ooooo`002Oooool7ool0
01Kooooo1ooo000Fooooo`Ooo`005_ooool7ool001Kooooo1ooo000Fooooo`Ooo`005_ooool7ool0
01Kooooo1ooo000Fooooo`Ooo`005_ooool7ool000_ooooo0009ooooo`Ooo`005_ooool7ool001Ko
oooo1ooo000Fooooo`Ooo`005_ooool7ool001Kooooo1ooo000Fooooo`Ooo`005_ooool7ool001Ko
oooo1ooo000Fooooo`Ooo`002oooool000Wooooo1ooo000Fooooo`Ooo`005_ooool7ool001Kooooo
1ooo000Fooooo`Ooo`005_ooool7ool001Kooooo1ooo000Fooooo`Ooo`005_ooool7ool001Kooooo
1ooo000;ooooo`002_ooool5ool001Sooooo1Ooo000Hooooo`Goo`006?ooool5ool001Sooooo1Ooo
000Hooooo`Goo`006?ooool5ool001Sooooo1Ooo000Hooooo`Goo`006?ooool5ool000cooooo000;
ooooo`?oo`006_ooool3ool001[ooooo0ooo000Jooooo`?oo`006_ooool3ool001[ooooo0ooo000J
ooooo`?oo`006_ooool3ool001[ooooo0ooo000Jooooo`?oo`003Oooool00?oooooo8Oooool00?oo
oooo8Oooool00?oooooo8Oooool00?oooooo8Oooool00?oooooo8Oooool00?oooooo8Oooool00?oo
oooo8Oooool00?oooooo8Oooool00?oooooo8Oooool00?oooooo8Oooool00?oooooo8Oooool00?oo
oooo8Oooool00?oooooo8Oooool00?oooooo8Oooool00?oooooo8Oooool00?oooooo8Oooool00?oo
oooo8Oooool00?oooooo8Oooool00?oooooo8Oooool00?oooooo8Oooool00?oooooo8Oooool00?oo
oooo8Oooool000_ooooo0ooo000Jooooo`?oo`006_ooool3ool001[ooooo0ooo000Jooooo`?oo`00
6_ooool3ool001[ooooo0ooo000Jooooo`?oo`006_ooool3ool001[ooooo0ooo000=ooooo`002_oo
ool5ool001Sooooo1Ooo000Hooooo`Goo`006?ooool5ool001Sooooo1Ooo000Hooooo`Goo`006?oo
ool5ool001Sooooo1Ooo000Hooooo`Goo`006?ooool5ool000cooooo0009ooooo`Ooo`005_ooool7
ool001Kooooo1ooo000Fooooo`Ooo`005_ooool7ool001Kooooo1ooo000Fooooo`Ooo`005_ooool7
ool001Kooooo1ooo000Fooooo`Ooo`002oooool000Wooooo1ooo000Fooooo`Ooo`005_ooool7ool0
01Kooooo1ooo000Fooooo`Ooo`005_ooool7ool001Kooooo1ooo000Fooooo`Ooo`005_ooool7ool0
01Kooooo1ooo000;ooooo`002Oooool7ool001Kooooo1ooo000Fooooo`Ooo`005_ooool7ool001Ko
oooo1ooo000Fooooo`Ooo`005_ooool7ool001Kooooo1ooo000Fooooo`Ooo`005_ooool7ool000_o
oooo000:ooooo`Goo`006?ooool5ool001Sooooo1Ooo000Hooooo`Goo`006?ooool5ool001Sooooo
1Ooo000Hooooo`Goo`006?ooool5ool001Sooooo1Ooo000Hooooo`Goo`003?ooool000_ooooo0ooo
000Jooooo`?oo`006_ooool3ool001[ooooo0ooo000Jooooo`?oo`006_ooool3ool001[ooooo0ooo
000Jooooo`?oo`006_ooool3ool001[ooooo0ooo000=ooooo`00oooooolQooooo`00oooooolQoooo
o`00oooooolQooooo`00oooooolQooooo`00oooooolQooooo`00oooooolQooooo`00oooooolQoooo
o`00oooooolQooooo`00oooooolQooooo`00oooooolQooooo`00oooooolQooooo`00oooooolQoooo
o`00oooooolQooooo`00oooooolQooooo`00oooooolQooooo`00oooooolQooooo`00oooooolQoooo
o`00oooooolQooooo`00oooooolQooooo`00oooooolQooooo`00oooooolQooooo`00oooooolQoooo
o`002oooool3ool001[ooooo0ooo000Jooooo`?oo`006_ooool3ool001[ooooo0ooo000Jooooo`?o
o`006_ooool3ool001[ooooo0ooo000Jooooo`?oo`006_ooool3ool000gooooo000:ooooo`Goo`00
6?ooool5ool001Sooooo1Ooo000Hooooo`Goo`006?ooool5ool001Sooooo1Ooo000Hooooo`Goo`00
6?ooool5ool001Sooooo1Ooo000Hooooo`Goo`003?ooool000Wooooo1ooo000Fooooo`Ooo`005_oo
ool7ool001Kooooo1ooo000Fooooo`Ooo`005_ooool7ool001Kooooo1ooo000Fooooo`Ooo`005_oo
ool7ool001Kooooo1ooo000;ooooo`002Oooool7ool001Kooooo1ooo000Fooooo`Ooo`005_ooool7
ool001Kooooo1ooo000Fooooo`Ooo`005_ooool7ool001Kooooo1ooo000Fooooo`Ooo`005_ooool7
ool000_ooooo0009ooooo`Ooo`005_ooool7ool001Kooooo1ooo000Fooooo`Ooo`005_ooool7ool0
01Kooooo1ooo000Fooooo`Ooo`005_ooool7ool001Kooooo1ooo000Fooooo`Ooo`002oooool000[o
oooo1Ooo000Hooooo`Goo`006?ooool5ool001Sooooo1Ooo000Hooooo`Goo`006?ooool5ool001So
oooo1Ooo000Hooooo`Goo`006?ooool5ool001Sooooo1Ooo000<ooooo`002oooool3ool001[ooooo
0ooo000Jooooo`?oo`006_ooool3ool001[ooooo0ooo000Jooooo`?oo`006_ooool3ool001[ooooo
0ooo000Jooooo`?oo`006_ooool3ool000gooooo003oooooob7ooooo003oooooob7ooooo003ooooo
ob7ooooo003oooooob7ooooo003oooooob7ooooo003oooooob7ooooo003oooooob7ooooo003ooooo
ob7ooooo003oooooob7ooooo0000\
\>"],
  ImageRangeCache->{{{0, 287}, {287, 0}} -> {-0.0500054, -0.0500054, \
0.00383279, 0.00383279}},
  CellTags->{"b:3", "LocalInteractions:10"}]
}, Open  ]]
}, Closed]]
}, Open  ]]
},
FrontEndVersion->"5.0 for Macintosh",
ScreenRectangle->{{0, 1152}, {0, 701}},
WindowSize->{520, 578},
WindowMargins->{{Automatic, 53}, {34, Automatic}},
StyleDefinitions -> "HelpBrowser.nb"
]

(*******************************************************************
Cached data follows.  If you edit this Notebook file directly, not
using Mathematica, you must remove the line containing CacheID at
the top of  the file.  The cache data will then be recreated when
you save this file from within Mathematica.
*******************************************************************)

(*CellTagsOutline
CellTagsIndex->{
  "b:3"->{
    Cell[1776, 53, 78, 1, 38, "ObjectName",
      CellTags->{"b:3", "LocalInteractions:10"}],
    Cell[1857, 56, 254, 10, 32, "Usage",
      CellTags->{"b:3", "LocalInteractions:10"}],
    Cell[2136, 70, 78, 1, 38, "ExampleSection",
      CellTags->{"b:3", "LocalInteractions:10"}],
    Cell[2239, 75, 187, 4, 42, "Input",
      CellTags->{"b:3", "LocalInteractions:10"}],
    Cell[2429, 81, 74795, 1503, 294, 8642, 681, "GraphicsData", 
    "PostScript", "Graphics",
      CellTags->{"b:3", "LocalInteractions:10"}],
    Cell[77239, 1587, 121, 3, 26, "Input",
      CellTags->{"b:3", "LocalInteractions:10"}],
    Cell[77385, 1594, 120, 3, 26, "Input",
      CellTags->{"b:3", "LocalInteractions:10"}],
    Cell[77508, 1599, 16524, 317, 294, 2493, 138, "GraphicsData", 
    "PostScript", "Graphics",
      CellTags->{"b:3", "LocalInteractions:10"}]},
  "LocalInteractions:10"->{
    Cell[1776, 53, 78, 1, 38, "ObjectName",
      CellTags->{"b:3", "LocalInteractions:10"}],
    Cell[1857, 56, 254, 10, 32, "Usage",
      CellTags->{"b:3", "LocalInteractions:10"}],
    Cell[2136, 70, 78, 1, 38, "ExampleSection",
      CellTags->{"b:3", "LocalInteractions:10"}],
    Cell[2239, 75, 187, 4, 42, "Input",
      CellTags->{"b:3", "LocalInteractions:10"}],
    Cell[2429, 81, 74795, 1503, 294, 8642, 681, "GraphicsData", 
    "PostScript", "Graphics",
      CellTags->{"b:3", "LocalInteractions:10"}],
    Cell[77239, 1587, 121, 3, 26, "Input",
      CellTags->{"b:3", "LocalInteractions:10"}],
    Cell[77385, 1594, 120, 3, 26, "Input",
      CellTags->{"b:3", "LocalInteractions:10"}],
    Cell[77508, 1599, 16524, 317, 294, 2493, 138, "GraphicsData", 
    "PostScript", "Graphics",
      CellTags->{"b:3", "LocalInteractions:10"}]}
  }
*)

(*CellTagsIndex
CellTagsIndex->{
  {"b:3", 94691, 1937},
  {"LocalInteractions:10", 95571, 1956}
  }
*)

(*NotebookFileOutline
Notebook[{

Cell[CellGroupData[{
Cell[1776, 53, 78, 1, 38, "ObjectName",
  CellTags->{"b:3", "LocalInteractions:10"}],
Cell[1857, 56, 254, 10, 32, "Usage",
  CellTags->{"b:3", "LocalInteractions:10"}],

Cell[CellGroupData[{
Cell[2136, 70, 78, 1, 38, "ExampleSection",
  CellTags->{"b:3", "LocalInteractions:10"}],

Cell[CellGroupData[{
Cell[2239, 75, 187, 4, 42, "Input",
  CellTags->{"b:3", "LocalInteractions:10"}],
Cell[2429, 81, 74795, 1503, 294, 8642, 681, "GraphicsData", "PostScript", \
"Graphics",
  CellTags->{"b:3", "LocalInteractions:10"}]
}, Open  ]],
Cell[77239, 1587, 121, 3, 26, "Input",
  CellTags->{"b:3", "LocalInteractions:10"}],

Cell[CellGroupData[{
Cell[77385, 1594, 120, 3, 26, "Input",
  CellTags->{"b:3", "LocalInteractions:10"}],
Cell[77508, 1599, 16524, 317, 294, 2493, 138, "GraphicsData", "PostScript", \
"Graphics",
  CellTags->{"b:3", "LocalInteractions:10"}]
}, Open  ]]
}, Closed]]
}, Open  ]]
}
]
*)



(*******************************************************************
End of Mathematica Notebook file.
*******************************************************************)

