(************** Content-type: application/mathematica **************
                     CreatedBy='Mathematica 5.0'

                    Mathematica-Compatible Notebook

This notebook can be used with any Mathematica-compatible
application, such as Mathematica, MathReader or Publicon. The data
for the notebook starts with the line containing stars above.

To get the notebook into a Mathematica-compatible application, do
one of the following:

* Save the data starting with the line of stars above into a file
  with a name ending in .nb, then open the file inside the
  application;

* Copy the data starting with the line of stars above to the
  clipboard, then use the Paste menu command inside the application.

Data for notebooks contains only printable 7-bit ASCII and can be
sent directly in email or through ftp in text mode.  Newlines can be
CR, LF or CRLF (Unix, Macintosh or MS-DOS style).

NOTE: If you modify the data for this notebook not in a Mathematica-
compatible application, you must delete the line below containing
the word CacheID, otherwise Mathematica-compatible applications may
try to use invalid cache data.

For more information on notebooks and Mathematica-compatible 
applications, contact Wolfram Research:
  web: http://www.wolfram.com
  email: info@wolfram.com
  phone: +1-217-398-0700 (U.S.)

Notebook reader applications are available free of charge from 
Wolfram Research.
*******************************************************************)

(*CacheID: 232*)


(*NotebookFileLineBreakTest
NotebookFileLineBreakTest*)
(*NotebookOptionsPosition[     90664,       1843]*)
(*NotebookOutlinePosition[     93520,       1916]*)
(*  CellTagsIndexPosition[     93408,       1909]*)
(*WindowFrame->Normal*)



Notebook[{

Cell[CellGroupData[{
Cell["HexGraph", "ObjectName",
  CellTags->{"b:11", "LocalInteractions:16"}],

Cell[TextData[{
  "\[FilledSmallSquare] HexGraph[",
  StyleBox["cols, rows",
    FontSlant->"Italic"],
  "] creates a hexagonal lattice having the specified shape."
}], "Usage",
  CellTags->{"b:11", "LocalInteractions:16"}],

Cell[TextData[{
  "\[FilledSmallSquare] Unequal column heights are obtained by setting the ",
  StyleBox["EqualColumnHeights",
    FontFamily->"Courier"],
  " option to ",
  StyleBox["False",
    FontFamily->"Courier"],
  "."
}], "Notes",
  CellTags->{"b:11", "LocalInteractions:16"}],

Cell[CellGroupData[{

Cell["Examples", "ExampleSection",
  CellTags->{"b:11", "LocalInteractions:16"}],

Cell["The default makes all columns have the same height.", "Text",
  CellTags->{"b:11", "LocalInteractions:16"}],

Cell[CellGroupData[{

Cell[BoxData[
    \(\(HexGraph[5, 5] // ShowGraph;\)\)], "Input",
  CellLabel->"In[35]:=",
  CellTags->{"b:11", "LocalInteractions:16"}],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: 1 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.0574845 1.14969 -0.0327869 0.983607 [
[ 0 0 0 0 ]
[ 1 1 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 0 m
1 0 L
1 1 L
0 1 L
closepath
clip
newpath
0 0 0 r
.005 w
[ ] 0 setdash
.05748 .13115 m
.1128 .04918 L
s
.05748 .13115 m
.1128 .21311 L
s
.05748 .29508 m
.1128 .21311 L
s
.05748 .29508 m
.1128 .37705 L
s
.05748 .45902 m
.1128 .37705 L
s
.05748 .45902 m
.1128 .54098 L
s
.05748 .62295 m
.1128 .54098 L
s
.05748 .62295 m
.1128 .70492 L
s
.05748 .78689 m
.1128 .70492 L
s
.05748 .78689 m
.1128 .86885 L
s
.1128 .04918 m
.22343 .04918 L
s
.1128 .21311 m
.22343 .21311 L
s
.1128 .37705 m
.22343 .37705 L
s
.1128 .54098 m
.22343 .54098 L
s
.1128 .70492 m
.22343 .70492 L
s
.1128 .86885 m
.22343 .86885 L
s
.22343 .04918 m
.27874 .13115 L
s
.22343 .21311 m
.27874 .13115 L
s
.22343 .21311 m
.27874 .29508 L
s
.22343 .37705 m
.27874 .29508 L
s
.22343 .37705 m
.27874 .45902 L
s
.22343 .54098 m
.27874 .45902 L
s
.22343 .54098 m
.27874 .62295 L
s
.22343 .70492 m
.27874 .62295 L
s
.22343 .70492 m
.27874 .78689 L
s
.22343 .86885 m
.27874 .78689 L
s
.22343 .86885 m
.27874 .95082 L
s
.27874 .13115 m
.38937 .13115 L
s
.27874 .29508 m
.38937 .29508 L
s
.27874 .45902 m
.38937 .45902 L
s
.27874 .62295 m
.38937 .62295 L
s
.27874 .78689 m
.38937 .78689 L
s
.27874 .95082 m
.38937 .95082 L
s
.38937 .13115 m
.44469 .04918 L
s
.38937 .13115 m
.44469 .21311 L
s
.38937 .29508 m
.44469 .21311 L
s
.38937 .29508 m
.44469 .37705 L
s
.38937 .45902 m
.44469 .37705 L
s
.38937 .45902 m
.44469 .54098 L
s
.38937 .62295 m
.44469 .54098 L
s
.38937 .62295 m
.44469 .70492 L
s
.38937 .78689 m
.44469 .70492 L
s
.38937 .78689 m
.44469 .86885 L
s
.38937 .95082 m
.44469 .86885 L
s
.44469 .04918 m
.55531 .04918 L
s
.44469 .21311 m
.55531 .21311 L
s
.44469 .37705 m
.55531 .37705 L
s
.44469 .54098 m
.55531 .54098 L
s
.44469 .70492 m
.55531 .70492 L
s
.44469 .86885 m
.55531 .86885 L
s
.55531 .04918 m
.61063 .13115 L
s
.55531 .21311 m
.61063 .13115 L
s
.55531 .21311 m
.61063 .29508 L
s
.55531 .37705 m
.61063 .29508 L
s
.55531 .37705 m
.61063 .45902 L
s
.55531 .54098 m
.61063 .45902 L
s
.55531 .54098 m
.61063 .62295 L
s
.55531 .70492 m
.61063 .62295 L
s
.55531 .70492 m
.61063 .78689 L
s
.55531 .86885 m
.61063 .78689 L
s
.55531 .86885 m
.61063 .95082 L
s
.61063 .13115 m
.72126 .13115 L
s
.61063 .29508 m
.72126 .29508 L
s
.61063 .45902 m
.72126 .45902 L
s
.61063 .62295 m
.72126 .62295 L
s
.61063 .78689 m
.72126 .78689 L
s
.61063 .95082 m
.72126 .95082 L
s
.72126 .13115 m
.77657 .04918 L
s
.72126 .13115 m
.77657 .21311 L
s
.72126 .29508 m
.77657 .21311 L
s
.72126 .29508 m
.77657 .37705 L
s
.72126 .45902 m
.77657 .37705 L
s
.72126 .45902 m
.77657 .54098 L
s
.72126 .62295 m
.77657 .54098 L
s
.72126 .62295 m
.77657 .70492 L
s
.72126 .78689 m
.77657 .70492 L
s
.72126 .78689 m
.77657 .86885 L
s
.72126 .95082 m
.77657 .86885 L
s
.77657 .04918 m
.8872 .04918 L
s
.77657 .21311 m
.8872 .21311 L
s
.77657 .37705 m
.8872 .37705 L
s
.77657 .54098 m
.8872 .54098 L
s
.77657 .70492 m
.8872 .70492 L
s
.77657 .86885 m
.8872 .86885 L
s
.8872 .04918 m
.94252 .13115 L
s
.8872 .21311 m
.94252 .13115 L
s
.8872 .21311 m
.94252 .29508 L
s
.8872 .37705 m
.94252 .29508 L
s
.8872 .37705 m
.94252 .45902 L
s
.8872 .54098 m
.94252 .45902 L
s
.8872 .54098 m
.94252 .62295 L
s
.8872 .70492 m
.94252 .62295 L
s
.8872 .70492 m
.94252 .78689 L
s
.8872 .86885 m
.94252 .78689 L
s
.025 w
.05748 .13115 Mdot
.05748 .29508 Mdot
.05748 .45902 Mdot
.05748 .62295 Mdot
.05748 .78689 Mdot
.1128 .04918 Mdot
.1128 .21311 Mdot
.1128 .37705 Mdot
.1128 .54098 Mdot
.1128 .70492 Mdot
.1128 .86885 Mdot
.22343 .04918 Mdot
.22343 .21311 Mdot
.22343 .37705 Mdot
.22343 .54098 Mdot
.22343 .70492 Mdot
.22343 .86885 Mdot
.27874 .13115 Mdot
.27874 .29508 Mdot
.27874 .45902 Mdot
.27874 .62295 Mdot
.27874 .78689 Mdot
.27874 .95082 Mdot
.38937 .13115 Mdot
.38937 .29508 Mdot
.38937 .45902 Mdot
.38937 .62295 Mdot
.38937 .78689 Mdot
.38937 .95082 Mdot
.44469 .04918 Mdot
.44469 .21311 Mdot
.44469 .37705 Mdot
.44469 .54098 Mdot
.44469 .70492 Mdot
.44469 .86885 Mdot
.55531 .04918 Mdot
.55531 .21311 Mdot
.55531 .37705 Mdot
.55531 .54098 Mdot
.55531 .70492 Mdot
.55531 .86885 Mdot
.61063 .13115 Mdot
.61063 .29508 Mdot
.61063 .45902 Mdot
.61063 .62295 Mdot
.61063 .78689 Mdot
.61063 .95082 Mdot
.72126 .13115 Mdot
.72126 .29508 Mdot
.72126 .45902 Mdot
.72126 .62295 Mdot
.72126 .78689 Mdot
.72126 .95082 Mdot
.77657 .04918 Mdot
.77657 .21311 Mdot
.77657 .37705 Mdot
.77657 .54098 Mdot
.77657 .70492 Mdot
.77657 .86885 Mdot
.8872 .04918 Mdot
.8872 .21311 Mdot
.8872 .37705 Mdot
.8872 .54098 Mdot
.8872 .70492 Mdot
.8872 .86885 Mdot
.94252 .13115 Mdot
.94252 .29508 Mdot
.94252 .45902 Mdot
.94252 .62295 Mdot
.94252 .78689 Mdot
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  CellLabel->"From In[35]:=",
  ImageSize->{288, 288},
  ImageMargins->{{0, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40004P000182000`400?l00000o`00003ooooooolQ
ooooo`00oooooolQooooo`00oooooolQooooo`00oooooolQooooo`00oooooolQooooo`00oooooolQ
ooooo`00oooooolQooooo`00oooooolQooooo`00oooooolQooooo`00oooooolQooooo`00oooooolQ
ooooo`00oooooolQooooo`007oooool3o`0001gooooo0ol0000looooo`?o00007Oooool3o`0003co
oooo0ol0000Mooooo`?o00008?ooool001kooooo1Ol0000Kooooo`Go0000>_ooool5o`0001_ooooo
1Ol0000jooooo`Go00006oooool5o`0001oooooo000Mooooo`Oo00006Oooool7o`0003Sooooo1ol0
000Iooooo`Oo0000>?ooool7o`0001Wooooo1ol0000Nooooo`007OoooolWo`0003Sooooo9ol0000h
ooooobOo00007_ooool001gooooo1ol0000Iooooo`Oo0000>?ooool7o`0001Wooooo1ol0000hoooo
o`Oo00006Oooool7o`0001kooooo000Nooooo`Go00006oooool5o`0003[ooooo1Ol0000Kooooo`Go
0000>_ooool5o`0001_ooooo1Ol0000Oooooo`007_ooool4o`0001gooooo1?l0000jooooo`Co0000
7Oooool4o`0003[ooooo1?l0000Mooooo`Co00007oooool001kooooo00?o0000ooooooooool08Ooo
ool00ol0003oooooooooo`0hooooo`03o`000?oooooooooo027ooooo00?o0000ooooooooool0>?oo
ool00ol0003oooooooooo`0Qooooo`03o`000?oooooooooo01gooooo000Mooooo`03o`000?oooooo
oooo02?ooooo00?o0000ooooooooool0=_ooool00ol0003oooooooooo`0Sooooo`03o`000?oooooo
oooo03Kooooo00?o0000ooooooooool08oooool00ol0003oooooooooo`0Looooo`007?ooool00ol0
003oooooooooo`0Uooooo`03o`000?oooooooooo03Cooooo00?o0000ooooooooool09Oooool00ol0
003oooooooooo`0dooooo`03o`000?oooooooooo02Gooooo00?o0000ooooooooool06oooool001_o
oooo00?o0000ooooooooool09oooool00ol0003oooooooooo`0booooo`03o`000?oooooooooo02Oo
oooo00?o0000ooooooooool0<oooool00ol0003oooooooooo`0Vooooo`03o`000?oooooooooo01[o
oooo000Kooooo`03o`000?oooooooooo02Oooooo00?o0000ooooooooool0<_ooool00ol0003ooooo
ooooo`0Wooooo`03o`000?oooooooooo03;ooooo00?o0000ooooooooool09oooool00ol0003ooooo
ooooo`0Jooooo`006_ooool00ol0003oooooooooo`0Yooooo`03o`000?oooooooooo033ooooo00?o
0000ooooooooool0:Oooool00ol0003oooooooooo`0`ooooo`03o`000?oooooooooo02Wooooo00?o
0000ooooooooool06Oooool001Wooooo00?o0000ooooooooool0:oooool00ol0003oooooooooo`0^
ooooo`03o`000?oooooooooo02_ooooo00?o0000ooooooooool0;oooool00ol0003oooooooooo`0Z
ooooo`03o`000?oooooooooo01Sooooo000Iooooo`03o`000?oooooooooo02_ooooo00?o0000oooo
ooooool0;_ooool00ol0003oooooooooo`0[ooooo`03o`000?oooooooooo02kooooo00?o0000oooo
ooooool0:oooool00ol0003oooooooooo`0Hooooo`006?ooool00ol0003oooooooooo`0]ooooo`03
o`000?oooooooooo02cooooo00?o0000ooooooooool0;Oooool00ol0003oooooooooo`0/ooooo`03
o`000?oooooooooo02gooooo00?o0000ooooooooool05oooool001Oooooo00?o0000ooooooooool0
;oooool00ol0003oooooooooo`0Zooooo`03o`000?oooooooooo02oooooo00?o0000ooooooooool0
:oooool00ol0003oooooooooo`0^ooooo`03o`000?oooooooooo01Kooooo000Gooooo`03o`000?oo
oooooooo02oooooo00?o0000ooooooooool0:_ooool00ol0003oooooooooo`0_ooooo`03o`000?oo
oooooooo02[ooooo00?o0000ooooooooool0;oooool00ol0003oooooooooo`0Fooooo`005_ooool0
0ol0003oooooooooo`0aooooo`03o`000?oooooooooo02Sooooo00?o0000ooooooooool0<Oooool0
0ol0003oooooooooo`0Yooooo`03o`000?oooooooooo033ooooo00?o0000ooooooooool05Oooool0
01Gooooo00?o0000ooooooooool0<oooool00ol0003oooooooooo`0Vooooo`03o`000?oooooooooo
03?ooooo00?o0000ooooooooool09oooool00ol0003oooooooooo`0booooo`03o`000?oooooooooo
01Cooooo000Eooooo`03o`000?oooooooooo03?ooooo00?o0000ooooooooool09_ooool00ol0003o
ooooooooo`0cooooo`03o`000?oooooooooo02Kooooo00?o0000ooooooooool0<oooool00ol0003o
ooooooooo`0Dooooo`005?ooool00ol0003oooooooooo`0eooooo`03o`000?oooooooooo02Cooooo
00?o0000ooooooooool0=Oooool00ol0003oooooooooo`0Uooooo`03o`000?oooooooooo03Cooooo
00?o0000ooooooooool04oooool001?ooooo00?o0000ooooooooool0=oooool00ol0003ooooooooo
o`0Rooooo`03o`000?oooooooooo03Oooooo00?o0000ooooooooool08oooool00ol0003ooooooooo
o`0fooooo`03o`000?oooooooooo01;ooooo000?ooooo`Co0000>oooool3o`0001gooooo1?l0000k
ooooo`Co00007?ooool3o`000003ooooool0003ooooo03Wooooo1?l0000@ooooo`003_ooool5o`00
03[ooooo1Ol0000Kooooo`Go0000>oooool5o`0001[ooooo1_l0000jooooo`Go00003oooool000go
oooo1ol0000hooooo`Oo00006Oooool7o`0003Wooooo1ol0000Hooooo`Oo0000>Oooool7o`0000ko
oooo000=ooooo`Oo0000>?oooolWo`0003Wooooo9_l0000iooooo`Oo00003_ooool000gooooo1ol0
000hooooo`Oo00006Oooool7o`0003Wooooo1ol0000Hooooo`Oo0000>Oooool7o`0000kooooo000>
ooooo`Go0000>_ooool5o`0001_ooooo1Ol0000kooooo`Go00006_ooool5o`0003_ooooo1Ol0000?
ooooo`003oooool4o`0003_ooooo0ol0000Mooooo`Co0000>oooool4o`0001cooooo0ol000000ooo
oooo0000ooooo`0iooooo`Co00004?ooool001;ooooo00?o0000ooooooooool0>Oooool00ol0003o
ooooooooo`0Pooooo`03o`000?oooooooooo03Wooooo00?o0000ooooooooool08Oooool00ol0003o
ooooooooo`0hooooo`03o`000?oooooooooo017ooooo000Cooooo`03o`000?oooooooooo03Oooooo
00?o0000ooooooooool08_ooool00ol0003oooooooooo`0gooooo`03o`000?oooooooooo02?ooooo
00?o0000ooooooooool0=_ooool00ol0003oooooooooo`0Booooo`005?ooool00ol0003ooooooooo
o`0eooooo`03o`000?oooooooooo02Cooooo00?o0000ooooooooool0=Oooool00ol0003ooooooooo
o`0Tooooo`03o`000?oooooooooo03Gooooo00?o0000ooooooooool04oooool001Cooooo00?o0000
ooooooooool0=Oooool00ol0003oooooooooo`0Tooooo`03o`000?oooooooooo03Gooooo00?o0000
ooooooooool09Oooool00ol0003oooooooooo`0dooooo`03o`000?oooooooooo01?ooooo000Eoooo
o`03o`000?oooooooooo03?ooooo00?o0000ooooooooool09_ooool00ol0003oooooooooo`0coooo
o`03o`000?oooooooooo02Oooooo00?o0000ooooooooool0<_ooool00ol0003oooooooooo`0Doooo
o`005_ooool00ol0003oooooooooo`0aooooo`03o`000?oooooooooo02Sooooo00?o0000oooooooo
ool0<Oooool00ol0003oooooooooo`0Xooooo`03o`000?oooooooooo037ooooo00?o0000oooooooo
ool05Oooool001Kooooo00?o0000ooooooooool0<Oooool00ol0003oooooooooo`0Xooooo`03o`00
0?oooooooooo037ooooo00?o0000ooooooooool0:Oooool00ol0003oooooooooo`0`ooooo`03o`00
0?oooooooooo01Gooooo000Gooooo`03o`000?oooooooooo02oooooo00?o0000ooooooooool0:_oo
ool00ol0003oooooooooo`0_ooooo`03o`000?oooooooooo02_ooooo00?o0000ooooooooool0;_oo
ool00ol0003oooooooooo`0Fooooo`006?ooool00ol0003oooooooooo`0]ooooo`03o`000?oooooo
oooo02cooooo00?o0000ooooooooool0;Oooool00ol0003oooooooooo`0/ooooo`03o`000?oooooo
oooo02gooooo00?o0000ooooooooool05oooool001Sooooo00?o0000ooooooooool0;Oooool00ol0
003oooooooooo`0/ooooo`03o`000?oooooooooo02gooooo00?o0000ooooooooool0;Oooool00ol0
003oooooooooo`0/ooooo`03o`000?oooooooooo01Oooooo000Iooooo`03o`000?oooooooooo02_o
oooo00?o0000ooooooooool0;_ooool00ol0003oooooooooo`0[ooooo`03o`000?oooooooooo02ko
oooo00?o0000ooooooooool0:oooool00ol0003oooooooooo`0Hooooo`006_ooool00ol0003ooooo
ooooo`0Yooooo`03o`000?oooooooooo033ooooo00?o0000ooooooooool0:Oooool00ol0003ooooo
ooooo`0`ooooo`03o`000?oooooooooo02Wooooo00?o0000ooooooooool06Oooool001[ooooo00?o
0000ooooooooool0:Oooool00ol0003oooooooooo`0`ooooo`03o`000?oooooooooo02Wooooo00?o
0000ooooooooool0<Oooool00ol0003oooooooooo`0Xooooo`03o`000?oooooooooo01Wooooo000K
ooooo`03o`000?oooooooooo02Oooooo00?o0000ooooooooool0<_ooool00ol0003oooooooooo`0W
ooooo`03o`000?oooooooooo03;ooooo00?o0000ooooooooool09oooool00ol0003oooooooooo`0J
ooooo`007?ooool00ol0003oooooooooo`0Uooooo`03o`000?oooooooooo03Cooooo00?o0000oooo
ooooool09Oooool00ol0003oooooooooo`0dooooo`03o`000?oooooooooo02Gooooo00?o0000oooo
ooooool06oooool001cooooo00?o0000ooooooooool09Oooool00ol0003oooooooooo`0dooooo`03
o`000?oooooooooo02Gooooo00?o0000ooooooooool0=Oooool00ol0003oooooooooo`0Tooooo`03
o`000?oooooooooo01_ooooo000Mooooo`03o`000?oooooooooo02?ooooo00?o0000ooooooooool0
=_ooool00ol0003oooooooooo`0Sooooo`03o`000?oooooooooo03Kooooo00?o0000ooooooooool0
8oooool00ol0003oooooooooo`0Looooo`007_ooool4o`0001gooooo1?l0000jooooo`Co00007Ooo
ool4o`0003[ooooo1?l0000Mooooo`Co00007oooool001kooooo1Ol0000Kooooo`Go0000>_ooool5
o`0001_ooooo1Ol0000jooooo`Go00006oooool5o`0001oooooo000Mooooo`Oo00006Oooool7o`00
03Sooooo1ol0000Iooooo`Oo0000>?ooool7o`0001Wooooo1ol0000Nooooo`007OoooolWo`0003So
oooo9ol0000hooooobOo00007_ooool001gooooo1ol0000Iooooo`Oo0000>?ooool7o`0001Wooooo
1ol0000hooooo`Oo00006Oooool7o`0001kooooo000Nooooo`Go00006oooool5o`0003[ooooo1Ol0
000Kooooo`Go0000>_ooool5o`0001_ooooo1Ol0000Oooooo`007_ooool4o`0001gooooo1?l0000j
ooooo`Co00007Oooool4o`0003[ooooo1?l0000Mooooo`Co00007oooool001kooooo00?o0000oooo
ooooool08Oooool00ol0003oooooooooo`0hooooo`03o`000?oooooooooo027ooooo00?o0000oooo
ooooool0>?ooool00ol0003oooooooooo`0Qooooo`03o`000?oooooooooo01gooooo000Mooooo`03
o`000?oooooooooo02?ooooo00?o0000ooooooooool0=_ooool00ol0003oooooooooo`0Sooooo`03
o`000?oooooooooo03Kooooo00?o0000ooooooooool08oooool00ol0003oooooooooo`0Looooo`00
7?ooool00ol0003oooooooooo`0Uooooo`03o`000?oooooooooo03Cooooo00?o0000ooooooooool0
9Oooool00ol0003oooooooooo`0dooooo`03o`000?oooooooooo02Gooooo00?o0000ooooooooool0
6oooool001_ooooo00?o0000ooooooooool09oooool00ol0003oooooooooo`0booooo`03o`000?oo
oooooooo02Oooooo00?o0000ooooooooool0<oooool00ol0003oooooooooo`0Vooooo`03o`000?oo
oooooooo01[ooooo000Kooooo`03o`000?oooooooooo02Oooooo00?o0000ooooooooool0<_ooool0
0ol0003oooooooooo`0Wooooo`03o`000?oooooooooo03;ooooo00?o0000ooooooooool09oooool0
0ol0003oooooooooo`0Jooooo`006_ooool00ol0003oooooooooo`0Yooooo`03o`000?oooooooooo
033ooooo00?o0000ooooooooool0:Oooool00ol0003oooooooooo`0`ooooo`03o`000?oooooooooo
02Wooooo00?o0000ooooooooool06Oooool001Wooooo00?o0000ooooooooool0:oooool00ol0003o
ooooooooo`0^ooooo`03o`000?oooooooooo02_ooooo00?o0000ooooooooool0;oooool00ol0003o
ooooooooo`0Zooooo`03o`000?oooooooooo01Sooooo000Iooooo`03o`000?oooooooooo02_ooooo
00?o0000ooooooooool0;_ooool00ol0003oooooooooo`0[ooooo`03o`000?oooooooooo02kooooo
00?o0000ooooooooool0:oooool00ol0003oooooooooo`0Hooooo`006?ooool00ol0003ooooooooo
o`0]ooooo`03o`000?oooooooooo02cooooo00?o0000ooooooooool0;Oooool00ol0003ooooooooo
o`0/ooooo`03o`000?oooooooooo02gooooo00?o0000ooooooooool05oooool001Oooooo00?o0000
ooooooooool0;oooool00ol0003oooooooooo`0Zooooo`03o`000?oooooooooo02oooooo00?o0000
ooooooooool0:oooool00ol0003oooooooooo`0^ooooo`03o`000?oooooooooo01Kooooo000Goooo
o`03o`000?oooooooooo02oooooo00?o0000ooooooooool0:_ooool00ol0003oooooooooo`0_oooo
o`03o`000?oooooooooo02[ooooo00?o0000ooooooooool0;oooool00ol0003oooooooooo`0Foooo
o`005_ooool00ol0003oooooooooo`0aooooo`03o`000?oooooooooo02Sooooo00?o0000oooooooo
ool0<Oooool00ol0003oooooooooo`0Yooooo`03o`000?oooooooooo033ooooo00?o0000oooooooo
ool05Oooool001Gooooo00?o0000ooooooooool0<oooool00ol0003oooooooooo`0Vooooo`03o`00
0?oooooooooo03?ooooo00?o0000ooooooooool09oooool00ol0003oooooooooo`0booooo`03o`00
0?oooooooooo01Cooooo000Eooooo`03o`000?oooooooooo03?ooooo00?o0000ooooooooool09_oo
ool00ol0003oooooooooo`0cooooo`03o`000?oooooooooo02Kooooo00?o0000ooooooooool0<ooo
ool00ol0003oooooooooo`0Dooooo`005?ooool00ol0003oooooooooo`0eooooo`03o`000?oooooo
oooo02Cooooo00?o0000ooooooooool0=Oooool00ol0003oooooooooo`0Uooooo`03o`000?oooooo
oooo03Cooooo00?o0000ooooooooool04oooool001?ooooo00?o0000ooooooooool0=oooool00ol0
003oooooooooo`0Rooooo`03o`000?oooooooooo03Oooooo00?o0000ooooooooool08oooool00ol0
003oooooooooo`0fooooo`03o`000?oooooooooo01;ooooo000?ooooo`Co0000>oooool3o`0001go
oooo1?l0000kooooo`Co00007?ooool3o`000003ooooool0003ooooo03Wooooo1?l0000@ooooo`00
3_ooool5o`0003[ooooo1Ol0000Kooooo`Go0000>oooool5o`0001[ooooo1_l0000jooooo`Go0000
3oooool000gooooo1ol0000hooooo`Oo00006Oooool7o`0003Wooooo1ol0000Hooooo`Oo0000>Ooo
ool7o`0000kooooo000=ooooo`Oo0000>?oooolWo`0003Wooooo9_l0000iooooo`Oo00003_ooool0
00gooooo1ol0000hooooo`Oo00006Oooool7o`0003Wooooo1ol0000Hooooo`Oo0000>Oooool7o`00
00kooooo000>ooooo`Go0000>_ooool5o`0001_ooooo1Ol0000kooooo`Go00006_ooool5o`0003_o
oooo1Ol0000?ooooo`003oooool4o`0003_ooooo0ol0000Mooooo`Co0000>oooool4o`0001cooooo
0ol000000ooooooo0000ooooo`0iooooo`Co00004?ooool001;ooooo00?o0000ooooooooool0>Ooo
ool00ol0003oooooooooo`0Pooooo`03o`000?oooooooooo03Wooooo00?o0000ooooooooool08Ooo
ool00ol0003oooooooooo`0hooooo`03o`000?oooooooooo017ooooo000Cooooo`03o`000?oooooo
oooo03Oooooo00?o0000ooooooooool08_ooool00ol0003oooooooooo`0gooooo`03o`000?oooooo
oooo02?ooooo00?o0000ooooooooool0=_ooool00ol0003oooooooooo`0Booooo`005?ooool00ol0
003oooooooooo`0eooooo`03o`000?oooooooooo02Cooooo00?o0000ooooooooool0=Oooool00ol0
003oooooooooo`0Tooooo`03o`000?oooooooooo03Gooooo00?o0000ooooooooool04oooool001Co
oooo00?o0000ooooooooool0=Oooool00ol0003oooooooooo`0Tooooo`03o`000?oooooooooo03Go
oooo00?o0000ooooooooool09Oooool00ol0003oooooooooo`0dooooo`03o`000?oooooooooo01?o
oooo000Eooooo`03o`000?oooooooooo03?ooooo00?o0000ooooooooool09_ooool00ol0003ooooo
ooooo`0cooooo`03o`000?oooooooooo02Oooooo00?o0000ooooooooool0<_ooool00ol0003ooooo
ooooo`0Dooooo`005_ooool00ol0003oooooooooo`0aooooo`03o`000?oooooooooo02Sooooo00?o
0000ooooooooool0<Oooool00ol0003oooooooooo`0Xooooo`03o`000?oooooooooo037ooooo00?o
0000ooooooooool05Oooool001Kooooo00?o0000ooooooooool0<Oooool00ol0003oooooooooo`0X
ooooo`03o`000?oooooooooo037ooooo00?o0000ooooooooool0:Oooool00ol0003oooooooooo`0`
ooooo`03o`000?oooooooooo01Gooooo000Gooooo`03o`000?oooooooooo02oooooo00?o0000oooo
ooooool0:_ooool00ol0003oooooooooo`0_ooooo`03o`000?oooooooooo02_ooooo00?o0000oooo
ooooool0;_ooool00ol0003oooooooooo`0Fooooo`006?ooool00ol0003oooooooooo`0]ooooo`03
o`000?oooooooooo02cooooo00?o0000ooooooooool0;Oooool00ol0003oooooooooo`0/ooooo`03
o`000?oooooooooo02gooooo00?o0000ooooooooool05oooool001Sooooo00?o0000ooooooooool0
;Oooool00ol0003oooooooooo`0/ooooo`03o`000?oooooooooo02gooooo00?o0000ooooooooool0
;Oooool00ol0003oooooooooo`0/ooooo`03o`000?oooooooooo01Oooooo000Iooooo`03o`000?oo
oooooooo02_ooooo00?o0000ooooooooool0;_ooool00ol0003oooooooooo`0[ooooo`03o`000?oo
oooooooo02kooooo00?o0000ooooooooool0:oooool00ol0003oooooooooo`0Hooooo`006_ooool0
0ol0003oooooooooo`0Yooooo`03o`000?oooooooooo033ooooo00?o0000ooooooooool0:Oooool0
0ol0003oooooooooo`0`ooooo`03o`000?oooooooooo02Wooooo00?o0000ooooooooool06Oooool0
01[ooooo00?o0000ooooooooool0:Oooool00ol0003oooooooooo`0`ooooo`03o`000?oooooooooo
02Wooooo00?o0000ooooooooool0<Oooool00ol0003oooooooooo`0Xooooo`03o`000?oooooooooo
01Wooooo000Kooooo`03o`000?oooooooooo02Oooooo00?o0000ooooooooool0<_ooool00ol0003o
ooooooooo`0Wooooo`03o`000?oooooooooo03;ooooo00?o0000ooooooooool09oooool00ol0003o
ooooooooo`0Jooooo`007?ooool00ol0003oooooooooo`0Uooooo`03o`000?oooooooooo03Cooooo
00?o0000ooooooooool09Oooool00ol0003oooooooooo`0dooooo`03o`000?oooooooooo02Gooooo
00?o0000ooooooooool06oooool001cooooo00?o0000ooooooooool09Oooool00ol0003ooooooooo
o`0dooooo`03o`000?oooooooooo02Gooooo00?o0000ooooooooool0=Oooool00ol0003ooooooooo
o`0Tooooo`03o`000?oooooooooo01_ooooo000Mooooo`03o`000?oooooooooo02?ooooo00?o0000
ooooooooool0=_ooool00ol0003oooooooooo`0Sooooo`03o`000?oooooooooo03Kooooo00?o0000
ooooooooool08oooool00ol0003oooooooooo`0Looooo`007_ooool4o`0001gooooo1?l0000joooo
o`Co00007Oooool4o`0003[ooooo1?l0000Mooooo`Co00007oooool001kooooo1Ol0000Kooooo`Go
0000>_ooool5o`0001_ooooo1Ol0000jooooo`Go00006oooool5o`0001oooooo000Mooooo`Oo0000
6Oooool7o`0003Sooooo1ol0000Iooooo`Oo0000>?ooool7o`0001Wooooo1ol0000Nooooo`007Ooo
oolWo`0003Sooooo9ol0000hooooobOo00007_ooool001gooooo1ol0000Iooooo`Oo0000>?ooool7
o`0001Wooooo1ol0000hooooo`Oo00006Oooool7o`0001kooooo000Nooooo`Go00006oooool5o`00
03[ooooo1Ol0000Kooooo`Go0000>_ooool5o`0001_ooooo1Ol0000Oooooo`007_ooool4o`0001go
oooo1?l0000jooooo`Co00007Oooool4o`0003[ooooo1?l0000Mooooo`Co00007oooool001kooooo
00?o0000ooooooooool08Oooool00ol0003oooooooooo`0hooooo`03o`000?oooooooooo027ooooo
00?o0000ooooooooool0>?ooool00ol0003oooooooooo`0Qooooo`03o`000?oooooooooo01gooooo
000Mooooo`03o`000?oooooooooo02?ooooo00?o0000ooooooooool0=_ooool00ol0003ooooooooo
o`0Sooooo`03o`000?oooooooooo03Kooooo00?o0000ooooooooool08oooool00ol0003ooooooooo
o`0Looooo`007?ooool00ol0003oooooooooo`0Uooooo`03o`000?oooooooooo03Cooooo00?o0000
ooooooooool09Oooool00ol0003oooooooooo`0dooooo`03o`000?oooooooooo02Gooooo00?o0000
ooooooooool06oooool001_ooooo00?o0000ooooooooool09oooool00ol0003oooooooooo`0boooo
o`03o`000?oooooooooo02Oooooo00?o0000ooooooooool0<oooool00ol0003oooooooooo`0Voooo
o`03o`000?oooooooooo01[ooooo000Kooooo`03o`000?oooooooooo02Oooooo00?o0000oooooooo
ool0<_ooool00ol0003oooooooooo`0Wooooo`03o`000?oooooooooo03;ooooo00?o0000oooooooo
ool09oooool00ol0003oooooooooo`0Jooooo`006_ooool00ol0003oooooooooo`0Yooooo`03o`00
0?oooooooooo033ooooo00?o0000ooooooooool0:Oooool00ol0003oooooooooo`0`ooooo`03o`00
0?oooooooooo02Wooooo00?o0000ooooooooool06Oooool001Wooooo00?o0000ooooooooool0:ooo
ool00ol0003oooooooooo`0^ooooo`03o`000?oooooooooo02_ooooo00?o0000ooooooooool0;ooo
ool00ol0003oooooooooo`0Zooooo`03o`000?oooooooooo01Sooooo000Iooooo`03o`000?oooooo
oooo02_ooooo00?o0000ooooooooool0;_ooool00ol0003oooooooooo`0[ooooo`03o`000?oooooo
oooo02kooooo00?o0000ooooooooool0:oooool00ol0003oooooooooo`0Hooooo`006?ooool00ol0
003oooooooooo`0]ooooo`03o`000?oooooooooo02cooooo00?o0000ooooooooool0;Oooool00ol0
003oooooooooo`0/ooooo`03o`000?oooooooooo02gooooo00?o0000ooooooooool05oooool001Oo
oooo00?o0000ooooooooool0;oooool00ol0003oooooooooo`0Zooooo`03o`000?oooooooooo02oo
oooo00?o0000ooooooooool0:oooool00ol0003oooooooooo`0^ooooo`03o`000?oooooooooo01Ko
oooo000Gooooo`03o`000?oooooooooo02oooooo00?o0000ooooooooool0:_ooool00ol0003ooooo
ooooo`0_ooooo`03o`000?oooooooooo02[ooooo00?o0000ooooooooool0;oooool00ol0003ooooo
ooooo`0Fooooo`005_ooool00ol0003oooooooooo`0aooooo`03o`000?oooooooooo02Sooooo00?o
0000ooooooooool0<Oooool00ol0003oooooooooo`0Yooooo`03o`000?oooooooooo033ooooo00?o
0000ooooooooool05Oooool001Gooooo00?o0000ooooooooool0<oooool00ol0003oooooooooo`0V
ooooo`03o`000?oooooooooo03?ooooo00?o0000ooooooooool09oooool00ol0003oooooooooo`0b
ooooo`03o`000?oooooooooo01Cooooo000Eooooo`03o`000?oooooooooo03?ooooo00?o0000oooo
ooooool09_ooool00ol0003oooooooooo`0cooooo`03o`000?oooooooooo02Kooooo00?o0000oooo
ooooool0<oooool00ol0003oooooooooo`0Dooooo`005?ooool00ol0003oooooooooo`0eooooo`03
o`000?oooooooooo02Cooooo00?o0000ooooooooool0=Oooool00ol0003oooooooooo`0Uooooo`03
o`000?oooooooooo03Cooooo00?o0000ooooooooool04oooool001?ooooo00?o0000ooooooooool0
=oooool00ol0003oooooooooo`0Rooooo`03o`000?oooooooooo03Oooooo00?o0000ooooooooool0
8oooool00ol0003oooooooooo`0fooooo`03o`000?oooooooooo01;ooooo000?ooooo`Co0000>ooo
ool3o`0001gooooo1?l0000kooooo`Co00007?ooool3o`000003ooooool0003ooooo03Wooooo1?l0
000@ooooo`003_ooool5o`0003[ooooo1Ol0000Kooooo`Go0000>oooool5o`0001[ooooo1_l0000j
ooooo`Go00003oooool000gooooo1ol0000hooooo`Oo00006Oooool7o`0003Wooooo1ol0000Hoooo
o`Oo0000>Oooool7o`0000kooooo000=ooooo`Oo0000>?oooolWo`0003Wooooo9_l0000iooooo`Oo
00003_ooool000gooooo1ol0000hooooo`Oo00006Oooool7o`0003Wooooo1ol0000Hooooo`Oo0000
>Oooool7o`0000kooooo000>ooooo`Go0000>_ooool5o`0001_ooooo1Ol0000kooooo`Go00006_oo
ool5o`0003_ooooo1Ol0000?ooooo`003oooool4o`0003_ooooo0ol0000Mooooo`Co0000>oooool4
o`0001cooooo0ol000000ooooooo0000ooooo`0iooooo`Co00004?ooool001;ooooo00?o0000oooo
ooooool0>Oooool00ol0003oooooooooo`0Pooooo`03o`000?oooooooooo03Wooooo00?o0000oooo
ooooool08Oooool00ol0003oooooooooo`0hooooo`03o`000?oooooooooo017ooooo000Cooooo`03
o`000?oooooooooo03Oooooo00?o0000ooooooooool08_ooool00ol0003oooooooooo`0gooooo`03
o`000?oooooooooo02?ooooo00?o0000ooooooooool0=_ooool00ol0003oooooooooo`0Booooo`00
5?ooool00ol0003oooooooooo`0eooooo`03o`000?oooooooooo02Cooooo00?o0000ooooooooool0
=Oooool00ol0003oooooooooo`0Tooooo`03o`000?oooooooooo03Gooooo00?o0000ooooooooool0
4oooool001Cooooo00?o0000ooooooooool0=Oooool00ol0003oooooooooo`0Tooooo`03o`000?oo
oooooooo03Gooooo00?o0000ooooooooool09Oooool00ol0003oooooooooo`0dooooo`03o`000?oo
oooooooo01?ooooo000Eooooo`03o`000?oooooooooo03?ooooo00?o0000ooooooooool09_ooool0
0ol0003oooooooooo`0cooooo`03o`000?oooooooooo02Oooooo00?o0000ooooooooool0<_ooool0
0ol0003oooooooooo`0Dooooo`005_ooool00ol0003oooooooooo`0aooooo`03o`000?oooooooooo
02Sooooo00?o0000ooooooooool0<Oooool00ol0003oooooooooo`0Xooooo`03o`000?oooooooooo
037ooooo00?o0000ooooooooool05Oooool001Kooooo00?o0000ooooooooool0<Oooool00ol0003o
ooooooooo`0Xooooo`03o`000?oooooooooo037ooooo00?o0000ooooooooool0:Oooool00ol0003o
ooooooooo`0`ooooo`03o`000?oooooooooo01Gooooo000Gooooo`03o`000?oooooooooo02oooooo
00?o0000ooooooooool0:_ooool00ol0003oooooooooo`0_ooooo`03o`000?oooooooooo02_ooooo
00?o0000ooooooooool0;_ooool00ol0003oooooooooo`0Fooooo`006?ooool00ol0003ooooooooo
o`0]ooooo`03o`000?oooooooooo02cooooo00?o0000ooooooooool0;Oooool00ol0003ooooooooo
o`0/ooooo`03o`000?oooooooooo02gooooo00?o0000ooooooooool05oooool001Sooooo00?o0000
ooooooooool0;Oooool00ol0003oooooooooo`0/ooooo`03o`000?oooooooooo02gooooo00?o0000
ooooooooool0;Oooool00ol0003oooooooooo`0/ooooo`03o`000?oooooooooo01Oooooo000Ioooo
o`03o`000?oooooooooo02_ooooo00?o0000ooooooooool0;_ooool00ol0003oooooooooo`0[oooo
o`03o`000?oooooooooo02kooooo00?o0000ooooooooool0:oooool00ol0003oooooooooo`0Hoooo
o`006_ooool00ol0003oooooooooo`0Yooooo`03o`000?oooooooooo033ooooo00?o0000oooooooo
ool0:Oooool00ol0003oooooooooo`0`ooooo`03o`000?oooooooooo02Wooooo00?o0000oooooooo
ool06Oooool001[ooooo00?o0000ooooooooool0:Oooool00ol0003oooooooooo`0`ooooo`03o`00
0?oooooooooo02Wooooo00?o0000ooooooooool0<Oooool00ol0003oooooooooo`0Xooooo`03o`00
0?oooooooooo01Wooooo000Kooooo`03o`000?oooooooooo02Oooooo00?o0000ooooooooool0<_oo
ool00ol0003oooooooooo`0Wooooo`03o`000?oooooooooo03;ooooo00?o0000ooooooooool09ooo
ool00ol0003oooooooooo`0Jooooo`007?ooool00ol0003oooooooooo`0Uooooo`03o`000?oooooo
oooo03Cooooo00?o0000ooooooooool09Oooool00ol0003oooooooooo`0dooooo`03o`000?oooooo
oooo02Gooooo00?o0000ooooooooool06oooool001cooooo00?o0000ooooooooool09Oooool00ol0
003oooooooooo`0dooooo`03o`000?oooooooooo02Gooooo00?o0000ooooooooool0=Oooool00ol0
003oooooooooo`0Tooooo`03o`000?oooooooooo01_ooooo000Mooooo`03o`000?oooooooooo02?o
oooo00?o0000ooooooooool0=_ooool00ol0003oooooooooo`0Sooooo`03o`000?oooooooooo03Ko
oooo00?o0000ooooooooool08oooool00ol0003oooooooooo`0Looooo`007_ooool4o`0001gooooo
1?l0000jooooo`Co00007Oooool4o`0003[ooooo1?l0000Mooooo`Co00007oooool001kooooo1Ol0
000Kooooo`Go0000>_ooool5o`0001_ooooo1Ol0000jooooo`Go00006oooool5o`0001oooooo000M
ooooo`Oo00006Oooool7o`0003Sooooo1ol0000Iooooo`Oo0000>?ooool7o`0001Wooooo1ol0000N
ooooo`007OoooolWo`0003Sooooo9ol0000hooooobOo00007_ooool001gooooo1ol0000Iooooo`Oo
0000>?ooool7o`0001Wooooo1ol0000hooooo`Oo00006Oooool7o`0001kooooo000Nooooo`Go0000
6oooool5o`0003[ooooo1Ol0000Kooooo`Go0000>_ooool5o`0001_ooooo1Ol0000Oooooo`007_oo
ool4o`0001gooooo1?l0000jooooo`Co00007Oooool4o`0003[ooooo1?l0000Mooooo`Co00007ooo
ool001kooooo00?o0000ooooooooool08Oooool00ol0003oooooooooo`0hooooo`03o`000?oooooo
oooo027ooooo00?o0000ooooooooool0>?ooool00ol0003oooooooooo`0Qooooo`03o`000?oooooo
oooo01gooooo000Mooooo`03o`000?oooooooooo02?ooooo00?o0000ooooooooool0=_ooool00ol0
003oooooooooo`0Sooooo`03o`000?oooooooooo03Kooooo00?o0000ooooooooool08oooool00ol0
003oooooooooo`0Looooo`007?ooool00ol0003oooooooooo`0Uooooo`03o`000?oooooooooo03Co
oooo00?o0000ooooooooool09Oooool00ol0003oooooooooo`0dooooo`03o`000?oooooooooo02Go
oooo00?o0000ooooooooool06oooool001_ooooo00?o0000ooooooooool09oooool00ol0003ooooo
ooooo`0booooo`03o`000?oooooooooo02Oooooo00?o0000ooooooooool0<oooool00ol0003ooooo
ooooo`0Vooooo`03o`000?oooooooooo01[ooooo000Kooooo`03o`000?oooooooooo02Oooooo00?o
0000ooooooooool0<_ooool00ol0003oooooooooo`0Wooooo`03o`000?oooooooooo03;ooooo00?o
0000ooooooooool09oooool00ol0003oooooooooo`0Jooooo`006_ooool00ol0003oooooooooo`0Y
ooooo`03o`000?oooooooooo033ooooo00?o0000ooooooooool0:Oooool00ol0003oooooooooo`0`
ooooo`03o`000?oooooooooo02Wooooo00?o0000ooooooooool06Oooool001Wooooo00?o0000oooo
ooooool0:oooool00ol0003oooooooooo`0^ooooo`03o`000?oooooooooo02_ooooo00?o0000oooo
ooooool0;oooool00ol0003oooooooooo`0Zooooo`03o`000?oooooooooo01Sooooo000Iooooo`03
o`000?oooooooooo02_ooooo00?o0000ooooooooool0;_ooool00ol0003oooooooooo`0[ooooo`03
o`000?oooooooooo02kooooo00?o0000ooooooooool0:oooool00ol0003oooooooooo`0Hooooo`00
6?ooool00ol0003oooooooooo`0]ooooo`03o`000?oooooooooo02cooooo00?o0000ooooooooool0
;Oooool00ol0003oooooooooo`0/ooooo`03o`000?oooooooooo02gooooo00?o0000ooooooooool0
5oooool001Oooooo00?o0000ooooooooool0;oooool00ol0003oooooooooo`0Zooooo`03o`000?oo
oooooooo02oooooo00?o0000ooooooooool0:oooool00ol0003oooooooooo`0^ooooo`03o`000?oo
oooooooo01Kooooo000Gooooo`03o`000?oooooooooo02oooooo00?o0000ooooooooool0:_ooool0
0ol0003oooooooooo`0_ooooo`03o`000?oooooooooo02[ooooo00?o0000ooooooooool0;oooool0
0ol0003oooooooooo`0Fooooo`005_ooool00ol0003oooooooooo`0aooooo`03o`000?oooooooooo
02Sooooo00?o0000ooooooooool0<Oooool00ol0003oooooooooo`0Yooooo`03o`000?oooooooooo
033ooooo00?o0000ooooooooool05Oooool001Gooooo00?o0000ooooooooool0<oooool00ol0003o
ooooooooo`0Vooooo`03o`000?oooooooooo03?ooooo00?o0000ooooooooool09oooool00ol0003o
ooooooooo`0booooo`03o`000?oooooooooo01Cooooo000Eooooo`03o`000?oooooooooo03?ooooo
00?o0000ooooooooool09_ooool00ol0003oooooooooo`0cooooo`03o`000?oooooooooo02Kooooo
00?o0000ooooooooool0<oooool00ol0003oooooooooo`0Dooooo`005?ooool00ol0003ooooooooo
o`0eooooo`03o`000?oooooooooo02Cooooo00?o0000ooooooooool0=Oooool00ol0003ooooooooo
o`0Uooooo`03o`000?oooooooooo03Cooooo00?o0000ooooooooool04oooool001?ooooo00?o0000
ooooooooool0=oooool00ol0003oooooooooo`0Rooooo`03o`000?oooooooooo03Oooooo00?o0000
ooooooooool08oooool00ol0003oooooooooo`0fooooo`03o`000?oooooooooo01;ooooo000?oooo
o`Co0000>oooool3o`0001gooooo1?l0000kooooo`Co00007?ooool3o`000003ooooool0003ooooo
03Wooooo1?l0000@ooooo`003_ooool5o`0003[ooooo1Ol0000Kooooo`Go0000>oooool5o`0001[o
oooo1_l0000jooooo`Go00003oooool000gooooo1ol0000hooooo`Oo00006Oooool7o`0003Wooooo
1ol0000Hooooo`Oo0000>Oooool7o`0000kooooo000=ooooo`Oo0000>?oooolWo`0003Wooooo9_l0
000iooooo`Oo00003_ooool000gooooo1ol0000hooooo`Oo00006Oooool7o`0003Wooooo1ol0000H
ooooo`Oo0000>Oooool7o`0000kooooo000>ooooo`Go0000>_ooool5o`0001_ooooo1Ol0000koooo
o`Go00006_ooool5o`0003_ooooo1Ol0000?ooooo`003oooool4o`0003_ooooo0ol0000Mooooo`Co
0000>oooool4o`0001cooooo0ol000000ooooooo0000ooooo`0iooooo`Co00004?ooool001;ooooo
00?o0000ooooooooool0>Oooool00ol0003oooooooooo`0Pooooo`03o`000?oooooooooo03Wooooo
00?o0000ooooooooool08Oooool00ol0003oooooooooo`0hooooo`03o`000?oooooooooo017ooooo
000Cooooo`03o`000?oooooooooo03Oooooo00?o0000ooooooooool08_ooool00ol0003ooooooooo
o`0gooooo`03o`000?oooooooooo02?ooooo00?o0000ooooooooool0=_ooool00ol0003ooooooooo
o`0Booooo`005?ooool00ol0003oooooooooo`0eooooo`03o`000?oooooooooo02Cooooo00?o0000
ooooooooool0=Oooool00ol0003oooooooooo`0Tooooo`03o`000?oooooooooo03Gooooo00?o0000
ooooooooool04oooool001Cooooo00?o0000ooooooooool0=Oooool00ol0003oooooooooo`0Toooo
o`03o`000?oooooooooo03Gooooo00?o0000ooooooooool09Oooool00ol0003oooooooooo`0doooo
o`03o`000?oooooooooo01?ooooo000Eooooo`03o`000?oooooooooo03?ooooo00?o0000oooooooo
ool09_ooool00ol0003oooooooooo`0cooooo`03o`000?oooooooooo02Oooooo00?o0000oooooooo
ool0<_ooool00ol0003oooooooooo`0Dooooo`005_ooool00ol0003oooooooooo`0aooooo`03o`00
0?oooooooooo02Sooooo00?o0000ooooooooool0<Oooool00ol0003oooooooooo`0Xooooo`03o`00
0?oooooooooo037ooooo00?o0000ooooooooool05Oooool001Kooooo00?o0000ooooooooool0<Ooo
ool00ol0003oooooooooo`0Xooooo`03o`000?oooooooooo037ooooo00?o0000ooooooooool0:Ooo
ool00ol0003oooooooooo`0`ooooo`03o`000?oooooooooo01Gooooo000Gooooo`03o`000?oooooo
oooo02oooooo00?o0000ooooooooool0:_ooool00ol0003oooooooooo`0_ooooo`03o`000?oooooo
oooo02_ooooo00?o0000ooooooooool0;_ooool00ol0003oooooooooo`0Fooooo`006?ooool00ol0
003oooooooooo`0]ooooo`03o`000?oooooooooo02cooooo00?o0000ooooooooool0;Oooool00ol0
003oooooooooo`0/ooooo`03o`000?oooooooooo02gooooo00?o0000ooooooooool05oooool001So
oooo00?o0000ooooooooool0;Oooool00ol0003oooooooooo`0/ooooo`03o`000?oooooooooo02go
oooo00?o0000ooooooooool0;Oooool00ol0003oooooooooo`0/ooooo`03o`000?oooooooooo01Oo
oooo000Iooooo`03o`000?oooooooooo02_ooooo00?o0000ooooooooool0;_ooool00ol0003ooooo
ooooo`0[ooooo`03o`000?oooooooooo02kooooo00?o0000ooooooooool0:oooool00ol0003ooooo
ooooo`0Hooooo`006_ooool00ol0003oooooooooo`0Yooooo`03o`000?oooooooooo033ooooo00?o
0000ooooooooool0:Oooool00ol0003oooooooooo`0`ooooo`03o`000?oooooooooo02Wooooo00?o
0000ooooooooool06Oooool001[ooooo00?o0000ooooooooool0:Oooool00ol0003oooooooooo`0`
ooooo`03o`000?oooooooooo02Wooooo00?o0000ooooooooool0<Oooool00ol0003oooooooooo`0X
ooooo`03o`000?oooooooooo01Wooooo000Kooooo`03o`000?oooooooooo02Oooooo00?o0000oooo
ooooool0<_ooool00ol0003oooooooooo`0Wooooo`03o`000?oooooooooo03;ooooo00?o0000oooo
ooooool09oooool00ol0003oooooooooo`0Jooooo`007?ooool00ol0003oooooooooo`0Uooooo`03
o`000?oooooooooo03Cooooo00?o0000ooooooooool09Oooool00ol0003oooooooooo`0dooooo`03
o`000?oooooooooo02Gooooo00?o0000ooooooooool06oooool001cooooo00?o0000ooooooooool0
9Oooool00ol0003oooooooooo`0dooooo`03o`000?oooooooooo02Gooooo00?o0000ooooooooool0
=Oooool00ol0003oooooooooo`0Tooooo`03o`000?oooooooooo01_ooooo000Mooooo`03o`000?oo
oooooooo02?ooooo00?o0000ooooooooool0=_ooool00ol0003oooooooooo`0Sooooo`03o`000?oo
oooooooo03Kooooo00?o0000ooooooooool08oooool00ol0003oooooooooo`0Looooo`007_ooool4
o`0001gooooo1?l0000jooooo`Co00007Oooool4o`0003[ooooo1?l0000Mooooo`Co00007oooool0
01kooooo1Ol0000Kooooo`Go0000>_ooool5o`0001_ooooo1Ol0000jooooo`Go00006oooool5o`00
01oooooo000Mooooo`Oo00006Oooool7o`0003Sooooo1ol0000Iooooo`Oo0000>?ooool7o`0001Wo
oooo1ol0000Nooooo`007OoooolWo`0003Sooooo9ol0000hooooobOo00007_ooool001gooooo1ol0
000Iooooo`Oo0000>?ooool7o`0001Wooooo1ol0000hooooo`Oo00006Oooool7o`0001kooooo000N
ooooo`Go00006oooool5o`0003[ooooo1Ol0000Kooooo`Go0000>_ooool5o`0001_ooooo1Ol0000O
ooooo`007_ooool4o`0001gooooo1?l0000jooooo`Co00007Oooool4o`0003[ooooo1?l0000Moooo
o`Co00007oooool001kooooo00?o0000ooooooooool08Oooool00ol0003oooooooooo`0hooooo`03
o`000?oooooooooo027ooooo00?o0000ooooooooool0>?ooool00ol0003oooooooooo`0Qooooo`03
o`000?oooooooooo01gooooo000Mooooo`03o`000?oooooooooo02?ooooo00?o0000ooooooooool0
=_ooool00ol0003oooooooooo`0Sooooo`03o`000?oooooooooo03Kooooo00?o0000ooooooooool0
8oooool00ol0003oooooooooo`0Looooo`007?ooool00ol0003oooooooooo`0Uooooo`03o`000?oo
oooooooo03Cooooo00?o0000ooooooooool09Oooool00ol0003oooooooooo`0dooooo`03o`000?oo
oooooooo02Gooooo00?o0000ooooooooool06oooool001_ooooo00?o0000ooooooooool09oooool0
0ol0003oooooooooo`0booooo`03o`000?oooooooooo02Oooooo00?o0000ooooooooool0<oooool0
0ol0003oooooooooo`0Vooooo`03o`000?oooooooooo01[ooooo000Kooooo`03o`000?oooooooooo
02Oooooo00?o0000ooooooooool0<_ooool00ol0003oooooooooo`0Wooooo`03o`000?oooooooooo
03;ooooo00?o0000ooooooooool09oooool00ol0003oooooooooo`0Jooooo`006_ooool00ol0003o
ooooooooo`0Yooooo`03o`000?oooooooooo033ooooo00?o0000ooooooooool0:Oooool00ol0003o
ooooooooo`0`ooooo`03o`000?oooooooooo02Wooooo00?o0000ooooooooool06Oooool001Wooooo
00?o0000ooooooooool0:oooool00ol0003oooooooooo`0^ooooo`03o`000?oooooooooo02_ooooo
00?o0000ooooooooool0;oooool00ol0003oooooooooo`0Zooooo`03o`000?oooooooooo01Sooooo
000Iooooo`03o`000?oooooooooo02_ooooo00?o0000ooooooooool0;_ooool00ol0003ooooooooo
o`0[ooooo`03o`000?oooooooooo02kooooo00?o0000ooooooooool0:oooool00ol0003ooooooooo
o`0Hooooo`006?ooool00ol0003oooooooooo`0]ooooo`03o`000?oooooooooo02cooooo00?o0000
ooooooooool0;Oooool00ol0003oooooooooo`0/ooooo`03o`000?oooooooooo02gooooo00?o0000
ooooooooool05oooool001Oooooo00?o0000ooooooooool0;oooool00ol0003oooooooooo`0Zoooo
o`03o`000?oooooooooo02oooooo00?o0000ooooooooool0:oooool00ol0003oooooooooo`0^oooo
o`03o`000?oooooooooo01Kooooo000Gooooo`03o`000?oooooooooo02oooooo00?o0000oooooooo
ool0:_ooool00ol0003oooooooooo`0_ooooo`03o`000?oooooooooo02[ooooo00?o0000oooooooo
ool0;oooool00ol0003oooooooooo`0Fooooo`005_ooool00ol0003oooooooooo`0aooooo`03o`00
0?oooooooooo02Sooooo00?o0000ooooooooool0<Oooool00ol0003oooooooooo`0Yooooo`03o`00
0?oooooooooo033ooooo00?o0000ooooooooool05Oooool001Gooooo00?o0000ooooooooool0<ooo
ool00ol0003oooooooooo`0Vooooo`03o`000?oooooooooo03?ooooo00?o0000ooooooooool09ooo
ool00ol0003oooooooooo`0booooo`03o`000?oooooooooo01Cooooo000Eooooo`03o`000?oooooo
oooo03?ooooo00?o0000ooooooooool09_ooool00ol0003oooooooooo`0cooooo`03o`000?oooooo
oooo02Kooooo00?o0000ooooooooool0<oooool00ol0003oooooooooo`0Dooooo`005?ooool00ol0
003oooooooooo`0eooooo`03o`000?oooooooooo02Cooooo00?o0000ooooooooool0=Oooool00ol0
003oooooooooo`0Uooooo`03o`000?oooooooooo03Cooooo00?o0000ooooooooool04oooool001?o
oooo00?o0000ooooooooool0=oooool00ol0003oooooooooo`0Rooooo`03o`000?oooooooooo03Oo
oooo00?o0000ooooooooool08oooool00ol0003oooooooooo`0fooooo`03o`000?oooooooooo01;o
oooo000?ooooo`Co0000>oooool3o`0001gooooo1?l0000kooooo`Co00007?ooool3o`000003oooo
ool0003ooooo03Wooooo1?l0000@ooooo`003_ooool5o`0003[ooooo1Ol0000Kooooo`Go0000>ooo
ool5o`0001[ooooo1_l0000jooooo`Go00003oooool000gooooo1ol0000hooooo`Oo00006Oooool7
o`0003Wooooo1ol0000Hooooo`Oo0000>Oooool7o`0000kooooo000=ooooo`Oo0000>?oooolWo`00
03Wooooo9_l0000iooooo`Oo00003_ooool000gooooo1ol0000hooooo`Oo00006Oooool7o`0003Wo
oooo1ol0000Hooooo`Oo0000>Oooool7o`0000kooooo000>ooooo`Go0000>_ooool5o`0001_ooooo
1Ol0000kooooo`Go00006_ooool5o`0003_ooooo1Ol0000?ooooo`003oooool4o`0003_ooooo0ol0
000Mooooo`Co0000>oooool4o`0001cooooo0ol000000ooooooo0000ooooo`0iooooo`Co00004?oo
ool001;ooooo00?o0000ooooooooool0>Oooool00ol0003oooooooooo`0Pooooo`03o`000?oooooo
oooo03Wooooo00?o0000ooooooooool08Oooool00ol0003oooooooooo`0hooooo`03o`000?oooooo
oooo017ooooo000Cooooo`03o`000?oooooooooo03Oooooo00?o0000ooooooooool08_ooool00ol0
003oooooooooo`0gooooo`03o`000?oooooooooo02?ooooo00?o0000ooooooooool0=_ooool00ol0
003oooooooooo`0Booooo`005?ooool00ol0003oooooooooo`0eooooo`03o`000?oooooooooo02Co
oooo00?o0000ooooooooool0=Oooool00ol0003oooooooooo`0Tooooo`03o`000?oooooooooo03Go
oooo00?o0000ooooooooool04oooool001Cooooo00?o0000ooooooooool0=Oooool00ol0003ooooo
ooooo`0Tooooo`03o`000?oooooooooo03Gooooo00?o0000ooooooooool09Oooool00ol0003ooooo
ooooo`0dooooo`03o`000?oooooooooo01?ooooo000Eooooo`03o`000?oooooooooo03?ooooo00?o
0000ooooooooool09_ooool00ol0003oooooooooo`0cooooo`03o`000?oooooooooo02Oooooo00?o
0000ooooooooool0<_ooool00ol0003oooooooooo`0Dooooo`005_ooool00ol0003oooooooooo`0a
ooooo`03o`000?oooooooooo02Sooooo00?o0000ooooooooool0<Oooool00ol0003oooooooooo`0X
ooooo`03o`000?oooooooooo037ooooo00?o0000ooooooooool05Oooool001Kooooo00?o0000oooo
ooooool0<Oooool00ol0003oooooooooo`0Xooooo`03o`000?oooooooooo037ooooo00?o0000oooo
ooooool0:Oooool00ol0003oooooooooo`0`ooooo`03o`000?oooooooooo01Gooooo000Gooooo`03
o`000?oooooooooo02oooooo00?o0000ooooooooool0:_ooool00ol0003oooooooooo`0_ooooo`03
o`000?oooooooooo02_ooooo00?o0000ooooooooool0;_ooool00ol0003oooooooooo`0Fooooo`00
6?ooool00ol0003oooooooooo`0]ooooo`03o`000?oooooooooo02cooooo00?o0000ooooooooool0
;Oooool00ol0003oooooooooo`0/ooooo`03o`000?oooooooooo02gooooo00?o0000ooooooooool0
5oooool001Sooooo00?o0000ooooooooool0;Oooool00ol0003oooooooooo`0/ooooo`03o`000?oo
oooooooo02gooooo00?o0000ooooooooool0;Oooool00ol0003oooooooooo`0/ooooo`03o`000?oo
oooooooo01Oooooo000Iooooo`03o`000?oooooooooo02_ooooo00?o0000ooooooooool0;_ooool0
0ol0003oooooooooo`0[ooooo`03o`000?oooooooooo02kooooo00?o0000ooooooooool0:oooool0
0ol0003oooooooooo`0Hooooo`006_ooool00ol0003oooooooooo`0Yooooo`03o`000?oooooooooo
033ooooo00?o0000ooooooooool0:Oooool00ol0003oooooooooo`0`ooooo`03o`000?oooooooooo
02Wooooo00?o0000ooooooooool06Oooool001[ooooo00?o0000ooooooooool0:Oooool00ol0003o
ooooooooo`0`ooooo`03o`000?oooooooooo02Wooooo00?o0000ooooooooool0<Oooool00ol0003o
ooooooooo`0Xooooo`03o`000?oooooooooo01Wooooo000Kooooo`03o`000?oooooooooo02Oooooo
00?o0000ooooooooool0<_ooool00ol0003oooooooooo`0Wooooo`03o`000?oooooooooo03;ooooo
00?o0000ooooooooool09oooool00ol0003oooooooooo`0Jooooo`007?ooool00ol0003ooooooooo
o`0Uooooo`03o`000?oooooooooo03Cooooo00?o0000ooooooooool09Oooool00ol0003ooooooooo
o`0dooooo`03o`000?oooooooooo02Gooooo00?o0000ooooooooool06oooool001cooooo00?o0000
ooooooooool09Oooool00ol0003oooooooooo`0dooooo`03o`000?oooooooooo02Gooooo00?o0000
ooooooooool0=Oooool00ol0003oooooooooo`0Tooooo`03o`000?oooooooooo01_ooooo000Moooo
o`03o`000?oooooooooo02?ooooo00?o0000ooooooooool0=_ooool00ol0003oooooooooo`0Soooo
o`03o`000?oooooooooo03Kooooo00?o0000ooooooooool08oooool00ol0003oooooooooo`0Loooo
o`007_ooool4o`0001gooooo1?l0000jooooo`Co00007Oooool4o`0003[ooooo1?l0000Mooooo`Co
00007oooool001kooooo1Ol0000Kooooo`Go0000>_ooool5o`0001_ooooo1Ol0000jooooo`Go0000
6oooool5o`0001oooooo000Mooooo`Oo00006Oooool7o`0003Sooooo1ol0000Iooooo`Oo0000>?oo
ool7o`0001Wooooo1ol0000Nooooo`007OoooolWo`0003Sooooo9ol0000hooooobOo00007_ooool0
01gooooo1ol0000Iooooo`Oo0000>?ooool7o`0001Wooooo1ol0000hooooo`Oo00006Oooool7o`00
01kooooo000Nooooo`Go00006oooool5o`0003[ooooo1Ol0000Kooooo`Go0000>_ooool5o`0001_o
oooo1Ol0000Oooooo`007oooool3o`0001gooooo1?l0000jooooo`Co00007Oooool4o`0003[ooooo
1?l0000Mooooo`?o00008?ooool004;ooooo00?o0000ooooooooool0>?ooool00ol0003ooooooooo
o`0Qooooo`03o`000?oooooooooo03Sooooo00?o0000ooooooooool0@Oooool004?ooooo00?o0000
ooooooooool0=_ooool00ol0003oooooooooo`0Sooooo`03o`000?oooooooooo03Kooooo00?o0000
ooooooooool0@_ooool004Cooooo00?o0000ooooooooool0=?ooool00ol0003oooooooooo`0Uoooo
o`03o`000?oooooooooo03Cooooo00?o0000ooooooooool0@oooool004Gooooo00?o0000oooooooo
ool0<_ooool00ol0003oooooooooo`0Wooooo`03o`000?oooooooooo03?ooooo00?o0000oooooooo
ool0@oooool004Gooooo00?o0000ooooooooool0<_ooool00ol0003oooooooooo`0Wooooo`03o`00
0?oooooooooo03;ooooo00?o0000ooooooooool0A?ooool004Kooooo00?o0000ooooooooool0<?oo
ool00ol0003oooooooooo`0Yooooo`03o`000?oooooooooo033ooooo00?o0000ooooooooool0AOoo
ool004Oooooo00?o0000ooooooooool0;_ooool00ol0003oooooooooo`0[ooooo`03o`000?oooooo
oooo02oooooo00?o0000ooooooooool0AOooool004Oooooo00?o0000ooooooooool0;_ooool00ol0
003oooooooooo`0[ooooo`03o`000?oooooooooo02kooooo00?o0000ooooooooool0A_ooool004So
oooo00?o0000ooooooooool0;?ooool00ol0003oooooooooo`0]ooooo`03o`000?oooooooooo02co
oooo00?o0000ooooooooool0Aoooool004Wooooo00?o0000ooooooooool0:_ooool00ol0003ooooo
ooooo`0_ooooo`03o`000?oooooooooo02_ooooo00?o0000ooooooooool0Aoooool004Wooooo00?o
0000ooooooooool0:_ooool00ol0003oooooooooo`0_ooooo`03o`000?oooooooooo02[ooooo00?o
0000ooooooooool0B?ooool004[ooooo00?o0000ooooooooool0:?ooool00ol0003oooooooooo`0a
ooooo`03o`000?oooooooooo02Wooooo00?o0000ooooooooool0B?ooool004_ooooo00?o0000oooo
ooooool09_ooool00ol0003oooooooooo`0cooooo`03o`000?oooooooooo02Oooooo00?o0000oooo
ooooool0BOooool004_ooooo00?o0000ooooooooool09_ooool00ol0003oooooooooo`0cooooo`03
o`000?oooooooooo02Kooooo00?o0000ooooooooool0B_ooool004cooooo00?o0000ooooooooool0
9?ooool00ol0003oooooooooo`0eooooo`03o`000?oooooooooo02Gooooo00?o0000ooooooooool0
B_ooool004gooooo00?o0000ooooooooool08_ooool00ol0003oooooooooo`0gooooo`03o`000?oo
oooooooo02?ooooo00?o0000ooooooooool0Boooool004kooooo0ol0000Mooooo`Co0000>oooool4
o`0001cooooo0ol000000ooooooo0000ooooo`1=ooooo`00COooool5o`0001_ooooo1Ol0000koooo
o`Go00006_ooool6o`0004kooooo001<ooooo`Oo00006Oooool7o`0003Wooooo1ol0000Hooooo`Oo
0000C_ooool004cooooo9ol0000iooooobKo0000C_ooool004cooooo1ol0000Iooooo`Oo0000>Ooo
ool7o`0001Sooooo1ol0001>ooooo`00COooool5o`0001_ooooo1Ol0000kooooo`Go00006_ooool5
o`0004oooooo001>ooooo`?o00007Oooool3o`0003gooooo0ol0000Looooo`?o0000D?ooool00?oo
oooo8Oooool00?oooooo8Oooool00?oooooo8Oooool00?oooooo8Oooool00?oooooo8Oooool00?oo
oooo8Oooool00?oooooo8Oooool00?oooooo8Oooool00?oooooo8Oooool00?oooooo8Oooool00?oo
oooo8Oooool00001\
\>"],
  ImageRangeCache->{{{0, 287}, {287, 0}} -> {-0.0500043, 0.0333283, \
0.00303069, 0.00354243}},
  CellTags->{"b:11", "LocalInteractions:16"}]
}, Open  ]],

Cell["Irregular column heights are obtained as follows.", "Text",
  CellTags->{"b:11", "LocalInteractions:16"}],

Cell[CellGroupData[{

Cell[BoxData[
    \(\(HexGraph[\[IndentingNewLine]5, 5, 
          EqualColumnHeights \[Rule] False\[IndentingNewLine]] // 
        ShowGraph;\)\)], "Input",
  CellLabel->"In[36]:=",
  CellTags->{"b:11", "LocalInteractions:16"}],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: 1 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.0532038 1.06408 -0.0405405 0.990991 [
[ 0 0 0 0 ]
[ 1 1 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 0 m
1 0 L
1 1 L
0 1 L
closepath
clip
newpath
0 0 0 r
.005 w
[ ] 0 setdash
.0532 .13964 m
.10905 .04955 L
s
.0532 .13964 m
.10905 .22973 L
s
.0532 .31982 m
.10905 .22973 L
s
.0532 .31982 m
.10905 .40991 L
s
.0532 .5 m
.10905 .40991 L
s
.0532 .5 m
.10905 .59009 L
s
.0532 .68018 m
.10905 .59009 L
s
.0532 .68018 m
.10905 .77027 L
s
.0532 .86036 m
.10905 .77027 L
s
.0532 .86036 m
.10905 .95045 L
s
.10905 .04955 m
.22075 .04955 L
s
.10905 .22973 m
.22075 .22973 L
s
.10905 .40991 m
.22075 .40991 L
s
.10905 .59009 m
.22075 .59009 L
s
.10905 .77027 m
.22075 .77027 L
s
.10905 .95045 m
.22075 .95045 L
s
.22075 .04955 m
.2766 .13964 L
s
.22075 .22973 m
.2766 .13964 L
s
.22075 .22973 m
.2766 .31982 L
s
.22075 .40991 m
.2766 .31982 L
s
.22075 .40991 m
.2766 .5 L
s
.22075 .59009 m
.2766 .5 L
s
.22075 .59009 m
.2766 .68018 L
s
.22075 .77027 m
.2766 .68018 L
s
.22075 .77027 m
.2766 .86036 L
s
.22075 .95045 m
.2766 .86036 L
s
.2766 .13964 m
.3883 .13964 L
s
.2766 .31982 m
.3883 .31982 L
s
.2766 .5 m
.3883 .5 L
s
.2766 .68018 m
.3883 .68018 L
s
.2766 .86036 m
.3883 .86036 L
s
.3883 .13964 m
.44415 .04955 L
s
.3883 .13964 m
.44415 .22973 L
s
.3883 .31982 m
.44415 .22973 L
s
.3883 .31982 m
.44415 .40991 L
s
.3883 .5 m
.44415 .40991 L
s
.3883 .5 m
.44415 .59009 L
s
.3883 .68018 m
.44415 .59009 L
s
.3883 .68018 m
.44415 .77027 L
s
.3883 .86036 m
.44415 .77027 L
s
.3883 .86036 m
.44415 .95045 L
s
.44415 .04955 m
.55585 .04955 L
s
.44415 .22973 m
.55585 .22973 L
s
.44415 .40991 m
.55585 .40991 L
s
.44415 .59009 m
.55585 .59009 L
s
.44415 .77027 m
.55585 .77027 L
s
.44415 .95045 m
.55585 .95045 L
s
.55585 .04955 m
.6117 .13964 L
s
.55585 .22973 m
.6117 .13964 L
s
.55585 .22973 m
.6117 .31982 L
s
.55585 .40991 m
.6117 .31982 L
s
.55585 .40991 m
.6117 .5 L
s
.55585 .59009 m
.6117 .5 L
s
.55585 .59009 m
.6117 .68018 L
s
.55585 .77027 m
.6117 .68018 L
s
.55585 .77027 m
.6117 .86036 L
s
.55585 .95045 m
.6117 .86036 L
s
.6117 .13964 m
.7234 .13964 L
s
.6117 .31982 m
.7234 .31982 L
s
.6117 .5 m
.7234 .5 L
s
.6117 .68018 m
.7234 .68018 L
s
.6117 .86036 m
.7234 .86036 L
s
.7234 .13964 m
.77925 .04955 L
s
.7234 .13964 m
.77925 .22973 L
s
.7234 .31982 m
.77925 .22973 L
s
.7234 .31982 m
.77925 .40991 L
s
.7234 .5 m
.77925 .40991 L
s
.7234 .5 m
.77925 .59009 L
s
.7234 .68018 m
.77925 .59009 L
s
.7234 .68018 m
.77925 .77027 L
s
.7234 .86036 m
.77925 .77027 L
s
.7234 .86036 m
.77925 .95045 L
s
.77925 .04955 m
.89095 .04955 L
s
.77925 .22973 m
.89095 .22973 L
s
.77925 .40991 m
.89095 .40991 L
s
.77925 .59009 m
.89095 .59009 L
s
.77925 .77027 m
.89095 .77027 L
s
.77925 .95045 m
.89095 .95045 L
s
.89095 .04955 m
.9468 .13964 L
s
.89095 .22973 m
.9468 .13964 L
s
.89095 .22973 m
.9468 .31982 L
s
.89095 .40991 m
.9468 .31982 L
s
.89095 .40991 m
.9468 .5 L
s
.89095 .59009 m
.9468 .5 L
s
.89095 .59009 m
.9468 .68018 L
s
.89095 .77027 m
.9468 .68018 L
s
.89095 .77027 m
.9468 .86036 L
s
.89095 .95045 m
.9468 .86036 L
s
.025 w
.0532 .13964 Mdot
.0532 .31982 Mdot
.0532 .5 Mdot
.0532 .68018 Mdot
.0532 .86036 Mdot
.10905 .04955 Mdot
.10905 .22973 Mdot
.10905 .40991 Mdot
.10905 .59009 Mdot
.10905 .77027 Mdot
.10905 .95045 Mdot
.22075 .04955 Mdot
.22075 .22973 Mdot
.22075 .40991 Mdot
.22075 .59009 Mdot
.22075 .77027 Mdot
.22075 .95045 Mdot
.2766 .13964 Mdot
.2766 .31982 Mdot
.2766 .5 Mdot
.2766 .68018 Mdot
.2766 .86036 Mdot
.3883 .13964 Mdot
.3883 .31982 Mdot
.3883 .5 Mdot
.3883 .68018 Mdot
.3883 .86036 Mdot
.44415 .04955 Mdot
.44415 .22973 Mdot
.44415 .40991 Mdot
.44415 .59009 Mdot
.44415 .77027 Mdot
.44415 .95045 Mdot
.55585 .04955 Mdot
.55585 .22973 Mdot
.55585 .40991 Mdot
.55585 .59009 Mdot
.55585 .77027 Mdot
.55585 .95045 Mdot
.6117 .13964 Mdot
.6117 .31982 Mdot
.6117 .5 Mdot
.6117 .68018 Mdot
.6117 .86036 Mdot
.7234 .13964 Mdot
.7234 .31982 Mdot
.7234 .5 Mdot
.7234 .68018 Mdot
.7234 .86036 Mdot
.77925 .04955 Mdot
.77925 .22973 Mdot
.77925 .40991 Mdot
.77925 .59009 Mdot
.77925 .77027 Mdot
.77925 .95045 Mdot
.89095 .04955 Mdot
.89095 .22973 Mdot
.89095 .40991 Mdot
.89095 .59009 Mdot
.89095 .77027 Mdot
.89095 .95045 Mdot
.9468 .13964 Mdot
.9468 .31982 Mdot
.9468 .5 Mdot
.9468 .68018 Mdot
.9468 .86036 Mdot
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  CellLabel->"From In[36]:=",
  ImageSize->{288, 288},
  ImageMargins->{{0, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40004P000182000`400?l00000o`00003ooooooolQ
ooooo`00oooooolQooooo`00oooooolQooooo`00oooooolQooooo`00oooooolQooooo`00oooooolQ
ooooo`00oooooolQooooo`00oooooolQooooo`00oooooolQooooo`00oooooolQooooo`00oooooolQ
ooooo`00oooooolQooooo`007_ooool3o`0001gooooo0ol0000mooooo`?o00007Oooool3o`0003go
oooo0ol0000Mooooo`?o00007oooool001gooooo1Ol0000Kooooo`Go0000>oooool5o`0001_ooooo
1Ol0000kooooo`Go00006oooool5o`0001kooooo000Looooo`Oo00006Oooool7o`0003Wooooo1ol0
000Iooooo`Oo0000>Oooool7o`0001Wooooo1ol0000Mooooo`007?oooolWo`0003Wooooo9ol0000i
ooooobOo00007Oooool001cooooo1ol0000Iooooo`Oo0000>Oooool7o`0001Wooooo1ol0000ioooo
o`Oo00006Oooool7o`0001gooooo000Mooooo`Go00006oooool5o`0003_ooooo1Ol0000Kooooo`Go
0000>oooool5o`0001_ooooo1Ol0000Nooooo`007Oooool4o`0001gooooo1?l0000kooooo`Co0000
7Oooool4o`0003_ooooo1?l0000Mooooo`Co00007_ooool001gooooo00?o0000ooooooooool08Ooo
ool00ol0003oooooooooo`0iooooo`03o`000?oooooooooo027ooooo00?o0000ooooooooool0>Ooo
ool00ol0003oooooooooo`0Qooooo`03o`000?oooooooooo01cooooo000Looooo`03o`000?oooooo
oooo02?ooooo00?o0000ooooooooool0=oooool00ol0003oooooooooo`0Sooooo`03o`000?oooooo
oooo03Oooooo00?o0000ooooooooool08oooool00ol0003oooooooooo`0Kooooo`007?ooool00ol0
003oooooooooo`0Sooooo`03o`000?oooooooooo03Oooooo00?o0000ooooooooool08oooool00ol0
003oooooooooo`0gooooo`03o`000?oooooooooo02?ooooo00?o0000ooooooooool06oooool001_o
oooo00?o0000ooooooooool09Oooool00ol0003oooooooooo`0eooooo`03o`000?oooooooooo02Go
oooo00?o0000ooooooooool0=Oooool00ol0003oooooooooo`0Uooooo`03o`000?oooooooooo01[o
oooo000Jooooo`03o`000?oooooooooo02Oooooo00?o0000ooooooooool0<oooool00ol0003ooooo
ooooo`0Wooooo`03o`000?oooooooooo03?ooooo00?o0000ooooooooool09oooool00ol0003ooooo
ooooo`0Iooooo`006_ooool00ol0003oooooooooo`0Wooooo`03o`000?oooooooooo03?ooooo00?o
0000ooooooooool09oooool00ol0003oooooooooo`0cooooo`03o`000?oooooooooo02Oooooo00?o
0000ooooooooool06Oooool001Wooooo00?o0000ooooooooool0:Oooool00ol0003oooooooooo`0a
ooooo`03o`000?oooooooooo02Wooooo00?o0000ooooooooool0<Oooool00ol0003oooooooooo`0Y
ooooo`03o`000?oooooooooo01Sooooo000Iooooo`03o`000?oooooooooo02Wooooo00?o0000oooo
ooooool0<Oooool00ol0003oooooooooo`0Yooooo`03o`000?oooooooooo037ooooo00?o0000oooo
ooooool0:Oooool00ol0003oooooooooo`0Hooooo`006?ooool00ol0003oooooooooo`0[ooooo`03
o`000?oooooooooo02oooooo00?o0000ooooooooool0:oooool00ol0003oooooooooo`0_ooooo`03
o`000?oooooooooo02_ooooo00?o0000ooooooooool05oooool001Oooooo00?o0000ooooooooool0
;Oooool00ol0003oooooooooo`0]ooooo`03o`000?oooooooooo02gooooo00?o0000ooooooooool0
;Oooool00ol0003oooooooooo`0]ooooo`03o`000?oooooooooo01Kooooo000Gooooo`03o`000?oo
oooooooo02gooooo00?o0000ooooooooool0;Oooool00ol0003oooooooooo`0]ooooo`03o`000?oo
oooooooo02gooooo00?o0000ooooooooool0;Oooool00ol0003oooooooooo`0Fooooo`005_ooool0
0ol0003oooooooooo`0_ooooo`03o`000?oooooooooo02_ooooo00?o0000ooooooooool0;oooool0
0ol0003oooooooooo`0[ooooo`03o`000?oooooooooo02oooooo00?o0000ooooooooool05Oooool0
01Gooooo00?o0000ooooooooool0<Oooool00ol0003oooooooooo`0Yooooo`03o`000?oooooooooo
037ooooo00?o0000ooooooooool0:Oooool00ol0003oooooooooo`0aooooo`03o`000?oooooooooo
01Cooooo000Eooooo`03o`000?oooooooooo037ooooo00?o0000ooooooooool0:Oooool00ol0003o
ooooooooo`0aooooo`03o`000?oooooooooo02Wooooo00?o0000ooooooooool0<Oooool00ol0003o
ooooooooo`0Dooooo`005?ooool00ol0003oooooooooo`0cooooo`03o`000?oooooooooo02Oooooo
00?o0000ooooooooool0<oooool00ol0003oooooooooo`0Wooooo`03o`000?oooooooooo03?ooooo
00?o0000ooooooooool04oooool001Cooooo00?o0000ooooooooool0<oooool00ol0003ooooooooo
o`0Wooooo`03o`000?oooooooooo03?ooooo00?o0000ooooooooool09oooool00ol0003ooooooooo
o`0cooooo`03o`000?oooooooooo01?ooooo000Cooooo`03o`000?oooooooooo03Gooooo00?o0000
ooooooooool09Oooool00ol0003oooooooooo`0eooooo`03o`000?oooooooooo02Gooooo00?o0000
ooooooooool0=Oooool00ol0003oooooooooo`0Booooo`004_ooool00ol0003oooooooooo`0goooo
o`03o`000?oooooooooo02?ooooo00?o0000ooooooooool0=oooool00ol0003oooooooooo`0Soooo
o`03o`000?oooooooooo03Oooooo00?o0000ooooooooool04Oooool001;ooooo00?o0000oooooooo
ool0=oooool00ol0003oooooooooo`0Sooooo`03o`000?oooooooooo03Oooooo00?o0000oooooooo
ool08oooool00ol0003oooooooooo`0gooooo`03o`000?oooooooooo017ooooo000>ooooo`Co0000
>oooool4o`0001gooooo1?l0000kooooo`Co00007Oooool4o`0003_ooooo1?l0000?ooooo`003Ooo
ool5o`0003_ooooo1Ol0000Kooooo`Go0000>oooool5o`0001_ooooo1Ol0000kooooo`Go00003_oo
ool000cooooo1ol0000iooooo`Oo00006Oooool7o`0003Wooooo1ol0000Iooooo`Oo0000>Oooool7
o`0000gooooo000<ooooo`Oo0000>OoooolWo`0003Wooooo9ol0000iooooo`Oo00003Oooool000co
oooo1ol0000iooooo`Oo00006Oooool7o`0003Wooooo1ol0000Iooooo`Oo0000>Oooool7o`0000go
oooo000=ooooo`Go0000>oooool5o`0001_ooooo1Ol0000kooooo`Go00006oooool5o`0003_ooooo
1Ol0000>ooooo`003_ooool4o`0003_ooooo1?l0000Mooooo`Co0000>oooool4o`0001gooooo1?l0
000kooooo`Co00003oooool0017ooooo00?o0000ooooooooool0>Oooool00ol0003oooooooooo`0Q
ooooo`03o`000?oooooooooo03Wooooo00?o0000ooooooooool08Oooool00ol0003oooooooooo`0i
ooooo`03o`000?oooooooooo013ooooo000Booooo`03o`000?oooooooooo03Oooooo00?o0000oooo
ooooool08oooool00ol0003oooooooooo`0gooooo`03o`000?oooooooooo02?ooooo00?o0000oooo
ooooool0=oooool00ol0003oooooooooo`0Aooooo`004oooool00ol0003oooooooooo`0eooooo`03
o`000?oooooooooo02Gooooo00?o0000ooooooooool0=Oooool00ol0003oooooooooo`0Uooooo`03
o`000?oooooooooo03Gooooo00?o0000ooooooooool04_ooool001?ooooo00?o0000ooooooooool0
=Oooool00ol0003oooooooooo`0Uooooo`03o`000?oooooooooo03Gooooo00?o0000ooooooooool0
9Oooool00ol0003oooooooooo`0eooooo`03o`000?oooooooooo01;ooooo000Dooooo`03o`000?oo
oooooooo03?ooooo00?o0000ooooooooool09oooool00ol0003oooooooooo`0cooooo`03o`000?oo
oooooooo02Oooooo00?o0000ooooooooool0<oooool00ol0003oooooooooo`0Cooooo`005?ooool0
0ol0003oooooooooo`0cooooo`03o`000?oooooooooo02Oooooo00?o0000ooooooooool0<oooool0
0ol0003oooooooooo`0Wooooo`03o`000?oooooooooo03?ooooo00?o0000ooooooooool04oooool0
01Gooooo00?o0000ooooooooool0<Oooool00ol0003oooooooooo`0Yooooo`03o`000?oooooooooo
037ooooo00?o0000ooooooooool0:Oooool00ol0003oooooooooo`0aooooo`03o`000?oooooooooo
01Cooooo000Fooooo`03o`000?oooooooooo02oooooo00?o0000ooooooooool0:oooool00ol0003o
ooooooooo`0_ooooo`03o`000?oooooooooo02_ooooo00?o0000ooooooooool0;oooool00ol0003o
ooooooooo`0Eooooo`005_ooool00ol0003oooooooooo`0_ooooo`03o`000?oooooooooo02_ooooo
00?o0000ooooooooool0;oooool00ol0003oooooooooo`0[ooooo`03o`000?oooooooooo02oooooo
00?o0000ooooooooool05Oooool001Oooooo00?o0000ooooooooool0;Oooool00ol0003ooooooooo
o`0]ooooo`03o`000?oooooooooo02gooooo00?o0000ooooooooool0;Oooool00ol0003ooooooooo
o`0]ooooo`03o`000?oooooooooo01Kooooo000Hooooo`03o`000?oooooooooo02_ooooo00?o0000
ooooooooool0;oooool00ol0003oooooooooo`0[ooooo`03o`000?oooooooooo02oooooo00?o0000
ooooooooool0:oooool00ol0003oooooooooo`0Gooooo`006?ooool00ol0003oooooooooo`0[oooo
o`03o`000?oooooooooo02oooooo00?o0000ooooooooool0:oooool00ol0003oooooooooo`0_oooo
o`03o`000?oooooooooo02_ooooo00?o0000ooooooooool05oooool001Wooooo00?o0000oooooooo
ool0:Oooool00ol0003oooooooooo`0aooooo`03o`000?oooooooooo02Wooooo00?o0000oooooooo
ool0<Oooool00ol0003oooooooooo`0Yooooo`03o`000?oooooooooo01Sooooo000Jooooo`03o`00
0?oooooooooo02Oooooo00?o0000ooooooooool0<oooool00ol0003oooooooooo`0Wooooo`03o`00
0?oooooooooo03?ooooo00?o0000ooooooooool09oooool00ol0003oooooooooo`0Iooooo`006_oo
ool00ol0003oooooooooo`0Wooooo`03o`000?oooooooooo03?ooooo00?o0000ooooooooool09ooo
ool00ol0003oooooooooo`0cooooo`03o`000?oooooooooo02Oooooo00?o0000ooooooooool06Ooo
ool001_ooooo00?o0000ooooooooool09Oooool00ol0003oooooooooo`0eooooo`03o`000?oooooo
oooo02Gooooo00?o0000ooooooooool0=Oooool00ol0003oooooooooo`0Uooooo`03o`000?oooooo
oooo01[ooooo000Kooooo`03o`000?oooooooooo02Gooooo00?o0000ooooooooool0=Oooool00ol0
003oooooooooo`0Uooooo`03o`000?oooooooooo03Gooooo00?o0000ooooooooool09Oooool00ol0
003oooooooooo`0Jooooo`007?ooool00ol0003oooooooooo`0Sooooo`03o`000?oooooooooo03Oo
oooo00?o0000ooooooooool08oooool00ol0003oooooooooo`0gooooo`03o`000?oooooooooo02?o
oooo00?o0000ooooooooool06oooool001gooooo1?l0000Mooooo`Co0000>oooool4o`0001gooooo
1?l0000kooooo`Co00007Oooool4o`0001kooooo000Mooooo`Go00006oooool5o`0003_ooooo1Ol0
000Kooooo`Go0000>oooool5o`0001_ooooo1Ol0000Nooooo`007?ooool7o`0001Wooooo1ol0000i
ooooo`Oo00006Oooool7o`0003Wooooo1ol0000Iooooo`Oo00007Oooool001cooooo9ol0000ioooo
obOo0000>OoooolWo`0001gooooo000Looooo`Oo00006Oooool7o`0003Wooooo1ol0000Iooooo`Oo
0000>Oooool7o`0001Wooooo1ol0000Mooooo`007Oooool5o`0001_ooooo1Ol0000kooooo`Go0000
6oooool5o`0003_ooooo1Ol0000Kooooo`Go00007_ooool001gooooo1?l0000Mooooo`Co0000>ooo
ool4o`0001gooooo1?l0000kooooo`Co00007Oooool4o`0001kooooo000Mooooo`03o`000?oooooo
oooo027ooooo00?o0000ooooooooool0>Oooool00ol0003oooooooooo`0Qooooo`03o`000?oooooo
oooo03Wooooo00?o0000ooooooooool08Oooool00ol0003oooooooooo`0Looooo`007?ooool00ol0
003oooooooooo`0Sooooo`03o`000?oooooooooo03Oooooo00?o0000ooooooooool08oooool00ol0
003oooooooooo`0gooooo`03o`000?oooooooooo02?ooooo00?o0000ooooooooool06oooool001co
oooo00?o0000ooooooooool08oooool00ol0003oooooooooo`0gooooo`03o`000?oooooooooo02?o
oooo00?o0000ooooooooool0=oooool00ol0003oooooooooo`0Sooooo`03o`000?oooooooooo01_o
oooo000Kooooo`03o`000?oooooooooo02Gooooo00?o0000ooooooooool0=Oooool00ol0003ooooo
ooooo`0Uooooo`03o`000?oooooooooo03Gooooo00?o0000ooooooooool09Oooool00ol0003ooooo
ooooo`0Jooooo`006_ooool00ol0003oooooooooo`0Wooooo`03o`000?oooooooooo03?ooooo00?o
0000ooooooooool09oooool00ol0003oooooooooo`0cooooo`03o`000?oooooooooo02Oooooo00?o
0000ooooooooool06Oooool001[ooooo00?o0000ooooooooool09oooool00ol0003oooooooooo`0c
ooooo`03o`000?oooooooooo02Oooooo00?o0000ooooooooool0<oooool00ol0003oooooooooo`0W
ooooo`03o`000?oooooooooo01Wooooo000Iooooo`03o`000?oooooooooo02Wooooo00?o0000oooo
ooooool0<Oooool00ol0003oooooooooo`0Yooooo`03o`000?oooooooooo037ooooo00?o0000oooo
ooooool0:Oooool00ol0003oooooooooo`0Hooooo`006Oooool00ol0003oooooooooo`0Yooooo`03
o`000?oooooooooo037ooooo00?o0000ooooooooool0:Oooool00ol0003oooooooooo`0aooooo`03
o`000?oooooooooo02Wooooo00?o0000ooooooooool06?ooool001Sooooo00?o0000ooooooooool0
:oooool00ol0003oooooooooo`0_ooooo`03o`000?oooooooooo02_ooooo00?o0000ooooooooool0
;oooool00ol0003oooooooooo`0[ooooo`03o`000?oooooooooo01Oooooo000Gooooo`03o`000?oo
oooooooo02gooooo00?o0000ooooooooool0;Oooool00ol0003oooooooooo`0]ooooo`03o`000?oo
oooooooo02gooooo00?o0000ooooooooool0;Oooool00ol0003oooooooooo`0Fooooo`005oooool0
0ol0003oooooooooo`0]ooooo`03o`000?oooooooooo02gooooo00?o0000ooooooooool0;Oooool0
0ol0003oooooooooo`0]ooooo`03o`000?oooooooooo02gooooo00?o0000ooooooooool05_ooool0
01Kooooo00?o0000ooooooooool0;oooool00ol0003oooooooooo`0[ooooo`03o`000?oooooooooo
02oooooo00?o0000ooooooooool0:oooool00ol0003oooooooooo`0_ooooo`03o`000?oooooooooo
01Gooooo000Eooooo`03o`000?oooooooooo037ooooo00?o0000ooooooooool0:Oooool00ol0003o
ooooooooo`0aooooo`03o`000?oooooooooo02Wooooo00?o0000ooooooooool0<Oooool00ol0003o
ooooooooo`0Dooooo`005Oooool00ol0003oooooooooo`0aooooo`03o`000?oooooooooo02Wooooo
00?o0000ooooooooool0<Oooool00ol0003oooooooooo`0Yooooo`03o`000?oooooooooo037ooooo
00?o0000ooooooooool05?ooool001Cooooo00?o0000ooooooooool0<oooool00ol0003ooooooooo
o`0Wooooo`03o`000?oooooooooo03?ooooo00?o0000ooooooooool09oooool00ol0003ooooooooo
o`0cooooo`03o`000?oooooooooo01?ooooo000Dooooo`03o`000?oooooooooo03?ooooo00?o0000
ooooooooool09oooool00ol0003oooooooooo`0cooooo`03o`000?oooooooooo02Oooooo00?o0000
ooooooooool0<oooool00ol0003oooooooooo`0Cooooo`004oooool00ol0003oooooooooo`0eoooo
o`03o`000?oooooooooo02Gooooo00?o0000ooooooooool0=Oooool00ol0003oooooooooo`0Uoooo
o`03o`000?oooooooooo03Gooooo00?o0000ooooooooool04_ooool001;ooooo00?o0000oooooooo
ool0=oooool00ol0003oooooooooo`0Sooooo`03o`000?oooooooooo03Oooooo00?o0000oooooooo
ool08oooool00ol0003oooooooooo`0gooooo`03o`000?oooooooooo017ooooo000Booooo`03o`00
0?oooooooooo03Oooooo00?o0000ooooooooool08oooool00ol0003oooooooooo`0gooooo`03o`00
0?oooooooooo02?ooooo00?o0000ooooooooool0=oooool00ol0003oooooooooo`0Aooooo`003_oo
ool4o`0003_ooooo1?l0000Mooooo`Co0000>oooool4o`0001gooooo1?l0000kooooo`Co00003ooo
ool000gooooo1Ol0000kooooo`Go00006oooool5o`0003_ooooo1Ol0000Kooooo`Go0000>oooool5
o`0000kooooo000<ooooo`Oo0000>Oooool7o`0001Wooooo1ol0000iooooo`Oo00006Oooool7o`00
03Wooooo1ol0000=ooooo`003?ooool7o`0003Wooooo9ol0000iooooobOo0000>Oooool7o`0000go
oooo000<ooooo`Oo0000>Oooool7o`0001Wooooo1ol0000iooooo`Oo00006Oooool7o`0003Wooooo
1ol0000=ooooo`003Oooool5o`0003_ooooo1Ol0000Kooooo`Go0000>oooool5o`0001_ooooo1Ol0
000kooooo`Go00003_ooool000kooooo1?l0000kooooo`Co00007Oooool4o`0003_ooooo1?l0000M
ooooo`Co0000>oooool4o`0000oooooo000Aooooo`03o`000?oooooooooo03Wooooo00?o0000oooo
ooooool08Oooool00ol0003oooooooooo`0iooooo`03o`000?oooooooooo027ooooo00?o0000oooo
ooooool0>Oooool00ol0003oooooooooo`0@ooooo`004_ooool00ol0003oooooooooo`0gooooo`03
o`000?oooooooooo02?ooooo00?o0000ooooooooool0=oooool00ol0003oooooooooo`0Sooooo`03
o`000?oooooooooo03Oooooo00?o0000ooooooooool04Oooool001;ooooo00?o0000ooooooooool0
=oooool00ol0003oooooooooo`0Sooooo`03o`000?oooooooooo03Oooooo00?o0000ooooooooool0
8oooool00ol0003oooooooooo`0gooooo`03o`000?oooooooooo017ooooo000Cooooo`03o`000?oo
oooooooo03Gooooo00?o0000ooooooooool09Oooool00ol0003oooooooooo`0eooooo`03o`000?oo
oooooooo02Gooooo00?o0000ooooooooool0=Oooool00ol0003oooooooooo`0Booooo`005?ooool0
0ol0003oooooooooo`0cooooo`03o`000?oooooooooo02Oooooo00?o0000ooooooooool0<oooool0
0ol0003oooooooooo`0Wooooo`03o`000?oooooooooo03?ooooo00?o0000ooooooooool04oooool0
01Cooooo00?o0000ooooooooool0<oooool00ol0003oooooooooo`0Wooooo`03o`000?oooooooooo
03?ooooo00?o0000ooooooooool09oooool00ol0003oooooooooo`0cooooo`03o`000?oooooooooo
01?ooooo000Eooooo`03o`000?oooooooooo037ooooo00?o0000ooooooooool0:Oooool00ol0003o
ooooooooo`0aooooo`03o`000?oooooooooo02Wooooo00?o0000ooooooooool0<Oooool00ol0003o
ooooooooo`0Dooooo`005Oooool00ol0003oooooooooo`0aooooo`03o`000?oooooooooo02Wooooo
00?o0000ooooooooool0<Oooool00ol0003oooooooooo`0Yooooo`03o`000?oooooooooo037ooooo
00?o0000ooooooooool05?ooool001Kooooo00?o0000ooooooooool0;oooool00ol0003ooooooooo
o`0[ooooo`03o`000?oooooooooo02oooooo00?o0000ooooooooool0:oooool00ol0003ooooooooo
o`0_ooooo`03o`000?oooooooooo01Gooooo000Gooooo`03o`000?oooooooooo02gooooo00?o0000
ooooooooool0;Oooool00ol0003oooooooooo`0]ooooo`03o`000?oooooooooo02gooooo00?o0000
ooooooooool0;Oooool00ol0003oooooooooo`0Fooooo`005oooool00ol0003oooooooooo`0]oooo
o`03o`000?oooooooooo02gooooo00?o0000ooooooooool0;Oooool00ol0003oooooooooo`0]oooo
o`03o`000?oooooooooo02gooooo00?o0000ooooooooool05_ooool001Sooooo00?o0000oooooooo
ool0:oooool00ol0003oooooooooo`0_ooooo`03o`000?oooooooooo02_ooooo00?o0000oooooooo
ool0;oooool00ol0003oooooooooo`0[ooooo`03o`000?oooooooooo01Oooooo000Iooooo`03o`00
0?oooooooooo02Wooooo00?o0000ooooooooool0<Oooool00ol0003oooooooooo`0Yooooo`03o`00
0?oooooooooo037ooooo00?o0000ooooooooool0:Oooool00ol0003oooooooooo`0Hooooo`006Ooo
ool00ol0003oooooooooo`0Yooooo`03o`000?oooooooooo037ooooo00?o0000ooooooooool0:Ooo
ool00ol0003oooooooooo`0aooooo`03o`000?oooooooooo02Wooooo00?o0000ooooooooool06?oo
ool001[ooooo00?o0000ooooooooool09oooool00ol0003oooooooooo`0cooooo`03o`000?oooooo
oooo02Oooooo00?o0000ooooooooool0<oooool00ol0003oooooooooo`0Wooooo`03o`000?oooooo
oooo01Wooooo000Jooooo`03o`000?oooooooooo02Oooooo00?o0000ooooooooool0<oooool00ol0
003oooooooooo`0Wooooo`03o`000?oooooooooo03?ooooo00?o0000ooooooooool09oooool00ol0
003oooooooooo`0Iooooo`006oooool00ol0003oooooooooo`0Uooooo`03o`000?oooooooooo03Go
oooo00?o0000ooooooooool09Oooool00ol0003oooooooooo`0eooooo`03o`000?oooooooooo02Go
oooo00?o0000ooooooooool06_ooool001cooooo00?o0000ooooooooool08oooool00ol0003ooooo
ooooo`0gooooo`03o`000?oooooooooo02?ooooo00?o0000ooooooooool0=oooool00ol0003ooooo
ooooo`0Sooooo`03o`000?oooooooooo01_ooooo000Looooo`03o`000?oooooooooo02?ooooo00?o
0000ooooooooool0=oooool00ol0003oooooooooo`0Sooooo`03o`000?oooooooooo03Oooooo00?o
0000ooooooooool08oooool00ol0003oooooooooo`0Kooooo`007Oooool4o`0001gooooo1?l0000k
ooooo`Co00007Oooool4o`0003_ooooo1?l0000Mooooo`Co00007_ooool001gooooo1Ol0000Koooo
o`Go0000>oooool5o`0001_ooooo1Ol0000kooooo`Go00006oooool5o`0001kooooo000Looooo`Oo
00006Oooool7o`0003Wooooo1ol0000Iooooo`Oo0000>Oooool7o`0001Wooooo1ol0000Mooooo`00
7?oooolWo`0003Wooooo9ol0000iooooobOo00007Oooool001cooooo1ol0000Iooooo`Oo0000>Ooo
ool7o`0001Wooooo1ol0000iooooo`Oo00006Oooool7o`0001gooooo000Mooooo`Go00006oooool5
o`0003_ooooo1Ol0000Kooooo`Go0000>oooool5o`0001_ooooo1Ol0000Nooooo`007Oooool4o`00
01gooooo1?l0000kooooo`Co00007Oooool4o`0003_ooooo1?l0000Mooooo`Co00007_ooool001go
oooo00?o0000ooooooooool08Oooool00ol0003oooooooooo`0iooooo`03o`000?oooooooooo027o
oooo00?o0000ooooooooool0>Oooool00ol0003oooooooooo`0Qooooo`03o`000?oooooooooo01co
oooo000Looooo`03o`000?oooooooooo02?ooooo00?o0000ooooooooool0=oooool00ol0003ooooo
ooooo`0Sooooo`03o`000?oooooooooo03Oooooo00?o0000ooooooooool08oooool00ol0003ooooo
ooooo`0Kooooo`007?ooool00ol0003oooooooooo`0Sooooo`03o`000?oooooooooo03Oooooo00?o
0000ooooooooool08oooool00ol0003oooooooooo`0gooooo`03o`000?oooooooooo02?ooooo00?o
0000ooooooooool06oooool001_ooooo00?o0000ooooooooool09Oooool00ol0003oooooooooo`0e
ooooo`03o`000?oooooooooo02Gooooo00?o0000ooooooooool0=Oooool00ol0003oooooooooo`0U
ooooo`03o`000?oooooooooo01[ooooo000Jooooo`03o`000?oooooooooo02Oooooo00?o0000oooo
ooooool0<oooool00ol0003oooooooooo`0Wooooo`03o`000?oooooooooo03?ooooo00?o0000oooo
ooooool09oooool00ol0003oooooooooo`0Iooooo`006_ooool00ol0003oooooooooo`0Wooooo`03
o`000?oooooooooo03?ooooo00?o0000ooooooooool09oooool00ol0003oooooooooo`0cooooo`03
o`000?oooooooooo02Oooooo00?o0000ooooooooool06Oooool001Wooooo00?o0000ooooooooool0
:Oooool00ol0003oooooooooo`0aooooo`03o`000?oooooooooo02Wooooo00?o0000ooooooooool0
<Oooool00ol0003oooooooooo`0Yooooo`03o`000?oooooooooo01Sooooo000Iooooo`03o`000?oo
oooooooo02Wooooo00?o0000ooooooooool0<Oooool00ol0003oooooooooo`0Yooooo`03o`000?oo
oooooooo037ooooo00?o0000ooooooooool0:Oooool00ol0003oooooooooo`0Hooooo`006?ooool0
0ol0003oooooooooo`0[ooooo`03o`000?oooooooooo02oooooo00?o0000ooooooooool0:oooool0
0ol0003oooooooooo`0_ooooo`03o`000?oooooooooo02_ooooo00?o0000ooooooooool05oooool0
01Oooooo00?o0000ooooooooool0;Oooool00ol0003oooooooooo`0]ooooo`03o`000?oooooooooo
02gooooo00?o0000ooooooooool0;Oooool00ol0003oooooooooo`0]ooooo`03o`000?oooooooooo
01Kooooo000Gooooo`03o`000?oooooooooo02gooooo00?o0000ooooooooool0;Oooool00ol0003o
ooooooooo`0]ooooo`03o`000?oooooooooo02gooooo00?o0000ooooooooool0;Oooool00ol0003o
ooooooooo`0Fooooo`005_ooool00ol0003oooooooooo`0_ooooo`03o`000?oooooooooo02_ooooo
00?o0000ooooooooool0;oooool00ol0003oooooooooo`0[ooooo`03o`000?oooooooooo02oooooo
00?o0000ooooooooool05Oooool001Gooooo00?o0000ooooooooool0<Oooool00ol0003ooooooooo
o`0Yooooo`03o`000?oooooooooo037ooooo00?o0000ooooooooool0:Oooool00ol0003ooooooooo
o`0aooooo`03o`000?oooooooooo01Cooooo000Eooooo`03o`000?oooooooooo037ooooo00?o0000
ooooooooool0:Oooool00ol0003oooooooooo`0aooooo`03o`000?oooooooooo02Wooooo00?o0000
ooooooooool0<Oooool00ol0003oooooooooo`0Dooooo`005?ooool00ol0003oooooooooo`0coooo
o`03o`000?oooooooooo02Oooooo00?o0000ooooooooool0<oooool00ol0003oooooooooo`0Woooo
o`03o`000?oooooooooo03?ooooo00?o0000ooooooooool04oooool001Cooooo00?o0000oooooooo
ool0<oooool00ol0003oooooooooo`0Wooooo`03o`000?oooooooooo03?ooooo00?o0000oooooooo
ool09oooool00ol0003oooooooooo`0cooooo`03o`000?oooooooooo01?ooooo000Cooooo`03o`00
0?oooooooooo03Gooooo00?o0000ooooooooool09Oooool00ol0003oooooooooo`0eooooo`03o`00
0?oooooooooo02Gooooo00?o0000ooooooooool0=Oooool00ol0003oooooooooo`0Booooo`004_oo
ool00ol0003oooooooooo`0gooooo`03o`000?oooooooooo02?ooooo00?o0000ooooooooool0=ooo
ool00ol0003oooooooooo`0Sooooo`03o`000?oooooooooo03Oooooo00?o0000ooooooooool04Ooo
ool001;ooooo00?o0000ooooooooool0=oooool00ol0003oooooooooo`0Sooooo`03o`000?oooooo
oooo03Oooooo00?o0000ooooooooool08oooool00ol0003oooooooooo`0gooooo`03o`000?oooooo
oooo017ooooo000>ooooo`Co0000>oooool4o`0001gooooo1?l0000kooooo`Co00007Oooool4o`00
03_ooooo1?l0000?ooooo`003Oooool5o`0003_ooooo1Ol0000Kooooo`Go0000>oooool5o`0001_o
oooo1Ol0000kooooo`Go00003_ooool000cooooo1ol0000iooooo`Oo00006Oooool7o`0003Wooooo
1ol0000Iooooo`Oo0000>Oooool7o`0000gooooo000<ooooo`Oo0000>OoooolWo`0003Wooooo9ol0
000iooooo`Oo00003Oooool000cooooo1ol0000iooooo`Oo00006Oooool7o`0003Wooooo1ol0000I
ooooo`Oo0000>Oooool7o`0000gooooo000=ooooo`Go0000>oooool5o`0001_ooooo1Ol0000koooo
o`Go00006oooool5o`0003_ooooo1Ol0000>ooooo`003_ooool4o`0003_ooooo1?l0000Mooooo`Co
0000>oooool4o`0001gooooo1?l0000kooooo`Co00003oooool0017ooooo00?o0000ooooooooool0
>Oooool00ol0003oooooooooo`0Qooooo`03o`000?oooooooooo03Wooooo00?o0000ooooooooool0
8Oooool00ol0003oooooooooo`0iooooo`03o`000?oooooooooo013ooooo000Booooo`03o`000?oo
oooooooo03Oooooo00?o0000ooooooooool08oooool00ol0003oooooooooo`0gooooo`03o`000?oo
oooooooo02?ooooo00?o0000ooooooooool0=oooool00ol0003oooooooooo`0Aooooo`004_ooool0
0ol0003oooooooooo`0gooooo`03o`000?oooooooooo02?ooooo00?o0000ooooooooool0=oooool0
0ol0003oooooooooo`0Sooooo`03o`000?oooooooooo03Oooooo00?o0000ooooooooool04Oooool0
01?ooooo00?o0000ooooooooool0=Oooool00ol0003oooooooooo`0Uooooo`03o`000?oooooooooo
03Gooooo00?o0000ooooooooool09Oooool00ol0003oooooooooo`0eooooo`03o`000?oooooooooo
01;ooooo000Dooooo`03o`000?oooooooooo03?ooooo00?o0000ooooooooool09oooool00ol0003o
ooooooooo`0cooooo`03o`000?oooooooooo02Oooooo00?o0000ooooooooool0<oooool00ol0003o
ooooooooo`0Cooooo`005?ooool00ol0003oooooooooo`0cooooo`03o`000?oooooooooo02Oooooo
00?o0000ooooooooool0<oooool00ol0003oooooooooo`0Wooooo`03o`000?oooooooooo03?ooooo
00?o0000ooooooooool04oooool001Gooooo00?o0000ooooooooool0<Oooool00ol0003ooooooooo
o`0Yooooo`03o`000?oooooooooo037ooooo00?o0000ooooooooool0:Oooool00ol0003ooooooooo
o`0aooooo`03o`000?oooooooooo01Cooooo000Eooooo`03o`000?oooooooooo037ooooo00?o0000
ooooooooool0:Oooool00ol0003oooooooooo`0aooooo`03o`000?oooooooooo02Wooooo00?o0000
ooooooooool0<Oooool00ol0003oooooooooo`0Dooooo`005_ooool00ol0003oooooooooo`0_oooo
o`03o`000?oooooooooo02_ooooo00?o0000ooooooooool0;oooool00ol0003oooooooooo`0[oooo
o`03o`000?oooooooooo02oooooo00?o0000ooooooooool05Oooool001Oooooo00?o0000oooooooo
ool0;Oooool00ol0003oooooooooo`0]ooooo`03o`000?oooooooooo02gooooo00?o0000oooooooo
ool0;Oooool00ol0003oooooooooo`0]ooooo`03o`000?oooooooooo01Kooooo000Gooooo`03o`00
0?oooooooooo02gooooo00?o0000ooooooooool0;Oooool00ol0003oooooooooo`0]ooooo`03o`00
0?oooooooooo02gooooo00?o0000ooooooooool0;Oooool00ol0003oooooooooo`0Fooooo`006?oo
ool00ol0003oooooooooo`0[ooooo`03o`000?oooooooooo02oooooo00?o0000ooooooooool0:ooo
ool00ol0003oooooooooo`0_ooooo`03o`000?oooooooooo02_ooooo00?o0000ooooooooool05ooo
ool001Wooooo00?o0000ooooooooool0:Oooool00ol0003oooooooooo`0aooooo`03o`000?oooooo
oooo02Wooooo00?o0000ooooooooool0<Oooool00ol0003oooooooooo`0Yooooo`03o`000?oooooo
oooo01Sooooo000Iooooo`03o`000?oooooooooo02Wooooo00?o0000ooooooooool0<Oooool00ol0
003oooooooooo`0Yooooo`03o`000?oooooooooo037ooooo00?o0000ooooooooool0:Oooool00ol0
003oooooooooo`0Hooooo`006_ooool00ol0003oooooooooo`0Wooooo`03o`000?oooooooooo03?o
oooo00?o0000ooooooooool09oooool00ol0003oooooooooo`0cooooo`03o`000?oooooooooo02Oo
oooo00?o0000ooooooooool06Oooool001[ooooo00?o0000ooooooooool09oooool00ol0003ooooo
ooooo`0cooooo`03o`000?oooooooooo02Oooooo00?o0000ooooooooool0<oooool00ol0003ooooo
ooooo`0Wooooo`03o`000?oooooooooo01Wooooo000Kooooo`03o`000?oooooooooo02Gooooo00?o
0000ooooooooool0=Oooool00ol0003oooooooooo`0Uooooo`03o`000?oooooooooo03Gooooo00?o
0000ooooooooool09Oooool00ol0003oooooooooo`0Jooooo`007?ooool00ol0003oooooooooo`0S
ooooo`03o`000?oooooooooo03Oooooo00?o0000ooooooooool08oooool00ol0003oooooooooo`0g
ooooo`03o`000?oooooooooo02?ooooo00?o0000ooooooooool06oooool001cooooo00?o0000oooo
ooooool08oooool00ol0003oooooooooo`0gooooo`03o`000?oooooooooo02?ooooo00?o0000oooo
ooooool0=oooool00ol0003oooooooooo`0Sooooo`03o`000?oooooooooo01_ooooo000Mooooo`Co
00007Oooool4o`0003_ooooo1?l0000Mooooo`Co0000>oooool4o`0001gooooo1?l0000Nooooo`00
7Oooool5o`0001_ooooo1Ol0000kooooo`Go00006oooool5o`0003_ooooo1Ol0000Kooooo`Go0000
7_ooool001cooooo1ol0000Iooooo`Oo0000>Oooool7o`0001Wooooo1ol0000iooooo`Oo00006Ooo
ool7o`0001gooooo000LooooobOo0000>OoooolWo`0003Wooooo9ol0000Mooooo`007?ooool7o`00
01Wooooo1ol0000iooooo`Oo00006Oooool7o`0003Wooooo1ol0000Iooooo`Oo00007Oooool001go
oooo1Ol0000Kooooo`Go0000>oooool5o`0001_ooooo1Ol0000kooooo`Go00006oooool5o`0001ko
oooo000Mooooo`Co00007Oooool4o`0003_ooooo1?l0000Mooooo`Co0000>oooool4o`0001gooooo
1?l0000Nooooo`007Oooool00ol0003oooooooooo`0Qooooo`03o`000?oooooooooo03Wooooo00?o
0000ooooooooool08Oooool00ol0003oooooooooo`0iooooo`03o`000?oooooooooo027ooooo00?o
0000ooooooooool07?ooool001cooooo00?o0000ooooooooool08oooool00ol0003oooooooooo`0g
ooooo`03o`000?oooooooooo02?ooooo00?o0000ooooooooool0=oooool00ol0003oooooooooo`0S
ooooo`03o`000?oooooooooo01_ooooo000Looooo`03o`000?oooooooooo02?ooooo00?o0000oooo
ooooool0=oooool00ol0003oooooooooo`0Sooooo`03o`000?oooooooooo03Oooooo00?o0000oooo
ooooool08oooool00ol0003oooooooooo`0Kooooo`006oooool00ol0003oooooooooo`0Uooooo`03
o`000?oooooooooo03Gooooo00?o0000ooooooooool09Oooool00ol0003oooooooooo`0eooooo`03
o`000?oooooooooo02Gooooo00?o0000ooooooooool06_ooool001[ooooo00?o0000ooooooooool0
9oooool00ol0003oooooooooo`0cooooo`03o`000?oooooooooo02Oooooo00?o0000ooooooooool0
<oooool00ol0003oooooooooo`0Wooooo`03o`000?oooooooooo01Wooooo000Jooooo`03o`000?oo
oooooooo02Oooooo00?o0000ooooooooool0<oooool00ol0003oooooooooo`0Wooooo`03o`000?oo
oooooooo03?ooooo00?o0000ooooooooool09oooool00ol0003oooooooooo`0Iooooo`006Oooool0
0ol0003oooooooooo`0Yooooo`03o`000?oooooooooo037ooooo00?o0000ooooooooool0:Oooool0
0ol0003oooooooooo`0aooooo`03o`000?oooooooooo02Wooooo00?o0000ooooooooool06?ooool0
01Wooooo00?o0000ooooooooool0:Oooool00ol0003oooooooooo`0aooooo`03o`000?oooooooooo
02Wooooo00?o0000ooooooooool0<Oooool00ol0003oooooooooo`0Yooooo`03o`000?oooooooooo
01Sooooo000Hooooo`03o`000?oooooooooo02_ooooo00?o0000ooooooooool0;oooool00ol0003o
ooooooooo`0[ooooo`03o`000?oooooooooo02oooooo00?o0000ooooooooool0:oooool00ol0003o
ooooooooo`0Gooooo`005oooool00ol0003oooooooooo`0]ooooo`03o`000?oooooooooo02gooooo
00?o0000ooooooooool0;Oooool00ol0003oooooooooo`0]ooooo`03o`000?oooooooooo02gooooo
00?o0000ooooooooool05_ooool001Oooooo00?o0000ooooooooool0;Oooool00ol0003ooooooooo
o`0]ooooo`03o`000?oooooooooo02gooooo00?o0000ooooooooool0;Oooool00ol0003ooooooooo
o`0]ooooo`03o`000?oooooooooo01Kooooo000Fooooo`03o`000?oooooooooo02oooooo00?o0000
ooooooooool0:oooool00ol0003oooooooooo`0_ooooo`03o`000?oooooooooo02_ooooo00?o0000
ooooooooool0;oooool00ol0003oooooooooo`0Eooooo`005Oooool00ol0003oooooooooo`0aoooo
o`03o`000?oooooooooo02Wooooo00?o0000ooooooooool0<Oooool00ol0003oooooooooo`0Yoooo
o`03o`000?oooooooooo037ooooo00?o0000ooooooooool05?ooool001Gooooo00?o0000oooooooo
ool0<Oooool00ol0003oooooooooo`0Yooooo`03o`000?oooooooooo037ooooo00?o0000oooooooo
ool0:Oooool00ol0003oooooooooo`0aooooo`03o`000?oooooooooo01Cooooo000Dooooo`03o`00
0?oooooooooo03?ooooo00?o0000ooooooooool09oooool00ol0003oooooooooo`0cooooo`03o`00
0?oooooooooo02Oooooo00?o0000ooooooooool0<oooool00ol0003oooooooooo`0Cooooo`005?oo
ool00ol0003oooooooooo`0cooooo`03o`000?oooooooooo02Oooooo00?o0000ooooooooool0<ooo
ool00ol0003oooooooooo`0Wooooo`03o`000?oooooooooo03?ooooo00?o0000ooooooooool04ooo
ool001?ooooo00?o0000ooooooooool0=Oooool00ol0003oooooooooo`0Uooooo`03o`000?oooooo
oooo03Gooooo00?o0000ooooooooool09Oooool00ol0003oooooooooo`0eooooo`03o`000?oooooo
oooo01;ooooo000Booooo`03o`000?oooooooooo03Oooooo00?o0000ooooooooool08oooool00ol0
003oooooooooo`0gooooo`03o`000?oooooooooo02?ooooo00?o0000ooooooooool0=oooool00ol0
003oooooooooo`0Aooooo`004_ooool00ol0003oooooooooo`0gooooo`03o`000?oooooooooo02?o
oooo00?o0000ooooooooool0=oooool00ol0003oooooooooo`0Sooooo`03o`000?oooooooooo03Oo
oooo00?o0000ooooooooool04Oooool000kooooo1?l0000kooooo`Co00007Oooool4o`0003_ooooo
1?l0000Mooooo`Co0000>oooool4o`0000oooooo000=ooooo`Go0000>oooool5o`0001_ooooo1Ol0
000kooooo`Go00006oooool5o`0003_ooooo1Ol0000>ooooo`003?ooool7o`0003Wooooo1ol0000I
ooooo`Oo0000>Oooool7o`0001Wooooo1ol0000iooooo`Oo00003Oooool000cooooo1ol0000ioooo
obOo0000>OoooolWo`0003Wooooo1ol0000=ooooo`003?ooool7o`0003Wooooo1ol0000Iooooo`Oo
0000>Oooool7o`0001Wooooo1ol0000iooooo`Oo00003Oooool000gooooo1Ol0000kooooo`Go0000
6oooool5o`0003_ooooo1Ol0000Kooooo`Go0000>oooool5o`0000kooooo000>ooooo`Co0000>ooo
ool4o`0001gooooo1?l0000kooooo`Co00007Oooool4o`0003_ooooo1?l0000?ooooo`004Oooool0
0ol0003oooooooooo`0iooooo`03o`000?oooooooooo027ooooo00?o0000ooooooooool0>Oooool0
0ol0003oooooooooo`0Qooooo`03o`000?oooooooooo03Wooooo00?o0000ooooooooool04?ooool0
01;ooooo00?o0000ooooooooool0=oooool00ol0003oooooooooo`0Sooooo`03o`000?oooooooooo
03Oooooo00?o0000ooooooooool08oooool00ol0003oooooooooo`0gooooo`03o`000?oooooooooo
017ooooo000Booooo`03o`000?oooooooooo03Oooooo00?o0000ooooooooool08oooool00ol0003o
ooooooooo`0gooooo`03o`000?oooooooooo02?ooooo00?o0000ooooooooool0=oooool00ol0003o
ooooooooo`0Aooooo`004oooool00ol0003oooooooooo`0eooooo`03o`000?oooooooooo02Gooooo
00?o0000ooooooooool0=Oooool00ol0003oooooooooo`0Uooooo`03o`000?oooooooooo03Gooooo
00?o0000ooooooooool04_ooool001Cooooo00?o0000ooooooooool0<oooool00ol0003ooooooooo
o`0Wooooo`03o`000?oooooooooo03?ooooo00?o0000ooooooooool09oooool00ol0003ooooooooo
o`0cooooo`03o`000?oooooooooo01?ooooo000Dooooo`03o`000?oooooooooo03?ooooo00?o0000
ooooooooool09oooool00ol0003oooooooooo`0cooooo`03o`000?oooooooooo02Oooooo00?o0000
ooooooooool0<oooool00ol0003oooooooooo`0Cooooo`005Oooool00ol0003oooooooooo`0aoooo
o`03o`000?oooooooooo02Wooooo00?o0000ooooooooool0<Oooool00ol0003oooooooooo`0Yoooo
o`03o`000?oooooooooo037ooooo00?o0000ooooooooool05?ooool001Gooooo00?o0000oooooooo
ool0<Oooool00ol0003oooooooooo`0Yooooo`03o`000?oooooooooo037ooooo00?o0000oooooooo
ool0:Oooool00ol0003oooooooooo`0aooooo`03o`000?oooooooooo01Cooooo000Fooooo`03o`00
0?oooooooooo02oooooo00?o0000ooooooooool0:oooool00ol0003oooooooooo`0_ooooo`03o`00
0?oooooooooo02_ooooo00?o0000ooooooooool0;oooool00ol0003oooooooooo`0Eooooo`005ooo
ool00ol0003oooooooooo`0]ooooo`03o`000?oooooooooo02gooooo00?o0000ooooooooool0;Ooo
ool00ol0003oooooooooo`0]ooooo`03o`000?oooooooooo02gooooo00?o0000ooooooooool05_oo
ool001Oooooo00?o0000ooooooooool0;Oooool00ol0003oooooooooo`0]ooooo`03o`000?oooooo
oooo02gooooo00?o0000ooooooooool0;Oooool00ol0003oooooooooo`0]ooooo`03o`000?oooooo
oooo01Kooooo000Hooooo`03o`000?oooooooooo02_ooooo00?o0000ooooooooool0;oooool00ol0
003oooooooooo`0[ooooo`03o`000?oooooooooo02oooooo00?o0000ooooooooool0:oooool00ol0
003oooooooooo`0Gooooo`006Oooool00ol0003oooooooooo`0Yooooo`03o`000?oooooooooo037o
oooo00?o0000ooooooooool0:Oooool00ol0003oooooooooo`0aooooo`03o`000?oooooooooo02Wo
oooo00?o0000ooooooooool06?ooool001Wooooo00?o0000ooooooooool0:Oooool00ol0003ooooo
ooooo`0aooooo`03o`000?oooooooooo02Wooooo00?o0000ooooooooool0<Oooool00ol0003ooooo
ooooo`0Yooooo`03o`000?oooooooooo01Sooooo000Jooooo`03o`000?oooooooooo02Oooooo00?o
0000ooooooooool0<oooool00ol0003oooooooooo`0Wooooo`03o`000?oooooooooo03?ooooo00?o
0000ooooooooool09oooool00ol0003oooooooooo`0Iooooo`006_ooool00ol0003oooooooooo`0W
ooooo`03o`000?oooooooooo03?ooooo00?o0000ooooooooool09oooool00ol0003oooooooooo`0c
ooooo`03o`000?oooooooooo02Oooooo00?o0000ooooooooool06Oooool001_ooooo00?o0000oooo
ooooool09Oooool00ol0003oooooooooo`0eooooo`03o`000?oooooooooo02Gooooo00?o0000oooo
ooooool0=Oooool00ol0003oooooooooo`0Uooooo`03o`000?oooooooooo01[ooooo000Looooo`03
o`000?oooooooooo02?ooooo00?o0000ooooooooool0=oooool00ol0003oooooooooo`0Sooooo`03
o`000?oooooooooo03Oooooo00?o0000ooooooooool08oooool00ol0003oooooooooo`0Kooooo`00
7?ooool00ol0003oooooooooo`0Sooooo`03o`000?oooooooooo03Oooooo00?o0000ooooooooool0
8oooool00ol0003oooooooooo`0gooooo`03o`000?oooooooooo02?ooooo00?o0000ooooooooool0
6oooool001gooooo1?l0000Mooooo`Co0000>oooool4o`0001gooooo1?l0000kooooo`Co00007Ooo
ool4o`0001kooooo000Mooooo`Go00006oooool5o`0003_ooooo1Ol0000Kooooo`Go0000>oooool5
o`0001_ooooo1Ol0000Nooooo`007?ooool7o`0001Wooooo1ol0000iooooo`Oo00006Oooool7o`00
03Wooooo1ol0000Iooooo`Oo00007Oooool001cooooo9ol0000iooooobOo0000>OoooolWo`0001go
oooo000Looooo`Oo00006Oooool7o`0003Wooooo1ol0000Iooooo`Oo0000>Oooool7o`0001Wooooo
1ol0000Mooooo`007Oooool5o`0001_ooooo1Ol0000kooooo`Go00006oooool5o`0003_ooooo1Ol0
000Kooooo`Go00007_ooool001gooooo1?l0000Mooooo`Co0000>oooool4o`0001gooooo1?l0000k
ooooo`Co00007Oooool4o`0001kooooo000Mooooo`03o`000?oooooooooo027ooooo00?o0000oooo
ooooool0>Oooool00ol0003oooooooooo`0Qooooo`03o`000?oooooooooo03Wooooo00?o0000oooo
ooooool08Oooool00ol0003oooooooooo`0Looooo`007?ooool00ol0003oooooooooo`0Sooooo`03
o`000?oooooooooo03Oooooo00?o0000ooooooooool08oooool00ol0003oooooooooo`0gooooo`03
o`000?oooooooooo02?ooooo00?o0000ooooooooool06oooool001_ooooo00?o0000ooooooooool0
9Oooool00ol0003oooooooooo`0eooooo`03o`000?oooooooooo02Gooooo00?o0000ooooooooool0
=Oooool00ol0003oooooooooo`0Uooooo`03o`000?oooooooooo01[ooooo000Kooooo`03o`000?oo
oooooooo02Gooooo00?o0000ooooooooool0=Oooool00ol0003oooooooooo`0Uooooo`03o`000?oo
oooooooo03Gooooo00?o0000ooooooooool09Oooool00ol0003oooooooooo`0Jooooo`006_ooool0
0ol0003oooooooooo`0Wooooo`03o`000?oooooooooo03?ooooo00?o0000ooooooooool09oooool0
0ol0003oooooooooo`0cooooo`03o`000?oooooooooo02Oooooo00?o0000ooooooooool06Oooool0
01[ooooo00?o0000ooooooooool09oooool00ol0003oooooooooo`0cooooo`03o`000?oooooooooo
02Oooooo00?o0000ooooooooool0<oooool00ol0003oooooooooo`0Wooooo`03o`000?oooooooooo
01Wooooo000Iooooo`03o`000?oooooooooo02Wooooo00?o0000ooooooooool0<Oooool00ol0003o
ooooooooo`0Yooooo`03o`000?oooooooooo037ooooo00?o0000ooooooooool0:Oooool00ol0003o
ooooooooo`0Hooooo`006?ooool00ol0003oooooooooo`0[ooooo`03o`000?oooooooooo02oooooo
00?o0000ooooooooool0:oooool00ol0003oooooooooo`0_ooooo`03o`000?oooooooooo02_ooooo
00?o0000ooooooooool05oooool001Sooooo00?o0000ooooooooool0:oooool00ol0003ooooooooo
o`0_ooooo`03o`000?oooooooooo02_ooooo00?o0000ooooooooool0;oooool00ol0003ooooooooo
o`0[ooooo`03o`000?oooooooooo01Oooooo000Gooooo`03o`000?oooooooooo02gooooo00?o0000
ooooooooool0;Oooool00ol0003oooooooooo`0]ooooo`03o`000?oooooooooo02gooooo00?o0000
ooooooooool0;Oooool00ol0003oooooooooo`0Fooooo`005_ooool00ol0003oooooooooo`0_oooo
o`03o`000?oooooooooo02_ooooo00?o0000ooooooooool0;oooool00ol0003oooooooooo`0[oooo
o`03o`000?oooooooooo02oooooo00?o0000ooooooooool05Oooool001Kooooo00?o0000oooooooo
ool0;oooool00ol0003oooooooooo`0[ooooo`03o`000?oooooooooo02oooooo00?o0000oooooooo
ool0:oooool00ol0003oooooooooo`0_ooooo`03o`000?oooooooooo01Gooooo000Eooooo`03o`00
0?oooooooooo037ooooo00?o0000ooooooooool0:Oooool00ol0003oooooooooo`0aooooo`03o`00
0?oooooooooo02Wooooo00?o0000ooooooooool0<Oooool00ol0003oooooooooo`0Dooooo`005?oo
ool00ol0003oooooooooo`0cooooo`03o`000?oooooooooo02Oooooo00?o0000ooooooooool0<ooo
ool00ol0003oooooooooo`0Wooooo`03o`000?oooooooooo03?ooooo00?o0000ooooooooool04ooo
ool001Cooooo00?o0000ooooooooool0<oooool00ol0003oooooooooo`0Wooooo`03o`000?oooooo
oooo03?ooooo00?o0000ooooooooool09oooool00ol0003oooooooooo`0cooooo`03o`000?oooooo
oooo01?ooooo000Cooooo`03o`000?oooooooooo03Gooooo00?o0000ooooooooool09Oooool00ol0
003oooooooooo`0eooooo`03o`000?oooooooooo02Gooooo00?o0000ooooooooool0=Oooool00ol0
003oooooooooo`0Booooo`004oooool00ol0003oooooooooo`0eooooo`03o`000?oooooooooo02Go
oooo00?o0000ooooooooool0=Oooool00ol0003oooooooooo`0Uooooo`03o`000?oooooooooo03Go
oooo00?o0000ooooooooool04_ooool001;ooooo00?o0000ooooooooool0=oooool00ol0003ooooo
ooooo`0Sooooo`03o`000?oooooooooo03Oooooo00?o0000ooooooooool08oooool00ol0003ooooo
ooooo`0gooooo`03o`000?oooooooooo017ooooo000>ooooo`Co0000>oooool4o`0001gooooo1?l0
000kooooo`Co00007Oooool4o`0003_ooooo1?l0000?ooooo`003Oooool5o`0003_ooooo1Ol0000K
ooooo`Go0000>oooool5o`0001_ooooo1Ol0000kooooo`Go00003_ooool000cooooo1ol0000ioooo
o`Oo00006Oooool7o`0003Wooooo1ol0000Iooooo`Oo0000>Oooool7o`0000gooooo000<ooooo`Oo
0000>OoooolWo`0003Wooooo9ol0000iooooo`Oo00003Oooool000cooooo1ol0000iooooo`Oo0000
6Oooool7o`0003Wooooo1ol0000Iooooo`Oo0000>Oooool7o`0000gooooo000=ooooo`Go0000>ooo
ool5o`0001_ooooo1Ol0000kooooo`Go00006oooool5o`0003_ooooo1Ol0000>ooooo`003_ooool4
o`0003_ooooo1?l0000Mooooo`Co0000>oooool4o`0001gooooo1?l0000kooooo`Co00003oooool0
017ooooo00?o0000ooooooooool0>Oooool00ol0003oooooooooo`0Qooooo`03o`000?oooooooooo
03Wooooo00?o0000ooooooooool08Oooool00ol0003oooooooooo`0iooooo`03o`000?oooooooooo
013ooooo000Booooo`03o`000?oooooooooo03Oooooo00?o0000ooooooooool08oooool00ol0003o
ooooooooo`0gooooo`03o`000?oooooooooo02?ooooo00?o0000ooooooooool0=oooool00ol0003o
ooooooooo`0Aooooo`004_ooool00ol0003oooooooooo`0gooooo`03o`000?oooooooooo02?ooooo
00?o0000ooooooooool0=oooool00ol0003oooooooooo`0Sooooo`03o`000?oooooooooo03Oooooo
00?o0000ooooooooool04Oooool001?ooooo00?o0000ooooooooool0=Oooool00ol0003ooooooooo
o`0Uooooo`03o`000?oooooooooo03Gooooo00?o0000ooooooooool09Oooool00ol0003ooooooooo
o`0eooooo`03o`000?oooooooooo01;ooooo000Dooooo`03o`000?oooooooooo03?ooooo00?o0000
ooooooooool09oooool00ol0003oooooooooo`0cooooo`03o`000?oooooooooo02Oooooo00?o0000
ooooooooool0<oooool00ol0003oooooooooo`0Cooooo`005?ooool00ol0003oooooooooo`0coooo
o`03o`000?oooooooooo02Oooooo00?o0000ooooooooool0<oooool00ol0003oooooooooo`0Woooo
o`03o`000?oooooooooo03?ooooo00?o0000ooooooooool04oooool001Gooooo00?o0000oooooooo
ool0<Oooool00ol0003oooooooooo`0Yooooo`03o`000?oooooooooo037ooooo00?o0000oooooooo
ool0:Oooool00ol0003oooooooooo`0aooooo`03o`000?oooooooooo01Cooooo000Eooooo`03o`00
0?oooooooooo037ooooo00?o0000ooooooooool0:Oooool00ol0003oooooooooo`0aooooo`03o`00
0?oooooooooo02Wooooo00?o0000ooooooooool0<Oooool00ol0003oooooooooo`0Dooooo`005_oo
ool00ol0003oooooooooo`0_ooooo`03o`000?oooooooooo02_ooooo00?o0000ooooooooool0;ooo
ool00ol0003oooooooooo`0[ooooo`03o`000?oooooooooo02oooooo00?o0000ooooooooool05Ooo
ool001Oooooo00?o0000ooooooooool0;Oooool00ol0003oooooooooo`0]ooooo`03o`000?oooooo
oooo02gooooo00?o0000ooooooooool0;Oooool00ol0003oooooooooo`0]ooooo`03o`000?oooooo
oooo01Kooooo000Gooooo`03o`000?oooooooooo02gooooo00?o0000ooooooooool0;Oooool00ol0
003oooooooooo`0]ooooo`03o`000?oooooooooo02gooooo00?o0000ooooooooool0;Oooool00ol0
003oooooooooo`0Fooooo`006?ooool00ol0003oooooooooo`0[ooooo`03o`000?oooooooooo02oo
oooo00?o0000ooooooooool0:oooool00ol0003oooooooooo`0_ooooo`03o`000?oooooooooo02_o
oooo00?o0000ooooooooool05oooool001Wooooo00?o0000ooooooooool0:Oooool00ol0003ooooo
ooooo`0aooooo`03o`000?oooooooooo02Wooooo00?o0000ooooooooool0<Oooool00ol0003ooooo
ooooo`0Yooooo`03o`000?oooooooooo01Sooooo000Iooooo`03o`000?oooooooooo02Wooooo00?o
0000ooooooooool0<Oooool00ol0003oooooooooo`0Yooooo`03o`000?oooooooooo037ooooo00?o
0000ooooooooool0:Oooool00ol0003oooooooooo`0Hooooo`006_ooool00ol0003oooooooooo`0W
ooooo`03o`000?oooooooooo03?ooooo00?o0000ooooooooool09oooool00ol0003oooooooooo`0c
ooooo`03o`000?oooooooooo02Oooooo00?o0000ooooooooool06Oooool001[ooooo00?o0000oooo
ooooool09oooool00ol0003oooooooooo`0cooooo`03o`000?oooooooooo02Oooooo00?o0000oooo
ooooool0<oooool00ol0003oooooooooo`0Wooooo`03o`000?oooooooooo01Wooooo000Kooooo`03
o`000?oooooooooo02Gooooo00?o0000ooooooooool0=Oooool00ol0003oooooooooo`0Uooooo`03
o`000?oooooooooo03Gooooo00?o0000ooooooooool09Oooool00ol0003oooooooooo`0Jooooo`00
7?ooool00ol0003oooooooooo`0Sooooo`03o`000?oooooooooo03Oooooo00?o0000ooooooooool0
8oooool00ol0003oooooooooo`0gooooo`03o`000?oooooooooo02?ooooo00?o0000ooooooooool0
6oooool001cooooo00?o0000ooooooooool08oooool00ol0003oooooooooo`0gooooo`03o`000?oo
oooooooo02?ooooo00?o0000ooooooooool0=oooool00ol0003oooooooooo`0Sooooo`03o`000?oo
oooooooo01_ooooo000Mooooo`Co00007Oooool4o`0003_ooooo1?l0000Mooooo`Co0000>oooool4
o`0001gooooo1?l0000Nooooo`007Oooool5o`0001_ooooo1Ol0000kooooo`Go00006oooool5o`00
03_ooooo1Ol0000Kooooo`Go00007_ooool001cooooo1ol0000Iooooo`Oo0000>Oooool7o`0001Wo
oooo1ol0000iooooo`Oo00006Oooool7o`0001gooooo000LooooobOo0000>OoooolWo`0003Wooooo
9ol0000Mooooo`007?ooool7o`0001Wooooo1ol0000iooooo`Oo00006Oooool7o`0003Wooooo1ol0
000Iooooo`Oo00007Oooool001gooooo1Ol0000Kooooo`Go0000>oooool5o`0001_ooooo1Ol0000k
ooooo`Go00006oooool5o`0001kooooo000Nooooo`?o00007Oooool3o`0003gooooo0ol0000Moooo
o`?o0000?Oooool3o`0001gooooo0ol0000Oooooo`00oooooolQooooo`00oooooolQooooo`00oooo
oolQooooo`00oooooolQooooo`00oooooolQooooo`00oooooolQooooo`00oooooolQooooo`00oooo
oolQooooo`00oooooolQooooo`00oooooolQooooo`00oooooolQooooo`00\
\>"],
  ImageRangeCache->{{{0, 287}, {287, 0}} -> {-0.0500045, 0.040904, \
0.00327452, 0.00351603}},
  CellTags->{"b:11", "LocalInteractions:16"}]
}, Open  ]]
}, Closed]]
}, Open  ]]
},
FrontEndVersion->"5.0 for Macintosh",
ScreenRectangle->{{0, 1152}, {0, 701}},
WindowSize->{520, 578},
WindowMargins->{{Automatic, 162}, {21, Automatic}},
StyleDefinitions -> "HelpBrowser.nb"
]

(*******************************************************************
Cached data follows.  If you edit this Notebook file directly, not
using Mathematica, you must remove the line containing CacheID at
the top of  the file.  The cache data will then be recreated when
you save this file from within Mathematica.
*******************************************************************)

(*CellTagsOutline
CellTagsIndex->{
  "b:11"->{
    Cell[1776, 53, 76, 1, 38, "ObjectName",
      CellTags->{"b:11", "LocalInteractions:16"}],
    Cell[1855, 56, 223, 6, 32, "Usage",
      CellTags->{"b:11", "LocalInteractions:16"}],
    Cell[2081, 64, 284, 9, 40, "Notes",
      CellTags->{"b:11", "LocalInteractions:16"}],
    Cell[2390, 77, 80, 1, 38, "ExampleSection",
      CellTags->{"b:11", "LocalInteractions:16"}],
    Cell[2473, 80, 113, 1, 22, "Text",
      CellTags->{"b:11", "LocalInteractions:16"}],
    Cell[2611, 85, 136, 3, 26, "Input",
      CellTags->{"b:11", "LocalInteractions:16"}],
    Cell[2750, 90, 43253, 869, 294, 5096, 392, "GraphicsData", 
    "PostScript", "Graphics",
      CellTags->{"b:11", "LocalInteractions:16"}],
    Cell[46018, 962, 111, 1, 22, "Text",
      CellTags->{"b:11", "LocalInteractions:16"}],
    Cell[46154, 967, 228, 5, 58, "Input",
      CellTags->{"b:11", "LocalInteractions:16"}],
    Cell[46385, 974, 44239, 864, 294, 4662, 370, "GraphicsData", 
    "PostScript", "Graphics",
      CellTags->{"b:11", "LocalInteractions:16"}]},
  "LocalInteractions:16"->{
    Cell[1776, 53, 76, 1, 38, "ObjectName",
      CellTags->{"b:11", "LocalInteractions:16"}],
    Cell[1855, 56, 223, 6, 32, "Usage",
      CellTags->{"b:11", "LocalInteractions:16"}],
    Cell[2081, 64, 284, 9, 40, "Notes",
      CellTags->{"b:11", "LocalInteractions:16"}],
    Cell[2390, 77, 80, 1, 38, "ExampleSection",
      CellTags->{"b:11", "LocalInteractions:16"}],
    Cell[2473, 80, 113, 1, 22, "Text",
      CellTags->{"b:11", "LocalInteractions:16"}],
    Cell[2611, 85, 136, 3, 26, "Input",
      CellTags->{"b:11", "LocalInteractions:16"}],
    Cell[2750, 90, 43253, 869, 294, 5096, 392, "GraphicsData", 
    "PostScript", "Graphics",
      CellTags->{"b:11", "LocalInteractions:16"}],
    Cell[46018, 962, 111, 1, 22, "Text",
      CellTags->{"b:11", "LocalInteractions:16"}],
    Cell[46154, 967, 228, 5, 58, "Input",
      CellTags->{"b:11", "LocalInteractions:16"}],
    Cell[46385, 974, 44239, 864, 294, 4662, 370, "GraphicsData", 
    "PostScript", "Graphics",
      CellTags->{"b:11", "LocalInteractions:16"}]}
  }
*)

(*CellTagsIndex
CellTagsIndex->{
  {"b:11", 91285, 1859},
  {"LocalInteractions:16", 92348, 1882}
  }
*)

(*NotebookFileOutline
Notebook[{

Cell[CellGroupData[{
Cell[1776, 53, 76, 1, 38, "ObjectName",
  CellTags->{"b:11", "LocalInteractions:16"}],
Cell[1855, 56, 223, 6, 32, "Usage",
  CellTags->{"b:11", "LocalInteractions:16"}],
Cell[2081, 64, 284, 9, 40, "Notes",
  CellTags->{"b:11", "LocalInteractions:16"}],

Cell[CellGroupData[{
Cell[2390, 77, 80, 1, 38, "ExampleSection",
  CellTags->{"b:11", "LocalInteractions:16"}],
Cell[2473, 80, 113, 1, 22, "Text",
  CellTags->{"b:11", "LocalInteractions:16"}],

Cell[CellGroupData[{
Cell[2611, 85, 136, 3, 26, "Input",
  CellTags->{"b:11", "LocalInteractions:16"}],
Cell[2750, 90, 43253, 869, 294, 5096, 392, "GraphicsData", "PostScript", \
"Graphics",
  CellTags->{"b:11", "LocalInteractions:16"}]
}, Open  ]],
Cell[46018, 962, 111, 1, 22, "Text",
  CellTags->{"b:11", "LocalInteractions:16"}],

Cell[CellGroupData[{
Cell[46154, 967, 228, 5, 58, "Input",
  CellTags->{"b:11", "LocalInteractions:16"}],
Cell[46385, 974, 44239, 864, 294, 4662, 370, "GraphicsData", "PostScript", \
"Graphics",
  CellTags->{"b:11", "LocalInteractions:16"}]
}, Open  ]]
}, Closed]]
}, Open  ]]
}
]
*)



(*******************************************************************
End of Mathematica Notebook file.
*******************************************************************)

